#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (DSQL_yychar=(-1))
#define yyerrok (DSQL_yyerrflag=0)
#define YYRECOVERING (DSQL_yyerrflag!=0)
#define YYPREFIX "yy"
/* 
 *	PROGRAM:	Dynamic SQL runtime support
 *	MODULE:		parse.y
 *	DESCRIPTION:	Dynamic SQL parser
 *
 * The contents of this file are subject to the Interbase Public
 * License Version 1.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy
 * of the License at http://www.Inprise.com/IPL.html
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code was created by Inprise Corporation
 * and its predecessors. Portions created by Inprise Corporation are
 * Copyright (C) Inprise Corporation.
 *
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 * 2001.05.20 Neil McCalden: Allow a udf to be used in a 'group by' clause.
 * 2001.05.30 Claudio Valderrama: DROP TABLE and DROP VIEW lead now to two
 *   different node types so DDL can tell which is which.
 * 2001.06.13 Claudio Valderrama: SUBSTRING is being surfaced.
 * 2001.06.30 Claudio valderrama: Feed (line,column) for each node. See node.h.
 * 2001.07.10 Claudio Valderrama: Better (line,column) report and "--" for comments.
 * 2001.07.28 John Bellardo: Changes to support parsing LIMIT and FIRST
 * 2001.08.03 John Bellardo: Finalized syntax for LIMIT, change LIMIT to SKIP
 * 2001.08.05 Claudio Valderrama: closed Bug #448062 and other spaces that appear
 *   in rdb$*_source fields when altering domains plus one unexpected null pointer.
 * 2001.08.12 Claudio Valderrama: adjust SUBSTRING's starting pos argument here
 *   and not in gen.c; this closes Bug #450301.
 * 2001.10.01 Claudio Valderrama: enable explicit GRANT...to ROLE role_name.
 * 2001.10.06 Claudio Valderrama: Honor explicit USER keyword in GRANTs and REVOKEs.
 */

#if defined(DEV_BUILD) && defined(WIN32) && defined(SUPERSERVER)
#include <windows.h>
/*#include <wincon.h>*/
#endif


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../jrd/common.h"
#include <stdarg.h>

#include "../jrd/iberror.h"
#include "../dsql/dsql.h"
#include "../dsql/node.h"
#include "../dsql/sym.h"
#include "../jrd/gds.h"
#include "../jrd/flags.h"
#include "../dsql/alld_proto.h"
#include "../dsql/errd_proto.h"
#include "../dsql/hsh_proto.h"
#include "../dsql/make_proto.h"
#include "../dsql/parse_proto.h"
#include "../jrd/gds_proto.h"
#include "../jrd/thd_proto.h"
#ifndef WINDOWS_ONLY
#include "../wal/wal.h"
#endif

/* Can't include ../jrd/err_proto.h here because it pulls jrd.h. */
#if !defined(_JRD_ERR_PROTO_H_)
extern TEXT * DLL_EXPORT ERR_string (TEXT *, int);
#endif


ASSERT_FILENAME

/* Remove compiler warning produced by redef of WRITE & READ from WINDOWS.H */
#ifdef WINDOWS_ONLY
#undef READ
#undef WRITE
#endif

/* since UNIX isn't standard, we have to define
   stuff which is in <limits.h> (which isn't available
   on all UNIXes... */

#define SHRT_POS_MAX		32767
#define SHRT_UNSIGNED_MAX	65535
#define SHRT_NEG_MAX		32768
#define LONG_POS_MAX		2147483647
#define POSITIVE		0
#define NEGATIVE		1
#define UNSIGNED		2

#define MIN_CACHE_BUFFERS       250
#define DEF_CACHE_BUFFERS       1000

/* Fix 69th procedure problem - solution from Oleg Loa */
#define YYSTACKSIZE		2048
#define YYMAXDEPTH		2048

#define YYSTYPE		NOD
#if defined(DEBUG) || defined(DEV_BUILD)
#define YYDEBUG		1
#endif

static CONST UCHAR
	INTERNAL_FIELD_NAME [] = "DSQL internal"; /* NTX: placeholder */
static CONST UCHAR
	NULL_STRING [] = "";	

#ifndef SHLIB_DEFS
NOD		DSQL_parse;
#else
extern NOD	DSQL_parse;
#endif

static FLD	g_field;
static FIL	g_file;
static NOD	g_field_name;
static TEXT	*beginning;
static SSHORT	log_defined, cache_defined;
static void	yyerror (TEXT *);

#define ACTIVE 257
#define ADD 258
#define AFTER 259
#define ALL 260
#define ALTER 261
#define AND 262
#define ANY 263
#define AS 264
#define ASC 265
#define AT 266
#define AVG 267
#define AUTO 268
#define BASENAME 269
#define BEFORE 270
#define BEGIN 271
#define BETWEEN 272
#define BLOB 273
#define BY 274
#define CACHE 275
#define CAST 276
#define CHARACTER 277
#define CHECK 278
#define CHECK_POINT_LEN 279
#define COLLATE 280
#define COLLATION 281
#define COMMA 282
#define COMMIT 283
#define COMMITTED 284
#define COMPUTED 285
#define CONCATENATE 286
#define CONDITIONAL 287
#define CONSTRAINT 288
#define CONTAINING 289
#define COUNT 290
#define CREATE 291
#define CSTRING 292
#define CURRENT 293
#define CURSOR 294
#define DATABASE 295
#define DATE 296
#define DB_KEY 297
#define DEBUG 298
#define DECIMAL 299
#define DECLARE 300
#define DEFAULT 301
#define DELETE 302
#define DESC 303
#define DISTINCT 304
#define DO 305
#define DOMAIN 306
#define DROP 307
#define ELSE 308
#define END 309
#define ENTRY_POINT 310
#define EQL 311
#define ESCAPE 312
#define EXCEPTION 313
#define EXECUTE 314
#define EXISTS 315
#define EXIT 316
#define EXTERNAL 317
#define FILTER 318
#define FOR 319
#define FOREIGN 320
#define FROM 321
#define FULL 322
#define FUNCTION 323
#define GDSCODE 324
#define GEQ 325
#define GENERATOR 326
#define GEN_ID 327
#define GRANT 328
#define GROUP 329
#define GROUP_COMMIT_WAIT 330
#define GTR 331
#define HAVING 332
#define IF 333
#define IN 334
#define INACTIVE 335
#define INNER 336
#define INPUT_TYPE 337
#define INDEX 338
#define INSERT 339
#define INTEGER 340
#define INTO 341
#define IS 342
#define ISOLATION 343
#define JOIN 344
#define KEY 345
#define KW_CHAR 346
#define KW_DEC 347
#define KW_DOUBLE 348
#define KW_FILE 349
#define KW_FLOAT 350
#define KW_INT 351
#define KW_LONG 352
#define KW_NULL 353
#define KW_NUMERIC 354
#define KW_UPPER 355
#define KW_VALUE 356
#define LENGTH 357
#define LOGFILE 358
#define LPAREN 359
#define LEFT 360
#define LEQ 361
#define LEVEL 362
#define LIKE 363
#define LOG_BUF_SIZE 364
#define LSS 365
#define MANUAL 366
#define MAXIMUM 367
#define MAX_SEGMENT 368
#define MERGE 369
#define MESSAGE 370
#define MINIMUM 371
#define MODULE_NAME 372
#define NAMES 373
#define NATIONAL 374
#define NATURAL 375
#define NCHAR 376
#define NEQ 377
#define NO 378
#define NOT 379
#define NOT_GTR 380
#define NOT_LSS 381
#define NUM_LOG_BUFS 382
#define OF 383
#define ON 384
#define ONLY 385
#define OPTION 386
#define OR 387
#define ORDER 388
#define OUTER 389
#define OUTPUT_TYPE 390
#define OVERFLOW 391
#define PAGE 392
#define PAGES 393
#define PAGE_SIZE 394
#define PARAMETER 395
#define PASSWORD 396
#define PLAN 397
#define POSITION 398
#define POST_EVENT 399
#define PRECISION 400
#define PRIMARY 401
#define PRIVILEGES 402
#define PROCEDURE 403
#define PROTECTED 404
#define RAW_PARTITIONS 405
#define READ 406
#define REAL 407
#define REFERENCES 408
#define RESERVING 409
#define RETAIN 410
#define RETURNING_VALUES 411
#define RETURNS 412
#define REVOKE 413
#define RIGHT 414
#define RPAREN 415
#define ROLLBACK 416
#define SEGMENT 417
#define SELECT 418
#define SET 419
#define SHADOW 420
#define SHARED 421
#define SINGULAR 422
#define SIZE 423
#define SMALLINT 424
#define SNAPSHOT 425
#define SOME 426
#define SORT 427
#define SQLCODE 428
#define STABILITY 429
#define STARTING 430
#define STATISTICS 431
#define SUB_TYPE 432
#define SUSPEND 433
#define SUM 434
#define TABLE 435
#define THEN 436
#define TO 437
#define TRANSACTION 438
#define TRIGGER 439
#define UNCOMMITTED 440
#define UNION 441
#define UNIQUE 442
#define UPDATE 443
#define USER 444
#define VALUES 445
#define VARCHAR 446
#define VARIABLE 447
#define VARYING 448
#define VERSION 449
#define VIEW 450
#define WAIT 451
#define WHEN 452
#define WHERE 453
#define WHILE 454
#define WITH 455
#define WORK 456
#define WRITE 457
#define FLOAT 458
#define NUMBER 459
#define NUMERIC 460
#define SYMBOL 461
#define STRING 462
#define INTRODUCER 463
#define ACTION 464
#define ADMIN 465
#define CASCADE 466
#define FREE_IT 467
#define RESTRICT 468
#define ROLE 469
#define COLUMN 470
#define TYPE 471
#define EXTRACT 472
#define YEAR 473
#define MONTH 474
#define DAY 475
#define HOUR 476
#define MINUTE 477
#define SECOND 478
#define WEEKDAY 479
#define YEARDAY 480
#define TIME 481
#define TIMESTAMP 482
#define CURRENT_DATE 483
#define CURRENT_TIME 484
#define CURRENT_TIMESTAMP 485
#define CURRENT_USER 486
#define CURRENT_ROLE 487
#define KW_BREAK 488
#define SUBSTRING 489
#define RECREATE 490
#define KW_DESCRIPTOR 491
#define FIRST 492
#define SKIP 493
#define NUMBER64BIT 494
#define SCALEDINT 495
#define YYERRCODE 256
static short yylhs[] = {                                        -1,
    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    9,
    9,    9,    9,    9,   20,   20,   19,   19,   19,   30,
   30,   23,   31,   31,   31,   31,   31,   22,   22,   28,
   28,   24,   13,   13,   13,   13,   13,   13,   13,   34,
   25,   25,   25,   25,   35,   35,   35,   35,   21,   21,
   36,   36,   36,   26,   26,   41,   27,   27,   42,   42,
    6,   43,   43,   45,   50,   50,   50,   47,   47,   47,
   54,   54,   55,   55,   48,   48,   57,   57,   57,   57,
   57,   44,    5,   60,   60,   60,   60,   60,   60,   60,
   60,   60,   60,   60,   12,   75,   75,   62,   62,   65,
   65,   65,   73,   84,   84,   84,   85,   85,   86,   86,
   87,   87,   91,   91,   72,   94,   94,   96,   96,   97,
   97,  100,  100,  101,  102,  102,  103,  104,   70,   74,
   71,   88,   88,  107,  108,  108,  110,  110,  111,  111,
  111,  111,  111,  109,  109,  112,  112,  113,  113,  113,
  113,  115,  115,  115,  115,  114,  114,  119,  119,  118,
   92,  120,  120,  121,  124,  125,  125,  126,  122,  123,
  123,  127,  127,  128,  128,  129,  129,  129,   90,   90,
   90,   67,   77,  130,  130,  130,  131,  131,  132,  132,
  133,  133,  133,  139,   80,   80,  135,  135,   98,   98,
   93,  143,  144,   56,  136,  136,   99,   99,   99,   99,
   99,  137,  137,  150,  150,  151,  153,  153,  153,  153,
  153,  134,  152,  152,  156,  156,  156,  156,  158,  159,
  160,  155,  154,  154,  154,  154,  154,  161,  162,  163,
  163,  163,  163,   66,   76,  168,  164,  164,  165,  165,
  169,  169,  170,  166,  166,  171,  171,  172,  173,  173,
  167,  167,  175,  175,  174,  174,  174,  174,  174,  174,
  174,  174,  174,  174,  174,  174,  174,  174,  178,  179,
  180,  180,  181,  187,  183,  183,  183,  184,  184,  184,
  189,  189,  189,  189,  189,  189,  189,  189,  185,  185,
  185,  185,  182,  186,  186,  176,  176,  192,  193,  193,
  194,  194,  194,  194,   11,  196,  196,  196,  197,  197,
  197,  197,  197,  197,   69,  199,  202,  202,  202,  203,
  207,  212,  212,  213,  213,  214,  214,  141,  201,   81,
   83,  200,  200,   68,  217,  217,  217,  218,  218,  218,
  218,  218,  218,  219,  219,  220,    2,  222,  222,  222,
  222,  222,  222,  222,  230,  231,  228,  228,  232,  232,
  232,  232,  232,  232,  232,  223,  223,  233,  233,  233,
  233,  233,  233,  233,  227,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  235,  235,  237,
  237,  236,  234,  234,  234,  229,  229,  225,  226,  226,
  239,  239,  239,  239,  240,  240,  224,  241,  241,  242,
  242,    8,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,   95,   95,  138,  138,  246,  246,
  249,  249,  251,  251,   51,   51,  248,  248,  248,  248,
  248,  248,  248,  248,  256,  256,  247,  247,  247,  247,
  257,  257,   59,   59,   59,   53,   53,  253,  253,  253,
  250,  250,  250,  261,  261,  261,  260,  260,  259,  259,
  259,  254,  254,  264,  262,  262,  262,  263,  263,  255,
  255,  255,  255,  265,  265,   16,   16,   16,  267,  267,
  267,    4,   14,  269,  269,  270,  270,  271,  271,  266,
  272,  272,  273,  273,  274,  274,  274,  274,  275,  275,
  276,  276,  277,  277,  279,  279,  279,  280,  280,  280,
  281,  281,  281,  278,  283,  283,  283,  284,  284,  282,
  282,  285,  287,  287,  286,  286,  268,   15,  288,  288,
  288,  289,  289,  292,  292,  293,  293,   63,   63,   63,
  290,  290,  294,  294,  291,  205,  205,  206,  206,  297,
  297,  298,  298,  298,  295,  301,  301,  302,  302,  303,
  303,  304,  304,  305,  305,  307,  307,  308,  308,  215,
  215,   29,  216,  216,  216,  216,  216,  216,  216,  216,
  309,  309,  309,  310,  310,  310,  204,  204,  204,  204,
  209,  209,  311,  311,  312,  312,  312,  210,  210,  208,
  208,  211,  211,  314,  315,  315,  315,  315,  315,  316,
  316,  317,  317,  318,  318,  319,  319,  319,  320,  320,
   10,   10,  322,  322,    7,    7,  323,  324,  325,   17,
   17,  326,  327,  328,  328,  177,  299,  299,    3,    3,
  330,  330,  330,  332,  332,   59,  331,  331,  333,  333,
   32,   32,   79,   78,   78,  321,  321,  334,  335,  335,
  190,  190,  190,  140,  329,  329,  105,  105,  105,  105,
  337,  337,  337,  337,  337,  337,  337,  337,  337,  337,
  337,  338,  338,  338,  338,  338,  338,  338,  338,  343,
  343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
  343,  343,  343,  343,  343,  349,  349,  339,  339,  340,
  340,  340,  340,  341,  341,  345,  345,  346,  346,  346,
  346,  344,  347,  342,  342,  350,  350,  348,  352,   82,
   82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
   82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
   82,   82,  149,  149,  149,  353,  356,  356,  145,  145,
  357,  357,  357,  357,  357,  355,  355,  355,  355,  355,
  351,  351,  351,  351,  351,  351,  351,  351,  198,  146,
  146,  147,   49,   49,   18,   18,  221,  358,   52,  117,
  252,  252,   89,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  313,  313,  359,  359,  359,  359,  359,  359,  359,  359,
  296,  296,  148,   46,  258,  116,  142,  336,  157,  191,
  245,   61,   58,  195,  106,   64,  300,   33,   39,  306,
  244,   37,   40,  188,   38,
};
static short yylen[] = {                                         2,
    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    7,
    8,    6,    7,    5,    1,    2,    1,    2,    1,    1,
    3,    1,    1,    1,    1,    2,    2,    3,    0,    3,
    0,    1,    7,    8,    6,    7,    6,    7,    4,    3,
    1,    3,    3,    3,    2,    2,    2,    2,    1,    3,
    1,    2,    2,    1,    3,    1,    1,    3,    1,    2,
    2,    2,    3,    8,    1,    1,    5,    0,    1,    3,
    1,    3,    2,    4,    1,    3,    2,    3,    4,    4,
    2,    9,    2,    3,    7,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    1,    0,    1,
    1,    6,    6,    1,    1,    0,    0,    1,    0,    4,
    0,    1,    1,    2,    8,    1,    0,    3,    0,    0,
    1,    1,    2,    1,    1,    1,    2,    6,    1,    1,
    3,    0,    1,    1,    0,    1,    1,    2,    3,    4,
    2,    2,    3,    0,    1,    1,    2,    1,    1,    1,
    4,    3,    3,    3,    3,    1,    1,    6,    3,    1,
    3,    1,    3,    2,    1,    0,    2,    3,    1,    0,
    1,    1,    2,    3,    4,    0,    1,    2,    0,    1,
    1,    5,    5,    3,    2,    0,    1,    3,    1,    1,
    6,    3,    2,    6,    2,    1,    2,    2,    2,    0,
    1,    1,    2,    0,    2,    0,    1,    1,    1,    1,
    1,    0,    1,    1,    2,    2,    2,    4,    1,    1,
    2,    2,    2,    0,    1,    1,    1,    1,    2,    3,
    7,    6,    1,    1,    2,    2,    0,    3,    3,    1,
    2,    2,    2,    8,    8,    8,    3,    0,    2,    0,
    1,    3,    2,    1,    0,    1,    2,    5,    1,    1,
    3,    4,    1,    2,    2,    2,    3,    1,    1,    1,
    2,    3,    1,    2,    1,    2,    2,    2,    6,    7,
    8,    6,    4,    2,    1,    3,    0,    2,    4,    0,
    1,    1,    1,    1,    3,    3,    3,    3,    1,    1,
    3,    3,    6,    3,    0,    1,    2,    4,    1,    3,
    2,    2,    2,    1,    4,    1,    3,    0,    1,    1,
    1,    3,    3,    3,    7,    1,    1,    3,    4,    9,
    2,    1,    3,    1,    1,    6,    3,    0,    0,    0,
    0,    3,    0,    9,    1,    1,    0,    2,    2,    2,
    2,    2,    2,    2,    0,    4,    2,    3,    3,    2,
    2,    3,    3,    2,    3,    6,    1,    2,    4,    3,
    2,    2,    2,    2,    3,    1,    3,    3,    3,    2,
    2,    4,    4,    5,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
    2,    1,    1,    1,    0,    2,    2,    0,    1,    2,
    2,    2,    2,    2,    1,    3,    7,    1,    0,    1,
    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    3,    2,    2,    2,    1,    1,    1,    1,    4,    5,
    1,    3,    1,    3,    1,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    4,    4,    6,    5,
    3,    0,    2,    2,    0,    3,    0,    4,    1,    5,
    4,    1,    4,    1,    2,    2,    1,    1,    1,    2,
    2,    2,    2,    1,    0,    3,    5,    1,    1,    2,
    3,    1,    2,    3,    0,    1,    1,    1,    5,    5,
    6,    3,    2,    1,    0,    2,    0,    1,    0,    3,
    1,    0,    1,    2,    1,    1,    1,    1,    2,    2,
    1,    2,    3,    1,    1,    3,    3,    1,    2,    3,
    1,    2,    0,    2,    1,    1,    0,    1,    1,    1,
    3,    2,    3,    0,    1,    3,    4,    3,    1,    3,
    4,    3,    0,    1,    3,    3,    3,    1,    1,    0,
    3,    0,    2,    0,    9,    1,    1,    1,    1,    1,
    3,    1,    2,    3,    2,    1,    3,    1,    1,    6,
    3,    3,    2,    3,    0,    1,    3,    1,    1,    1,
    2,    1,    1,    1,    2,    1,    2,    1,    2,    0,
    2,    4,    2,    2,    4,    2,    2,    1,    1,    0,
    3,    0,    1,    3,    1,    1,    3,    2,    0,    2,
    0,    2,    0,    4,    1,    2,    1,    1,    0,    1,
    3,    2,    1,    1,    2,    1,    4,    2,    1,    3,
    8,    5,    1,    3,    1,    1,    4,    4,    4,    1,
    1,    5,    5,    1,    3,    3,    1,    1,    7,    7,
    5,    3,    0,    1,    1,    1,    2,    0,    1,    1,
    1,    0,    3,    1,    3,    1,    0,    3,    1,    3,
    1,    3,    3,    1,    1,    3,    1,    3,    3,    2,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    1,    1,    5,    6,    3,
    4,    5,    6,    3,    4,    3,    4,    3,    4,    4,
    5,    4,    4,    3,    4,    3,    3,    9,    9,    1,
    1,    1,    1,    1,    1,    1,    2,    2,    3,    3,
    3,    3,    3,    3,    3,    3,    1,    1,    1,    3,
    1,    1,    1,    1,    1,    4,    1,    3,    1,    2,
    1,    1,    1,    1,    1,    1,    1,    2,    2,    2,
    1,    1,    1,    1,    3,    3,    3,    3,    1,    1,
    1,    1,    1,    2,    1,    2,    1,    1,    1,    1,
    1,    2,    1,    4,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    6,    4,    6,    6,    6,    8,
    4,    3,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,
};
static short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
   14,   15,   16,   17,   18,  516,  517,  518,    0,  569,
  665,  666,  670,  671,  428,    0,    0,    0,    0,    0,
    0,  367,  524,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  108,    0,    0,   93,    0,  827,    0,   19,
  825,    0,    0,   71,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  442,    0,    0,
   35,   32,   34,    0,   33,    0,  879,    0,    0,    0,
    0,   30,   66,   64,    0,    0,    0,    0,    0,    0,
    0,    0,  523,    0,    0,    0,    0,  629,    0,    0,
    0,  881,  610,    0,    0,    0,    0,  105,    2,    0,
    0,    0,    0,  414,  396,  397,  398,  399,  400,  401,
  402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
  412,  413,  415,  416,  417,    0,  395,  872,    0,  876,
    0,  374,  878,    0,  371,    0,  612,  882,    0,  370,
    0,  522,  823,    0,  144,  101,    0,  868,  102,    0,
  211,  704,    0,  875,  100,  139,    0,   96,    0,  103,
  829,    0,   97,    0,   98,  885,    0,   99,  140,  104,
  578,  579,    0,  828,  826,    0,  873,   72,    0,    0,
  871,  450,  443,    0,  449,  454,  444,  445,  452,  446,
  447,  448,  453,    0,   28,    0,   37,  691,   36,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  833,    0,  819,  621,  623,    0,  624,
  626,  861,  586,    0,  587,  627,    0,    0,    0,    0,
    0,    0,    0,  541,  530,    0,  533,  535,  536,  537,
  538,  544,  545,    0,  880,  611,    0,  106,    0,  107,
    0,    0,  570,    0,  568,    0,    0,    0,    0,  429,
    0,    0,  350,    0,  214,    0,  377,  368,  426,  427,
    0,    0,    0,    0,    0,    0,  386,    0,  355,  356,
    0,  528,  526,  824,    0,    0,    0,    0,    0,    0,
    0,  147,  126,    0,   94,    0,  115,  114,    0,    0,
    0,    0,    0,    0,  864,   73,    0,    0,    0,  667,
  668,  451,    0,  863,  803,  802,  801,    0,    0,  804,
  805,    0,    0,  807,  330,  331,  325,    0,  329,  799,
  806,    0,  694,    0,    0,   25,    0,    0,  883,    0,
   69,   67,   65,   31,    0,    0,    0,  696,    0,   50,
    0,    0,    0,    0,    0,    0,    0,    0,  789,    0,
    0,  791,    0,    0,    0,  820,    0,    0,  793,  794,
  795,  821,  822,    0,    0,    0,    0,    0,    0,    0,
  701,  787,  788,  792,  775,    0,  774,    0,  776,  771,
  772,  773,    0,  589,    0,  678,    0,    0,  590,    0,
    0,  567,    0,  542,    0,  539,    0,  540,  565,    0,
  560,    0,    0,  534,    0,  705,  674,    0,    0,    0,
    0,    0,  504,    0,    0,    0,  574,    0,  571,    0,
  179,    0,    0,  123,  434,  166,  167,    0,  432,    0,
    0,    0,    0,  435,    0,  430,    0,    0,  381,  383,
  382,    0,  384,    0,  378,  212,    0,    0,  261,    0,
    0,    0,    0,  390,  391,    0,  419,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  438,    0,  143,    0,
    0,  152,    0,  151,    0,  158,  141,    0,  156,  159,
  160,  148,    0,    0,  472,  508,  475,    0,  509,    0,
    0,  476,    0,    0,    0,  499,  512,  471,  494,  473,
  474,  457,  350,  455,  456,  458,    0,    0,  467,  468,
  469,  470,    0,    0,    0,    0,    0,  118,    0,    0,
  195,    0,    0,  348,    0,  214,    0,    0,   81,    0,
    0,  686,    0,    0,    0,    0,    0,    0,    0,    0,
  707,  711,  712,  713,  714,  715,  716,  717,  718,  719,
  720,  808,  809,  810,  800,    0,    0,    0,  693,   26,
    0,    0,   42,   70,    0,    0,   24,    0,  699,    0,
    0,  662,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  884,  294,    0,    0,    0,    0,    0,    0,
    0,  622,    0,    0,  625,    0,    0,    0,    0,  877,
  593,  520,    0,  831,  519,    0,  543,    0,  551,  547,
  546,    0,    0,    0,  562,  550,    0,    0,  672,  673,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  581,
    0,    0,  124,    0,    0,    0,    0,    0,    0,  350,
  380,    0,  350,  351,  385,  465,    0,  263,    0,  257,
  259,  348,  869,  233,    0,    0,  350,    0,    0,  203,
  348,    0,    0,    0,    0,  238,  232,  235,  236,  237,
  389,  424,  423,  388,  387,    0,    0,    0,  363,  359,
  361,  362,  358,  360,    0,  350,    0,  149,  153,    0,
  157,    0,    0,  495,  496,  513,    0,  510,    0,    0,
  502,  500,  501,    0,    0,    0,    0,  466,    0,    0,
    0,    0,  503,  348,    0,  194,    0,  197,  199,  200,
    0,    0,    0,    0,    0,  214,   76,    0,    0,   75,
  865,  483,  484,    0,    0,    0,  710,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  327,  333,  334,
  332,  695,    0,    0,    0,    0,    0,    0,    0,    0,
   51,   59,   61,    0,    0,   68,    0,    0,    0,  698,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  853,  854,  855,  856,  857,  858,  859,  860,    0,
    0,    0,  785,  786,  852,    0,    0,  867,  781,    0,
    0,    0,    0,    0,    0,  790,  703,  702,    0,    0,
    0,    0,  598,  599,    0,    0,  591,  594,  521,  832,
  552,  561,  556,  555,    0,  566,  706,  675,  676,  348,
    0,  209,  576,  577,  575,    0,  175,  169,  176,    0,
  172,    0,    0,  171,    0,  182,  163,  162,  830,  165,
  164,  436,    0,    0,    0,  379,  262,    0,  205,  350,
  207,    0,  351,  202,  208,    0,    0,  239,    0,  392,
  393,  350,  348,  351,  364,    0,  190,  191,  150,    0,
    0,    0,    0,    0,    0,  511,    0,    0,  350,  351,
    0,  461,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  192,    0,    0,    0,    0,  337,    0,
   80,    0,    0,    0,    0,   85,   82,    0,    0,    0,
  870,  669,    0,    0,  721,    0,    0,    0,  747,  746,
    0,    0,    0,  754,  764,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  709,    0,   63,   55,   56,
   62,   57,   58,    0,    0,   20,    0,    0,    0,   40,
    0,    0,    0,  680,  700,  663,    0,  679,    0,    0,
    0,    0,    0,    0,  214,    0,  834,    0,    0,  846,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  851,  796,    0,    0,    0,    0,    0,    0,  613,    0,
    0,    0,    0,    0,  558,  559,  563,    0,  193,    0,
    0,    0,    0,    0,    0,  183,    0,    0,  375,  217,
  218,  219,  220,  221,    0,    0,    0,  266,    0,  215,
    0,    0,  240,    0,  420,  421,  394,  350,  440,  351,
  866,  161,    0,    0,  478,    0,  477,  514,    0,  506,
    0,    0,    0,  459,    0,  486,    0,    0,  488,  491,
  493,    0,    0,  113,    0,  198,  350,    0,    0,  349,
    0,   95,    0,  111,    0,   91,    0,    0,    0,    0,
   84,    0,  762,  763,    0,    0,    0,    0,  811,  813,
  814,  812,    0,    0,  765,    0,    0,    0,    0,    0,
    0,    0,  755,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   54,   60,
   52,   53,   21,  684,  685,    0,  682,  689,  690,  687,
    0,  661,    0,    0,  840,  839,    0,    0,  836,  835,
    0,  844,  843,  842,  841,  838,  837,    0,    0,    0,
    0,  601,    0,  608,    0,  606,  602,    0,  619,  615,
  617,    0,    0,    0,    0,    0,    0,  177,  173,    0,
    0,  188,  184,    0,  351,    0,    0,  351,  267,    0,
    0,    0,  224,    0,    0,    0,    0,  437,  480,    0,
  481,    0,  128,    0,    0,    0,  132,  134,  135,  136,
  462,  464,  460,  490,  351,    0,    0,    0,    0,  335,
    0,  338,  350,   86,    0,    0,   88,    0,    0,    0,
    0,    0,    0,  767,    0,  766,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   38,    0,  664,  213,  845,  847,
  848,    0,  849,    0,    0,  604,    0,    0,    0,  633,
  636,    0,    0,  585,  351,    0,  168,  185,  351,  138,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  270,  273,  269,    0,    0,
  278,  279,  280,  283,  285,  256,    0,  201,  225,    0,
    0,    0,  230,  226,  229,    0,  351,    0,  479,  507,
  137,  125,  133,  254,  120,  351,    0,  352,  339,    0,
    0,   89,   90,   77,    0,  733,  741,    0,  815,  817,
  818,  816,  734,  742,  737,  745,    0,    0,  735,  743,
  736,  744,  730,  738,  731,  739,  732,  740,  681,    0,
    0,  607,    0,    0,    0,  645,  647,    0,  642,    0,
  255,  178,  376,    0,    0,    0,  287,    0,    0,    0,
  286,    0,  288,  276,  281,    0,  284,  271,    0,  274,
    0,  316,  275,  204,  227,  231,    0,    0,  242,  366,
  354,    0,    0,    0,   74,   92,    0,  850,    0,    0,
  637,  634,  646,    0,  268,  277,    0,    0,    0,  282,
    0,    0,  309,  310,  324,    0,    0,    0,    0,  319,
  272,  317,    0,    0,  241,    0,    0,    0,    0,    0,
  344,  345,    0,    0,    0,    0,    0,  653,    0,    0,
    0,    0,  302,  304,    0,  301,    0,  303,    0,    0,
    0,  293,    0,  323,  874,  322,  321,    0,    0,  228,
    0,    0,    0,  246,    0,  245,    0,    0,    0,    0,
    0,  112,    0,  769,  655,  644,    0,    0,  656,    0,
  652,    0,    0,    0,    0,    0,    0,    0,    0,  312,
  311,  318,  320,    0,    0,  250,  249,  248,  347,    0,
    0,    0,    0,  651,    0,  658,  296,    0,    0,  289,
  306,  308,  305,  307,    0,    0,    0,  313,  253,  251,
  252,    0,  340,    0,    0,    0,    0,  314,  290,    0,
    0,  768,    0,  657,  299,  291,    0,  660,
};
static short yydgoto[] = {                                      18,
   19,   20,   21,   22,   23,   24, 1372,   26,   27, 1373,
   29,   30,   31,   32, 1374,   34, 1375,  572,   98,  365,
  819, 1046,   99,  602,  820,  100,  370,  607,  123,  101,
  102,  227,  880,  112,  821,  822,  169,  197,  103,  823,
  104,  372,   74,  208,  336,  409,  567,  984,  354,  779,
  542,  453,  758,  568,  569,  570,  986,  209, 1214,   66,
  159,   67,  203, 1615, 1162,  188,  193,  195,  198,  185,
  176,  179,  190,  200,  128,  278,  280,  362,  228,  706,
  478,  579,  926,  329,  559,  972, 1154,  510,  654,  949,
  463,  464,  493,  324,  543,  960, 1285,  675, 1109, 1286,
 1287, 1288, 1289, 1290,  580,  186,  177,  320,  517,  321,
  322,  518,  519,  520,  521, 1132,  920,  466,  467,  910,
  908,  468,  914,  909, 1100, 1258,  915,  916, 1105,  331,
  767,  768,  769,  770,  708,  933, 1271,  544,  710,  411,
  772,  869,  487, 1228, 1110,  412,  413,  426,  414, 1272,
 1273,  496, 1394, 1515,  716,  717,  704,  718,  719,  720,
 1516, 1517, 1587,  302,  491, 1116, 1376,  165,  488,  489,
 1117, 1118, 1377, 1378, 1379, 1471, 1380, 1381, 1382, 1383,
 1384, 1385, 1535, 1574, 1502, 1577,  415,  634, 1537,  416,
  992, 1472, 1509, 1510, 1546,  357,  358,  417,  977, 1160,
 1300,  978,  979,  116,  254,  427, 1483,  340, 1094, 1255,
 1354, 1519, 1520, 1521, 1522, 1092,  311,  507,  736, 1129,
  191,   52,  306,  170,  133,  289,  156,  296,  162,  694,
  691,  297,  307,  724,  308,  504,  944,  157,  290,  475,
  508, 1130,   88,  167,  212,  545,  546,  696,  961,  697,
  962,  963,  549,  550,  551,  552,  954,  783,  553,  554,
  555,  751,  556,  455,  748,   36,   37,   38,   54,  172,
  313,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  660,  440,  895, 1097,  441,  442,  665,   39,  132,  285,
   40,  456,  457,  680,  647,  255,  428,  429,  430,  651,
  881,  882,  883,  884, 1086,  418, 1245, 1246,  117,  118,
 1349, 1350,  419, 1528, 1450, 1529, 1530, 1531, 1571, 1616,
  377, 1057,   41,   42,  341,   43,   44,  449,  450,  828,
 1054, 1216, 1220,  378,  610,  182,  581,  582,  583,  584,
  585,  586,  587,  588,  589,  590,  591, 1183, 1002, 1004,
 1184,  632,  420,  421,  422,  867,  361,  205,  860,
};
static short yysindex[] = {                                   5064,
  930, -185, 3868,   28,  859,  -11, 4164,  221, 2532,  -30,
  382, 2230, -185,  998,  326,  210,  230,    0,  651,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -157,    0,
    0,    0,    0,    0,    0, 6609,  289,  430,  461,  210,
  471,    0,    0,  528, 1050,  531,  289,  592,  461,  525,
  210,  471,    0,  599,  614,    0,  355,    0,  628,    0,
    0,  806,  650,    0,  210,  723,  289,  818,  650,  592,
  430,  461,  525,  210,  471,  599,  614,    0,  461,  747,
    0,    0,    0, 1166,    0, 1166,    0,  850,  896,   35,
 1210,    0,    0,    0,  531,  210,  531,  910,  920,  950,
   68,  960,    0,   22,   83,  524,  853,    0,  592, 1043,
 1184,    0,    0,  941,  939,  461,  210,    0,    0, 1130,
  -89, 1093,  548,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  504,    0,    0, 1050,    0,
  -27,    0,    0, 1401,    0,  911,    0,    0,  -19,    0,
 1023,    0,    0, 1002,    0,    0,  986,    0,    0, 1204,
    0,    0, 1050,    0,    0,    0, 1401,    0,  616,    0,
    0, 1180,    0, 1163,    0,    0, 1166,    0,    0,    0,
    0,    0, 1179,    0,    0, 1042,    0,    0, 1189, 1077,
    0,    0,    0, 1042,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1353,    0,  531,    0,    0,    0,  702,
 1144,  700,  614, 1171, 1216, 1528, 1249, 1255,  702, 1231,
  700, 1215, 1223,    0, 5288,    0,    0,    0, 5288,    0,
    0,    0,    0, 4499,    0,    0, 1157,  430, 1301, 1217,
  384,  210, 1251,    0,    0, 1184,    0,    0,    0,    0,
    0,    0,    0, 1227,    0,    0, 1401,    0, 1180,    0,
  585, 1266,    0, 1253,    0, 1003, 1343,  462,  548,    0,
 1415, 1136,    0,  531,    0,  504,    0,    0,    0,    0,
  531, 1309, -107, 1243, -103, 1678,    0, 6666,    0,    0,
 1079,    0,    0,    0, 1666, 1666, 1050, 1358, 1050, 1290,
  986,    0,    0, 6632,    0, 1309,    0,    0, 1449,  437,
 1692,  210, 1498,  430,    0,    0, 1724,  189, 2754,    0,
    0,    0, 1304,    0,    0,    0,    0, 1306, 1318,    0,
    0, 1101, 1955,    0,    0,    0,    0, 1747,    0,    0,
    0,  237,    0,  210, 1362,    0,  461, 1339,    0,   77,
    0,    0,    0,    0,  210, 1227,  578,    0,  210,    0,
 1480,  461, 1758,  702, 1406, 1770, 1774, 1777,    0, 1778,
 1779,    0, 1785, 1787, 1789,    0,    0, 1790,    0,    0,
    0,    0,    0, 1791, 5288, 5288, 4822, 1361, 1793, 1312,
    0,    0,    0,    0,    0, 1745,    0, 1792,    0,    0,
    0,    0, 1418,    0, 2296,    0, 1516, 1795,    0, -125,
    4,    0,  870,    0, -143,    0, -143,    0,    0, 1796,
    0,   91, 1413,    0,    0,    0,    0, 1797,   82, 1783,
 1309, 1805,    0, 1571, 1571, 1808,    0, 1809,    0, 1471,
    0,  118, 1507,    0,    0,    0,    0, 1050,    0, 1666,
 1666, 1666, 1666,    0, 1814,    0, 1583, 1585,    0,    0,
    0, 1565,    0, 6632,    0,    0, 6632,  273,    0, 1401,
 1603, 1407, 5460,    0,    0,  -18,    0, 1407,  862,  911,
    0, 1473, 1432, 1404,  567,  631,    0, 1479,    0, 1419,
  525,    0, 1050,    0, 1604,    0,    0, 1290,    0,    0,
    0,    0,   32, 1434,    0,    0,    0, 1435,    0, 1484,
 1845,    0, 1540, 1868,  -56,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1819,   53,    0,    0,
    0,    0,   48, 1871, 1874, 1868, 1651,    0, 1050, 1050,
    0, -107,  -19,    0, 1532,    0, 1505, 1876,    0, 6385,
  107,    0, 1533, 1535, 1884, 3281, 1886, 2851, 6494,   11,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1457, 1955,  531,    0,    0,
 1268, 1490,    0,    0, 1463,  700,    0, 1612,    0, 1497,
 1893,    0, 1612, 1268, 1614, 1617,  461,  714, 4965,   71,
  592, 5288, 1001, 1022, 1032, 1894, 5288,  753,  753,  998,
 1859, 1898,    0,    0, 5062, 1482, 5288, 5288, 5288, 5288,
 5288,    0, 5288,   44,    0,   34, 1487, 4965, 1492,    0,
    0,    0, -173,    0,    0, -120,    0, 1496,    0,    0,
    0,  210,  795,  210,    0,    0,  531, 1227,    0,    0,
 4965, 1687, -107, 1482,  355,  355,  585,   69,  531,    0,
 1050, 1050,    0, -135, 1419, 1419, 1499,  525,  462,    0,
    0, 1914,    0,    0,    0,    0, 1679,    0,  531,    0,
    0,    0,    0,    0, 1683, 1919,    0, 1661, 1684,    0,
    0, 1625, 1626, 1166, 1695,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  525,  531, 6530,    0,    0,
    0,    0,    0,    0,  525,    0, 1240,    0,    0, 1557,
    0,   80, 1561,    0,    0,    0,  525,    0, 1845,   31,
    0,    0,    0, 1682,   31, 1566,   31,    0, 1946,  525,
  525,  525,    0,    0, 1632,    0, 1633,    0,    0,    0,
 1079, 1573,  210, 1641,  178,    0,    0, 1952, 1721,    0,
    0,    0,    0,  189, 1541, 1266,    0, 1266, 6361,  378,
 5288, 5288, 3343, 1953,  763, 3580, 5288, 3634,  976, 3871,
 3925, 5108, 4162, 4216, 4453, 3281, 3281,    0,    0,    0,
    0,    0, 1339,  461,  471, 1339,  599,  614,   93, 1959,
    0,    0,    0, 1268, 1619,    0, -119, 1638, 1227,    0,
 4965, 1638, 1964, 1959, 1268,  -73, 1688, 5288, 5288, 1746,
 5288, 1970, 5288, 1968, 2139, 5288, 5288, 5288, 5288, 5288,
 5288,    0,    0,    0,    0,    0,    0,    0,    0, 1696,
  868,  524,    0,    0,    0, 2296, 1656,    0,    0, 1740,
  753,  753,  322,  322,  809,    0,    0,    0,   34, 1973,
 1977,  664,    0,    0, 3281, 1697,    0,    0,    0,    0,
    0,    0,    0,    0,  224,    0,    0,    0,    0,    0,
 1676,    0,    0,    0,    0, 1980,    0,    0,    0, 1699,
    0, 1666, 1759,    0, -135,    0,    0,    0,    0,    0,
    0,    0, 1988, 3281, 3056,    0,    0, 1734,    0,    0,
    0, 3056,    0,    0,    0, 1166, 1166,    0, 1993,    0,
    0,    0,    0,    0,    0, 1772,    0,    0,    0, 1577,
   28, 1701, 1620, 1679, 2004,    0, 1419, 1706,    0,    0,
  961,    0, 1989, 1577, 1148,  525, 2007, 2009, 2024, 1734,
 1666, 1507, -107,    0, 1479,  998, 1611, 1627,    0,   27,
    0,  525, 1672, 1769, 6385,    0,    0,  525, 1578, 1771,
    0,    0, 2039, 2042,    0, 1270, 2296, 2044,    0,    0,
 2296, 2045, 3405,    0,    0, 1739, 2046, 2296, 2048, 1228,
 2053, 2296, 2055, 5288, 5288, 1953, 5288, 5205, 2059, 2296,
 2060, 2066, 2296, 2069, 5288, 2296, 2075, 2296, 2077, 2079,
 2296, 2081, 2082, 2296, 2087,    0, 1867,    0,    0,    0,
    0,    0,    0, 1803, 1268,    0, 1268,   93, 1959,    0,
  197,  197,   20,    0,    0,    0, 1717,    0, 1964, 1959,
 2088,  -73, 2167, 2216,    0, 2655,    0, 2698, 5288,    0,
 2875, 2911, 2981, 3045, 3061, 3132, 5288,  525, 5288, 5288,
    0,    0,  664, 2093, 4965,  939,   34, 1748,    0, 1752,
 1754, 1794, 1861, 1812,    0,    0,    0, 1734,    0, 1723,
 1050, 1756, 1419, 1760, 1419,    0, 3281,  606,    0,    0,
    0,    0,    0,    0, 1703, 1882, 1734,    0, 5288,    0,
 1870, 1765,    0, 3281,    0,    0,    0,    0,    0,    0,
    0,    0, 2114,   28,    0, 1499,    0,    0,   31,    0,
 3056, 1781,   31,    0,   31,    0, 1679, 2115,    0,    0,
    0, 1882, 1419,    0, 1507,    0,    0,  524, 1890,    0,
  -69,    0, 1980,    0, 2122,    0, 2123, 1050,  -86, 2133,
    0, 1050,    0,    0, 5288, 1757, 1757,  998,    0,    0,
    0,    0, 2135, 1719,    0, 1757, 1757, 5288, 1757, 1757,
 1608, 2296,    0, 1429, 5288, 2296, 1757, 1757, 1757, 1757,
 2296, 1757, 1757, 1757, 1757, 1757, 1757, 1799,    0,    0,
    0,    0,    0,    0,    0, 1741,    0,    0,    0,    0,
 4965,    0,  -73, 2088,    0,    0, 6632, 2142,    0,    0,
 3247,    0,    0,    0,    0,    0,    0, 3321,   88, 1160,
 2296,    0, 2296,    0, 1733,    0,    0,  664,    0,    0,
    0,   34, 1726, 3281, 1798, 1882, 1666,    0,    0, 1050,
 1240,    0,    0,  658,    0,  531, 3328,    0,    0, 2296,
 1571, 1870,    0,  680,  210,  677, 1734,    0,    0, 2147,
    0, 2148,    0, 1839, 1571, 1781,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1240, 1772, 4499, 1807,    0,
 1573,    0,    0,    0, 1825,  251,    0, 1679, 1827, 2296,
 2164, 2166,  524,    0, 3535,    0, 2172, 2174, 2296, 2175,
 2181, 5288, 5288, 2296, 2184, 2187, 2190, 2191, 2195, 2197,
 2201, 2202, 2203, 2204,    0,  197,    0,    0,    0,    0,
    0,  525,    0, 1487, 4965,    0, 1330, 1974, 2206,    0,
    0,   11,  746,    0,    0, 1419,    0,    0,    0,    0,
 6632,  289, 1852, 2189, 1266, 2220, 1915, 5288, 2205, 2227,
 2212, 2213, 2217, 1934, 2219,    0,    0,    0, 4698, 2221,
    0,    0,    0,    0,    0,    0, 2240,    0,    0, 1930,
 1945,  210,    0,    0,    0, 1166,    0, 1882,    0,    0,
    0,    0,    0,    0,    0,    0, 1975,    0,    0, 5288,
 1050,    0,    0,    0, 1050,    0,    0, 5288,    0,    0,
    0,    0,    0,    0,    0,    0, 2296, 2296,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2250,
 1697,    0, 3281, 1482, 1726,    0,    0, 1926,    0, 2258,
    0,    0,    0, 2241, 2242,  461,    0, 1958, 3281, 1850,
    0, 3281,    0,    0,    0,  110,    0,    0,  624,    0,
 -114,    0,    0,    0,    0,    0, 1166, 1931,    0,    0,
    0,   57, 1487, 2296,    0,    0, 1160,    0, 1812,   11,
    0,    0,    0,  735,    0,    0, 1143,  110,  719,    0,
  769,  988,    0,    0,    0,  289, 1849,   28,   63,    0,
    0,    0, 1931,  -92,    0, 1936, 1941,   57, 2282,  664,
    0,    0, 1697, 2288, 1487, 1798,  210,    0, 2289, 2287,
  956, 1326,    0,    0, 1921,    0, 2304,    0,   78, 1897,
 2047,    0,  110,    0,    0,    0,    0, 3328,  624,    0,
 -142, -142, 2051,    0, 1907,    0,  664, 2313,   57, 2017,
 1812,    0, 1697,    0,    0,    0,  735, 2322,    0,  430,
    0, 1735,   40, 2306, 1326, 2083, 2058, 3328, 3328,    0,
    0,    0,    0, 1916,  591,    0,    0,    0,    0,  664,
   57, 1798, 1812,    0,  430,    0,    0,  110, 2335,    0,
    0,    0,    0,    0, 1541, 3328, 2073,    0,    0,    0,
    0, 1342,    0, 1798, 2338, 2342, 1737,    0,    0, 3328,
 3281,    0,  430,    0,    0,    0,   11,    0,
};
static short yyrindex[] = {                                      0,
    0,  145,  557,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  223, 3003,    0,    0,    0,    0, 2384,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  115,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  776,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2049,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2001,
    0,    0,    0,  219,    0,  219,    0,    0,    0,    0,
 2013,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 4596, 3100,    0,    0,    0,
  816,    0,    0,    0, 1065,    0,    0,    0,    0,    0,
    0,  245,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -115,    0,    0,    0,    0,  587,    0,
  827,    0,    0,    0,    0,    0,  639,    0,    0, 6653,
    0,    0,    0,    0,    0,    0, -115,    0,  -59,    0,
    0, 2358,    0,    0,    0,    0, 2144,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  943,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1061,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  604,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  100,    0,    0, 1069,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -115,    0, 2358,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1072,    0,
 2131,    0,    0,    0,    0, 1080,    0,    0,    0,    0,
    0, 2146,  428, 6695,    0, 1099,    0,    0,    0,    0,
  156,    0,    0,    0, 1957, 1957,    0,    0,    0, 1121,
 1549,    0,    0,    0,    0, 2146,    0,    0, 1124,    0,
    0,    0,    0,    0,    0,    0, 6369, 2032,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1145,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1151,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1165,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1600,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1710,    0,    0,    0,    0,
    0,    0,    0,    0,  148,    0,    0, 2103,    0,  119,
    0,    0,    0,    0,  357,    0,  357,    0,    0,  206,
    0,  425,  692,    0, 4534,    0,    0,    0,  943,    0,
 2146,    0,    0, 1164, 1164,  672,    0,    0,    0,  275,
    0, 3355,  155,    0,    0,    0,    0,    0,    0, 1957,
 1957, 1957, 1957,    0,  173,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2162,
    0,    0,    0,    0,    0, 2131,    0,    0,  761,    0,
  434, 1956,    0,    0,    0,    0,    0,  165,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1191,    0,    0,
    0,    0,   75,   92,    0,    0,    0,  406,    0,    0,
  688,    0,    0,  971,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  157, 1445,    0,    0,
    0,    0, 1257,  303,    0,  971,    0,    0,    0,    0,
    0,  428, 1177,    0,    0,    0,    0, 2018,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  448,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  102,    0,    0,
    0,    0,  102,    0,    0,    0,    0, 5357,    0, 5357,
    0,    0, 5357, 5357, 5357,    0,    0, 2262, 2345, 4739,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2428,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  549,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  428,    0,  999,  999,    0,    0,    0,    0,
    0,    0,    0, 3883,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  523,    0,    0,    0,
    0,    0,    0,    0, 2392,    0,    0, 2229, 1495,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2269,    0,    0,    0,
    0,    0,  676,    0,    0,    0,    0,    0,  688,    0,
    0,    0,    0,  669,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  103,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 6543,    0,    0,    0,   55,    0,
    0,    0,    0, 2124,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1194, 1238,
    0,    0,    0,    0,    0,    0,    0, 1244,    0,    0,
    0, 1244, 1247, 1264,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 5357,    0,    0,    0,  771,    0,    0,    0, 1905,
 2518, 2675, 2015, 2159,    0,    0,    0,    0,    0,  209,
 1708,  849,    0,    0,    0,  778,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  319,    0,    0,    0,    0,
    0, 1957, 1976,    0, 4012,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2168,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1283,    0,    0,    0,    0,
    0,    0,    0,  600,    0,    0,    0,    0,    0,    0,
    0,    0, 1196,    0,    0,    0,    0,    0,    0, 2168,
 1957, 1288,  428,    0, 2169, 3003, 1314,   66,    0,    0,
    0,    0, 6543,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1351,    0,    0,    0,
 2867,    0,    0,    0,    0,    0,    0, 3631,    0, 4113,
    0, 4403,    0,    0,    0,    0,    0,    0,    0, 5573,
    0,    0, 5637,    0,    0, 5657,    0, 5720,    0,    0,
 5740,    0,    0, 5804,    0,    0, 3094,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1194, 1327,    0,
 2003,  217,    0,    0,    0,    0,    0,    0, 1329, 1337,
 1367,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2098,  873,    0, 1782,    0, 2099,    0, 2102,
 2107,    0,    0, 2023,    0,    0,    0, 2168,    0, 3800,
    0,    0,    0, 1995,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2186,    0,    0,    0,
 2400,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  788,    0,    0,    0,    0, 1832,    0,    0,    0,
    0,    0,    0,    0, 1375,    0,    0, 4596,    0,    0,
    0,    0, 1385,    0,    0,    0,    0,    0,  139,    0,
    0,    0,    0,    0,    0,    0,    0, 4739,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 5824,    0, 5887,    0, 5908,    0,    0,    0,    0,
 5971,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1433,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1170,    0, 1749,    0,    0,    0,    0, 1675,    0,    0,
    0,    0,    0,    0, 1112,    0, 1957,    0,    0,    0,
 2508,    0,    0,    0,    0,    0,    0,    0,    0, 2411,
 1391, 2712,    0, 2131,    0,    0, 2168,    0,    0,    0,
    0,    0,    0,    0, 1469,  813,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  108,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  392,    0, 5991,
    0,    0, 5357,    0,    0,    0,    0,    0, 6055,    0,
    0,    0,    0, 6118,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  217,    0,    0,    0,    0,
    0,    0,    0,  420,    0,    0, 2098,  695,  685,    0,
    0,  697, 2415,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  248,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 6138, 6202,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   41,    0,    0,    0,    0,    0,    0, 2418,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2113, 1475,    0,    0,
    0,    0,  426, 2411,    0,    0,    0,    0,   54, 5888,
    0,    0,    0, 2415,    0,    0,   30,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2253,    0,    0, 2844, 3221,    0,  401,  208,
    0,    0,  246,    0,  420, 2419, 1105,    0,    0, 2420,
    0,    0,    0,    0, 2403,    0,  211,    0, 2158,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2098, 1345,    0,    0,
   58,    0,   41,    0,    0,    0, 2415,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  346,
    0,   61,   54,    0,    0,    0,    0,    0, 2406,    0,
    0,    0,    0,    0,    0,    0, 6178,    0,    0,    0,
    0, 2098,    0, 2419, 2425,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  838,    0,
};
static short yygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0, 2467,    0,    0, 2472,
    0,    0,    0,    0,    9,    0, 2473,    1,  201,  -57,
 -536, 1426,  681, -272, -182, 2463, 2236,    0,  -36,    0,
 2245,  -88,  -42,    0,  501, -806,  -21,  -44,  -22, -178,
 2249, 1877,    0,    0,    0,  766,    0,    0,  -45, 1500,
 -442,  -37, -849, 1920, 1713, -256, 1511, 2426, -257,    0,
  -51,    0,  981,  -47,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -589,  -97, 1518,
 -263,  780, -873,    0,    0,    0,    0, -294,  -96, -929,
 1527, -293,  -40,    0, -456,    0,    0, -419, -785,    0,
 1218,    0,    0, 2215, -545,  -25,    0,    0,    0,    0,
 2192,    0, 1992, 2225, -113, 1548, -576,    0,    0,    0,
 -626,    0,    0,    0,    0,    0,    0, 1601,    0, 2244,
 1842, 1552, 2224, 2226,    0,    0,    0, -449, 1821,  -54,
  214, -642,    0,    0, -212, -720, -688, -211, -782,    0,
 1256, -937,    0, 1024, 1261,    0, 2052,    0,    0,    0,
 1025, 1029,  997,  -81,  -33, -869, -998,    0,    0, 1853,
    0, 1436, -351,    0,    0,    0,  -74,    0,    0,    0,
    0,    0,    0,    0, -677,    0,  -10,    0, 1028, -266,
  949, 1086,    0, 1015,    0,    0, 2218,  -94,    0,    0,
    0,    0, -975, -580, -793, 1267,    0, -420,-1254,-1270,
 -506,    0, -655, 1048, 1454, -290, 2005, 1801, 1610, 1278,
   -1,    0,    0,    0,    0,    0, 2278,    0,    0,    0,
    0, 2292, 2090,    0,    0,    0,    0,    0, 2303,    0,
    0,    0,    0,  -16,    0,    0,    0, -300, 1836, -296,
 1452, -386,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2041,    0,    0, 1856,    0,    0,    0, 2588,    0,
    0,    0,    0, 2336,    0,    0,    0,    0, 2177,    0,
 2176,    0,    0,    0, 1954,    0,    0,    0,    0,    0,
  -83,    0, 1938,    0,-1113,  992,    0, 1971, -567, 1972,
    0, -786, 1750,    0,    0, -121,    0, 1279,    0, 2511,
    0, 1186,-1084, 1282,    0, 1073,    0, 1109,    0, 1021,
    0,    0,    0,    0, 2196,    0,    0,    0, -319, 2034,
 1820, -921,    0,    0,    0,  877,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 4423, 1513, 1637,
    0,    0,    0,    0, -213, 2012, 2308,    0,    0,
};
#define YYTABLESIZE 7186
static short yytable[] = {                                     125,
  161,  181,   71,  276,   70,  183,  164,  229,   33,  175,
  360,  355,  356,  166,  454,  180,  187,  247,  250,  248,
  251,  511,  189,  547,  192,  213,  516,  548,  669,  482,
  787,  902,  790,  217,  695,  676,  707,  698,  484,  218,
  194,  222,  199,  709,  655,  219,  224,  283,  653,  862,
  235,  840,  237,  371,  216,  911,  609,  639,  125, 1121,
  643,  245,  371,  221,  223,  336,  226,  220, 1079,  236,
 1127,  742,   69,  879,  485,  957,   69,  833,  233, 1598,
  573,  632,  246,  277,  246,  877, 1142,  760,  297,  906,
  279,  497, 1083,  257,  639,   83, 1518,  408,   83,  548,
 1152,  683,  119,  899, 1137,  326, 1549,  189,  333,  615,
  877,  233,  842,  298,  573,  485,  639, 1268,  485,  643,
  606, 1543,  249,  951,  336,  668, 1344,  780, 1343,  359,
 1217,  497,  497,  485,  664,  497, 1045,  325,  649,  360,
  355,  356, 1114,  757,  525,  246, 1120,  677,  258, 1114,
  497,   69,  448, 1295,  431,  439,  465,  682,  548,  458,
  683,  119,  592,  435,  365,  952,  189,  408, 1351,  683,
  282,  363,  433,  573,  474,  685,  686,  687,  688,   87,
  492,  381,  497, 1274,  498, 1302, 1489, 1306,  677,  604,
 1301,  677,  547,  366, 1511,  451,  548,  465,  459,  447,
  465, 1051,  366,  525, 1111,  554,  677,  342,  605, 1551,
  432, 1111,  109,  431,  439,  465,  485,  983, 1526,  446,
  752,  912,  525,  365,  516,  439,  886,  116, 1256,  299,
  130,  433,  715,   69,  658, 1584, 1112,  309, 1210,  483,
 1212,   69,  105, 1112,  582,  632,  486,  692,  181,  605,
  499,  342,  605,  502,  448,  813, 1278, 1355,  359,  246,
 1036, 1037,  692, 1056,  554,  743,  342,  605, 1561,  295,
   53,  512,  806,  514,  584,  485, 1585,  599,  942,  754,
  598,  525, 1180,  131,  561,  244,  565, 1048,  692,  753,
 1592,  692,  557,  612,  913,  563,  258, 1293, 1059, 1061,
 1248,  712,  492,  582,  632,  659,  692,  300, 1593,   75,
  106,  705,  242,  700, 1181,  310,  699, 1052,  583,  437,
  889,  446, 1614, 1586,  603, 1409,  616,  600,   14,  756,
  252, 1358,  485,  584, 1274,  650,   71, 1469,  608,  603,
  876, 1576,  613,  492,  837,  343,  492,  366,  976,  497,
 1552,  485,  485,  178,  485, 1283,  553,  178, 1114,  485,
 1351,  492,  485,  958, 1298,  497, 1405, 1548,  497,  497,
  816,  497,  632, 1525,  841,  485,  497,  583, 1108,  497,
 1307,  485,  713,  360,  809,  810,  681,  369,  241,  343,
 1163, 1360,  497,  492, 1386, 1158, 1387,  807,  497, 1480,
  341,  497,  116,  116,  343,  498, 1342, 1398,  701,  663,
  454,  677,  431,  737, 1439,  553, 1210,  672,  995,  439,
 1111, 1404,  684,  714,  564,  641,  923,  371,  365,  925,
  433,  834,  487,  573,  465,  487,  465,  632,  711,  592,
  297,  465,  548,  931,  465,  498,  498,  640,   87,  498,
  639,  119, 1112,  485,  639,  573,  189,  465, 1414,  341,
  641,  431,  244,  571,  498, 1347,   83,  739,  677,  683,
  497,  232,  946,  738, 1259,  485, 1218,  548,  919,  433,
  244, 1451,  485,  564,  641, 1453,   68,  178,  640,  244,
   68,  485,  497,  485,  163,  759,  498,  652,  639,  497,
  445,  643,  811,  497,  178,  548,  640,  181,  548, 1055,
  497,  485,  639,  765,  766,  643,  485,  122,  985, 1418,
  336,   71,  487, 1479,  548, 1224,  990,  605,  497,  178,
  605,  605, 1481,  497,  339,  465,  342,  605,  919,  342,
  605,  244,  780,  812,  605,  485,  448, 1044,  554,  605,
  548,  620,  605,  439,  525,  458,  890,  465,  497, 1281,
  492, 1264,  497,  487,  465,   68,  487,  781,  605,   71,
  445,  782,  982,  431,  603,  922,  492,  632, 1276,  492,
  492,  487,  492,  554,  485,  582,  357,  492,  917,  918,
  492,  433,  605,  898, 1420,  844,  605, 1313,  465,  487,
  677,  636,  692,  492,  342,  605, 1412,  637,  677,  492,
 1524,  554,  492,  446,  554,  584,  938, 1103,  181,  201,
  571,  295,  605,   89,  363,  439, 1421,  896,  571, 1095,
  554,  692,  126, 1357, 1038,  907,  907, 1041,  145,  806,
  487, 1049,  632,  487,  486,  357, 1265,   68,  342,  605,
  921,  119, 1060, 1337,  107,   68,  554,  202,  487,  583,
  342,  605,  342,  498,  127,  487, 1119,  435,  129,  605,
  122,  572,  941,  943,  343,  482, 1153,  343, 1125,  498,
 1096,  492,  498,  498,  631,  498,  632,  515,  940,  620,
  498,  549,  110,  498,  635, 1141,  638,  145, 1359,  553,
  632,  487,  993,  492,  994,  234,  498,  448, 1352,  129,
  492,  360,  498, 1113,  492,  498,  482, 1397,  360,  482,
 1113,  492,  967,  968,  969,  631,  985,  129,  515,  341,
  572,  515,  341,  945,  482,  635,  980,  638,  635,  492,
  470, 1413,  343,  631,  492,  955,  515,  234,  641,  158,
  549,  641, 1282,  635,  641,  638,  120,  641, 1292, 1540,
  425,  291,  553,  121,  807,  553,  640,  564,  436,  492,
 1338, 1039, 1042,  492,  446,  527,  640,  632,  515,  640,
  487,  553,   71,  252,  498,  560,  343,  130,  640,  360,
 1179,  471,  243, 1040,  640, 1043,  487,  341,  343,  641,
  343, 1491,  564,  487,  425,  286,  498,  553, 1227, 1541,
  292,  797,  131,  498,  797,  532,  641,  498,  632,  425,
 1539,  109,  641,  437,  498,  472,  529,  253,  234,  487,
  564,  868,  487,  564,  527,  640,  632,  346, 1122, 1123,
  438,  341,  498,  473,  640,  357,  130,  498,  596,  564,
  357, 1388, 1080,  341,  287,  341,  357,  487,  487,  109,
  890,  683, 1557,  797, 1277, 1402,  641,  806,  729,  234,
  414,  131,  498, 1244,  532,  564,  498,  487,  346,  487,
  641,  346, 1164,  327,  487,  529, 1505,  487,  640,  596,
  160, 1610,  596, 1297,  109, 1599,  346, 1490,  173,  174,
  487, 1082,  640, 1590,  868,  730,  487,  596, 1182,  640,
  638, 1454,  639, 1499,  641,  928, 1501,  145,  181,  806,
 1617,  163,  293, 1441,  935,  363,  547,  360, 1148, 1113,
  548,  168,  732,  482,  487, 1612, 1506,  171,  806,  145,
  294,  487,  641, 1611, 1166,  515,  129, 1507,  129,   71,
 1170, 1133,  482,  482,  557,  482, 1215, 1215, 1219,  487,
  482,  515, 1356,  482, 1247,  515,  288,  515,  145,  733,
  505,  337,  515,  252,  295,  515,  482,  970,  487,  342,
  806,  328,  482,   68,  357, 1088, 1348,  145,  515,  487,
  572,  178,  807,  487,  515,   14,  145,  515,  580, 1089,
  487,  641,  145,  631, 1143,  557, 1261,  487, 1263,  731,
  715,  505,  572,  635,  505,  638,  631,  838,  487, 1564,
  145,  697,  611, 1090,  410,  631,  635, 1470,  423,  505,
  806, 1543,  636,  425,  549,  635,  487,  638,  637, 1410,
 1239,  487,  580,   68,  807,  445, 1542,  129,  697,   71,
   71, 1508,  184, 1144,  482,  907, 1296,  580, 1390,  196,
  328,  505, 1523,  807,  612,  350,  515,  130,  531,  549,
  487,  372,  631,  734,   97, 1627,  482, 1091, 1446,  373,
 1391,  631,  635,  482,  638, 1613,  204, 1392,  515, 1446,
  350,  635,  131,  638,  482,  515,  632,  549,  369,  515,
  549,  360, 1419, 1447, 1563,  807,  515, 1622,  612,  632,
  207,  643,  482, 1098, 1447, 1005,  549,  482,  632,  328,
  154, 1393, 1305,  612,  515,  631, 1309,  531,  206,  515,
  372,  458,   71, 1244, 1280,  635,  364,  638,  373,  631,
  214, 1006,  549,  368,  326,  448,  482,  636,  225,  635,
   41,  638,  643,  637,  515,  807, 1126,  369,  515,  346,
  369, 1448,  122,  210,   49,  632,  346,  596,  303,  346,
  643,  304, 1448,  346,  632,   72,   73,  596, 1348,  154,
  596,  346, 1532,  211,  628,  629,  631,  352, 1078,  596,
  155, 1143,  620,   39,  598,  122, 1582,  346,  893, 1504,
  408,  640,  638,  326,  639,  226,  641,  210,  598,   41,
  798,  181,  446,  798,  907,  894,  598,  305,  632,   90,
 1422,  346,  210,   49,   45, 1361, 1607, 1608,  505, 1560,
 1538, 1504,  598,  230,  346,   46,  596,   22, 1396,  463,
 1147, 1215,   47,  688,  505,  596,   45, 1014,  505,  155,
  505,  346,   39,  234, 1619,  505,  489,  448,  505, 1452,
  252,   91,  798,   47, 1015, 1538, 1560,   48, 1626,  640,
  638,  505,  639,   92,  641,  656, 1581,  505,  346,  231,
  505,  252,  441,  360, 1533, 1534,  598,  121,  463,  596,
  346,  252,  346, 1568,  263,  238,   22,  489,   93, 1560,
  489,  596,  688,  239,  846,   45, 1504, 1478, 1604, 1016,
 1455,  640,  638,  353,  639,  489,  641,  580,  360, 1533,
 1534, 1560,   47,  458,  446,  848,   23,  722,   46,  723,
 1569, 1504,   49,  240,   71,  850,   48,  505, 1017,  580,
 1440,  441,  315, 1570,  458,  115,  121,  489,  506,  505,
  756,  461,  642,  640,  638, 1477,  639,  789,  641,  274,
  462,  360, 1601, 1602,   50, 1485,   43,   94,   51, 1486,
  352,  505,  353, 1458,  122,  458,  458,   95,  505,  316,
  258,  317,  505,  408,  110,   23,  612,   46, 1513,  505,
  210,  756,  353,  612,  756,   48,  612,  352,  425,  275,
  612,  845,   96,  281,  318, 1018,  861,  505,  612,  756,
  458,  284,  505, 1497,  866,  246,  870,  871,  872,  873,
  874,  458,  866,  480,  612,   43,  448,  425,  210,  319,
  643,  210,   44,  122,  210,  357,  481,  505,  343,  636,
  301,  505,  654,  110,  487,  637,  357,  312,  612,  210,
  425,  458,  643,  458, 1544, 1503,  448,  448,  645,  640,
  638,  612,  639,  314,  641,  125,  210,  323,  210,  124,
  640,  638,   91,  639,  247,  641,  458, 1527,  612,  654,
  646,  332,  210,  612,  448,  487, 1536, 1503,  487,  114,
  115,   44,  654,  446,  455,  344,  330,  808,  448,  643,
  597,  125,  335,  487,  210,  612,   71,  636, 1547,   93,
 1527,  173,  174,  637,  489,  247,  334,  612,  247,  612,
  878, 1536, 1596,  446,  446,  338,  259,  210,  210,  339,
  489, 1175, 1580,  247,  489,  455,  489,  830,  455, 1188,
  829,  489,  125,  897,  489, 1209,  367, 1211,  146,  636,
 1527,  446,  643,  455,  878,  637,  375,  489,  345,  346,
  347,  260, 1503,  489, 1603,  446,  489,  376,  470,  379,
  996,  997, 1001,  380,  125, 1008, 1010, 1012,   94, 1020,
 1023, 1026, 1028, 1031, 1034,  117,  117, 1503,   95,  261,
  515,  636,  262,  431,  350,  351,  813,  637,  384,  868,
  345,  346,  347,  445,  173,  174,  385,  146,  263,  839,
  425,  843,  756,   96,  847,  849,  851, 1063, 1064,  471,
 1066,  343, 1068,  348,  349, 1071, 1072, 1073, 1074, 1075,
 1076,  947,  948,  382,  264,  489,  350,  351,  461,  864,
  868,  868,  868,  868,  868,  880,  868,  462,  343,  640,
  638, 1088,  639,  472,  641,  903,  904,  489,  868,  868,
  868,  868,  433, 1088,  489, 1089,  344,  434,  489,  756,
  814,  473,  756,  974,  597,  489,  973, 1089,  344,  756,
  344,  981,  756,   14,  776,  443,  756,  445,  344, 1090,
  868,  756,  868,  489,  756,  460, 1081,  636,  489, 1080,
  469, 1090,  477,  637,  344,  344,  815,  595,  636,  770,
  756,  816,  497, 1443,  637,  597, 1099,  817,  597,  973,
  490,  500,  487,  489,  487, 1621,  509,  489,  369,  487,
  513,  562,  487,  597,  756,  558,  818,  756,  756, 1102,
 1323, 1135, 1101, 1091, 1134,  487, 1140,  756,  595, 1139,
  770,  770,  770,  770,  770, 1091,  770, 1222,  344, 1316,
 1221,  564, 1315,  566,  756,  592,  595,  593,  770,  770,
  770,  770,  455, 1346,  455, 1597, 1345, 1625, 1575,  594,
 1543,  603,  455,  345,  346,  347,  445,  173,  174,  609,
  597,  756,  609, 1191, 1192,  455, 1194, 1196,  601,  369,
  614,  606,  770,  756, 1201,  756,  348,  349,  617,  618,
  345,  346,  347,  619,  173,  174,  620,  621,  622,  350,
  351,  633,  603,  487,  623,  603,  624,  146,  625,  626,
  627,  487,  635,  348,  349,  643,  646,  644,  648,  662,
  603,  666,  667,  671,  673,  487,  350,  351, 1231,  146,
  674,  677,  487,  679,  678,  461, 1238,  689, 1240, 1241,
  690,  868,  692,  868, 1243,  693,  702,  703,  727, 1322,
  726,  868,  487,  455,  728,  487,  735,  244,  146,  868,
  740,  744,  745,  746,  747,  868,  487,  636,  868,  749,
  487,  640,  638,  637,  639,  455,  641,  146, 1270,  863,
  640,  638,  455,  639,  780,  641,  146,  750, 1500,  755,
  761,  868,  146,  762,  764,  773,  775,  785,  868,  776,
  868,  868,  784,  786,  868,  788,  824,  825,  868,  827,
  146,  868,  831,  868,  835,  868,  455,  836,  864,  885,
  868,  868,  868,  868,  891,  780,  780,  780,  780,  780,
  900,  780,  650,  924, 1310,  756,  929,  919,  930,  868,
  868,  932,  868,  780,  780,  780,  780, 1319,  705,  936,
  937,  770,  939,  770, 1324,  950,  868,  953,  868,  868,
  868,  770,  959,  868,  964,  966,  868,  868,  971,  770,
  976,  988, 1003,  597,  989,  770,  868,  780,  770,  352,
  425,  991, 1047,  597, 1050, 1053,  597, 1045, 1062, 1065,
 1067, 1069, 1085,  868,  783,  597, 1077,  246,  620,  636,
 1087,  770,  639,  598, 1104, 1093,  595, 1107,  770,  868,
  770,  770, 1124, 1115,  770, 1128,  595, 1131,  770,  595,
  868,  770, 1136,  770, 1138,  770, 1145, 1149,  595, 1150,
  770,  770,  868,  770,  868,  783,  783,  783,  783,  783,
  868,  783,  597,  639, 1151, 1159,  982, 1161, 1171,  770,
  770,  597,  770,  783,  783,  783,  783,  425, 1168, 1173,
 1172,  639, 1174, 1176, 1177, 1186,  770, 1187,  770,  770,
  770, 1185, 1189,  770, 1190,  595,  770,  770, 1197, 1198,
  603, 1427, 1428,  603,  595, 1199,  770,  783, 1200,  487,
  603,  487,  692,  603, 1202,  597, 1203,  603, 1204,  487,
 1205, 1206,  603,  770, 1243,  603, 1207,  597,  806,  636,
 1208, 1223,  487, 1242, 1253,  637, 1249, 1252,  636,  770,
 1250,  603, 1251, 1254,  637, 1257, 1260, 1460,  595, 1266,
  770, 1262, 1267,  692, 1279, 1294,  692,  492,  784, 1284,
  595, 1303,  770, 1304,  770,  603,  780, 1299,  780,  603,
  770,  692, 1275, 1308, 1178, 1314,  780, 1336,  603, 1070,
  640,  638, 1339,  639, 1335,  641,  397, 1399, 1400, 1484,
  780, 1401, 1408,  780, 1353,  603, 1411, 1487, 1415,  784,
  784,  784,  784,  784, 1416,  784, 1417, 1225,  640,  638,
  487,  639, 1423,  641, 1424, 1425,  780,  784,  784,  784,
  784, 1426,  603,  780, 1429,  780,  780, 1430,  216,  780,
 1431, 1432,  487,  780,  603, 1433,  780, 1434,  780,  487,
  780, 1435, 1436, 1437, 1438,  780,  780, 1457,  780, 1445,
  343,  784,  247, 1444, 1456,  106, 1226,  640,  638, 1459,
  639,  778,  641, 1461,  780,  780, 1462,  780,  189,  216,
 1463, 1464,  216,  487, 1466, 1465,  783, 1467,  783, 1473,
 1474,  780, 1475,  780,  780,  780,  783,  216,  780, 1476,
 1488,  780,  780,  247, 1493, 1482,  247, 1494, 1498, 1495,
 1496,  780,  778,  783,  778,  778,  778,  344, 1009, 1545,
 1013,  247, 1021, 1024, 1514, 1029, 1032, 1035,  780, 1553,
  778,  778,  778,  778, 1555, 1559,  783,  189, 1562, 1566,
 1567, 1573, 1578,  783,  780,  783,  783,  640,  638,  783,
  639,  639,  641,  783,  777,  780,  783, 1575,  783, 1552,
  783, 1579, 1551, 1589,  778,  783,  783,  780,  783,  780,
 1591, 1595, 1606,  639, 1600,  780,  852,  853,  854,  855,
  856,  857,  858,  859,  783,  783, 1605,  783, 1543, 1609,
 1620, 1623, 1624,    1,   27,  777,  580,  777,  777,  777,
  692,  783,  692,  783,  783,  783,   29,  196,  783,  222,
  692,  783,  783,  777,  777,  777,  777,  692,  350,  260,
  639,  783,  345,  346,  347,  142,  173,  174,  636,  639,
  784,  485,  784,  588,  637,  258,  422,  641,  783,   79,
  784,  206,  365,  485,  186,  348,  349,  777,  265,  485,
  222,  620,  618,  222,  783,  614,  636,  784,  350,  351,
  616,  351,  637,  187,  649,  783,  264,  648,  222,  643,
  650,  300,  315,  639,  298,  659,   25,  783,  641,  783,
  784,   28,   35, 1213,  111,  783,  383,  784,  374,  784,
  784,  373,  826,  784, 1169,  774,  641,  784,  987,   90,
  784,  692,  784, 1167,  784,  636,  692, 1165, 1155,  784,
  784,  637,  784, 1403,  215,  479,  216,  189,  216,  741,
  465, 1146,  522,  692,  901, 1106,  216,  779,  784,  784,
  692,  784,  452,  778, 1156,  778,  494, 1389,  495,  934,
  247,   91,  247,  778, 1395,  784, 1550,  784,  784,  784,
  247, 1556,  784,   92, 1554,  784,  784,  189, 1588,  721,
  778,  927, 1269, 1618,  692,  784, 1512,  108,  779, 1572,
  779,  779,  779, 1583, 1407, 1558,  189,  771,   93,  189,
  596,  975,  784,  778, 1406,  636,  779,  779,  779,  779,
  778,  637,  778,  778, 1157,  503,  778,  485,  784,  725,
  778,  476,  965,  778, 1291,  778,  763,  778,  189,  784,
  113,  444,  778,  778,  956,  778,  777,  216,  777,  657,
  779,  784,  661,  784,  905,  892,  777,  189,  887,  784,
  888,  778,  778, 1442,  778,  189,  189,  256, 1084,  216,
 1492,  247,  189,  777, 1449, 1565,  216,   94,  778, 1594,
  778,  778,  778, 1628,  670,  778,  832,   95,  778,  778,
  189, 1058, 1193,  247,  875,    0,  777,    0,  778,  595,
  247,    0,  189,  777,  189,  777,  777,    0,    0,  777,
  216,    0,   96,  777,  782,  778,  777,  234,  777,  222,
  777,    0,    0,    0,    0,  777,  777,  189,  777,    0,
   97,  778,    0,    0,  247, 1229,  640,  638,    0,  639,
    0,  641,  778,    0,  777,  777,    0,  777,    0,    0,
    0,  223,  189,    0,  778,  782,  778,  782,  782,  782,
    0,  777,  778,  777,  777,  777,    0,    0,  777,    0,
    0,  777,  777,  782,  782,  782,  782,    0, 1230,  640,
  638,  777,  639,    0,  641,    0,  641,    0,    0,    0,
    0,    0,  223,    0,    0,  223,  641,    0,  777,  641,
    0,    0,    0,    0,    0,  189,    0,  782,  641,    0,
  223,    0,    0,    0,  777,    0,    0,    0,  234,  779,
    0,  779,    0,    0,    0,  777,  189,    0,    0,  779,
    0,   90,    0,  578,    0,    0,  405,  777,  406,  777,
  234,    0,    0,    0,    0,  777,  779,  234,  189,    0,
    0,  408,    0,    0,  189,  641,  246,    0,    0,    0,
    0,    0,    0,    0,  641,    0,    0,    0,    0,  779,
    0,    0,    0,   91,    0,    0,  779,  189,  779,  779,
    0,  234,  779,  243,    0,   92,  779,    0,    0,  779,
    0,  779,    0,  779,    0,    0,  189,    0,  779,  779,
    0,  779,    0,    0,  189,  189,  725,    0,  641,    0,
   93,  189,    0,    0,    0,    0,    0,  779,  779,    0,
  779,    0,    0,    0,  243,    0,    0,  243,    0,  189,
  578,    0,    0,  405,  779,  406,  779,  779,  779,    0,
    0,  779,  243,    0,  779,  779,    0,  725,  408,    0,
  725,    0,    0,  246,  779, 1232,  640,  638,    0,  639,
    0,  641,    0,    0,    0,  725,  189,    0,    0,    0,
    0,  779,    0,    0,  636,    0,  782,  189,  782,   94,
  637,    0,    0,    0,    0,    0,  782,  779,    0,   95,
    0, 1233,  640,  638,    0,  639,    0,  641,  779,    0,
    0,    0,    0,  782,    0,    0,    0,    0,    0,    0,
  779,    0,  779,    0,   96,    0,    0,  636,  779,    0,
    0,    0,    0,  637,    0,    0,  782,    0,    0,  234,
    0,  223,   97,  782,    0,  782,  782,    0,    0,  782,
    0,    0,    0,  782,    0,    0,  782,    0,  782,    0,
  782,    0,    0,    0,    0,  782,  782,    0,  782,    0,
  386, 1234,  640,  638,    0,  639,    0,  641,    0,  387,
    0,    0,    0,    0,  782,  782,    0,  782,    0,    0,
    0,    0,  630,  388,  630,  630,  574,  630,    0,  343,
  389,  782,    0,  782,  782,  782,    0,    0,  782,    0,
  630,  782,  782,    0,    0,  630,    0,    0,  575,    0,
    0,  782,    0,    0,    0,    0,    0,    0,    0,    0,
  390,    0,    0,    0,    0, 1235,  640,  638,  782,  639,
  234,  641,    0,  708,    0,    0,    0,    0,    0,    0,
  352, 1236,  640,  638,  782,  639,    0,  641,  391,  392,
    0,    0,  234,    0,    0,  782,    0,  386,    0,  234,
  393,  243,    0,  243,  394,    0,  387,  782,  725,  782,
    0,  243,  576,    0,  708,  782,    0,  708,    0,  628,
  388,  628,  628,    0,  628,    0,  343,  389,    0,    0,
    0,    0,  708,  234,  636,    0,    0,  628,    0,    0,
  637,    0,  628,    0,    0,  575,    0,    0,    0,    0,
    0,    0, 1237,  640,  638,  577,  639,  390,  641,    0,
    0,    0,    0,    0,    0,  725,    0,  395,  725,    0,
  636,    0,    0,    0,    0,  725,  637,  396,  725,    0,
    0,    0,  725,    0,    0,  391,  392,  725,    0,    0,
  725,  345,  346,  347,  397,  173,  174,  393,    0,    0,
  244,  394,  243,    0,    0,  398,  725,    0,    0,  576,
    0,    0,    0,    0,  348,  349,  399,  400,  401,  402,
  403,    0,  404,    0,  243,    0,    0,  350,  351,    0,
  725,  243,    0,  725,  725,    0,    0,    0,    0,    0,
  636,  244,  630,  725,  244,    0,  637,    0,  630,  630,
    0,    0,  577,    0,    0,    0,    0,    0,  630,  244,
  725,    0,    0,    0,  395,  243,    0, 1340,  640,  638,
    0,  639,  630,  641,  396,    0,    0,    0,  630,  630,
    0,    0,    0,    0,    0,    0,  630,  725,  345,  346,
  347,  397,  173,  174,    0,    0,    0,    0,    0,  725,
  578,  725,  398,  405,  636,  406,    0,    0,    0,  630,
  637,  348,  349,  399,  400,  401,  402,  403,  408,  404,
  636,    0,    0,  246,  350,  351,  637,    0,    0,    0,
    0,  343,    0,    0,  170,  630,    0,  630,  630,  628,
    0, 1341,  640,  638,    0,  639,  628,  641,    0,  630,
    0,    0,    0,  630,    0,  628,    0,    0,    0,    0,
    0,    0,  407,    0,    0,  405,    0,  406,    0,  628,
    0,    0,    0,    0,    0,  628,  628,    0,    0,    0,
  408,    0,    0,  628,    0,  246,    0,    0,  344,    0,
    0,  636,  708,  170,    0,  708,    0,  637,    0,    0,
    0,    0,  708,    0,    0,  708,  628,    0,    0,  708,
    0,    0,    0,    0,  708,    0,  630,  708,    0,    0,
    0,    0,    0,    0,    0,    0,  630,    0,    0,  352,
    0,    0,  628,  708,  628,  628,    0,    0,    0,    0,
  630,  630,  630,  630,  630,  630,  628,  246,    0,    0,
  628,    0,    0,    0,  630,    0,    0,  708,    0,    0,
  708,  708,    0,  630,  630,  630,  630,  630,  630,  630,
  708,  630,    0,    0,    0,    0,  630,  630,  244,  396,
  244,    0,    0,    0,    0,    0,    0,  708,  244,    0,
    0,    0,    0,  345,  346,  347,    0,  173,  174,    0,
    0,    0,    0,    0,    0,    0,  636,    0,    0,    0,
    0,    0,  637,  628,  708,    0,  348,  349,  399,  400,
  401,  402,  403,  628,    0,    0,  708,  386,  708,  350,
  351,    0,    0,    0,    0,    0,  387,  628,  628,  628,
  628,  628,  628,    0,    0,    0,    0,    0,    0,    0,
  388,  628,    0,    0,    0,    0,  343,  389,    0,  352,
  628,  628,  628,  628,  628,  628,  628,    0,  628,    0,
    0,    0,    0,  628,  628,  575,    0,  246, 1267,  244,
  636,    0,  998,    0,    0,  999,  637,  390,    0,  386,
    0,    0,  170,    0,    0,    0,    0,    0,  387,  407,
    0,  244,  405,    0,  406,    0,    0,    0,  244,    6,
  726,    0,  388,  170,    0,  391,  392,  408,  343,  389,
 1362, 1363,  246, 1364,    0,    0, 1365,  393,    0,    0,
    0,  394,    0,    0,    0,  170,    0,    0,    0,  576,
 1366,  170,  244,    0,    0,    0, 1367,    0,    0,  390,
    0,  726,    0,  407,  726,    0,  405,    0,  406,    0,
    0,    0,    0,    0,  170,    0,    0,    0,    0,  726,
    0,  408,    0,    0,    0,    0,  246,  391,  392,    0,
  343,    0,  577,  170,    0,    0,    0,    0,    0,  393,
    0,    0,  170,  394,  395,    0,    0,    0,  170,    0,
    0,    0,    0,    0,  396,    0, 1368,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  170,    0,  345,  346,
  347,  397,  173,  174,    0,   14,    0,    0,    0,    0,
    0,    0,  398,    0,    0,    0,    0,    0,    0,    0,
 1369,  348,  349,  399,  400,  401,  402,  403, 1000,  404,
   16,    0,    0,  170,  350,  351,  395,    0,    0,    0,
    0, 1370,    0,    0,    0,    0,  396,    0,  445,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  174,
  345,  346,  347,  397,  173,  174,    0,    0,    0,    0,
    0,    0,    0,    0,  398, 1371,    0,    0,    0,    0,
    0,    0, 1178,  348,  349,  399,  400,  401,  402,  403,
  343,  404,    0,    0,    0,    0,  350,  351,    0, 1007,
  174,    0,  999,  174,    0,    0,  386,    0,  396,    0,
    0,    0,    0,    0,    0,  387,    0,    0,  174,    0,
    0,    0,  345,  346,  347,    0,  173,  174,    0,  388,
    0,    0,    0,    0,    0,  343,  389,    0,    0,    0,
    0,    0,  180,    0,    0,  348,  349,    0,    0,    0,
  402,  403,  726, 1011,    0,    0,  999,    0,  350,  351,
  386,    0,    0,    0,    0,    0,  390,    0,    0,  387,
  407,    0,    0,  405,    0,  406,    0,    0,    0,    0,
    0,    0,    0,  388,    0,    0,    0,    0,  408,  343,
  389,    0,    0,  246,  391,  392,    0,    0,    0,    0,
    0,  180,    0,    0,    0,    0,  393,    0,    0,  726,
  394,    0,  726,    0,    0,    0,    0,    0,    0,  726,
  390,    0,  726,    0,  407,    0,  726,  405,    0,  406,
    0,  726,    0,    0,  726,    0,    0,    0,  396,    0,
    0,    0,  408,    0,    0,    0,    0,  246,  391,  392,
  726,    0,  345,  346,  347,    0,  173,  174,    0,    0,
  393,    0,    0,    0,  394, 1000,    0,    0,    0,    0,
    0,  181,    0,  395,  726,  348,  349,  726,  726,    0,
  402,  403,    0,  396,    0,    0,    0,  726,  350,  351,
    0,    0,    0,    0,    0,    0,    0,  345,  346,  347,
  397,  173,  174,    0,  726,    0,    0,    0,    0,    0,
    0,  398,    0,    0,    0,    0,    0,  174,    0, 1000,
  348,  349,  399,  400,  401,  402,  403,  395,  404,    0,
  181,  726,    0,  350,  351,    0,    0,  396,  174,    0,
    0,    0,    0,  726,    0,  726,    0,    0,    0,    0,
    0,  345,  346,  347,  397,  173,  174,    0,    0,    0,
  174,    0,    0,    0,    0,  398,  174,    0,    0,    0,
    0,    0,  750,    0,  348,  349,  399,  400,  401,  402,
  403,    0,  404,    0,    0,    0,    0,  350,  351,  174,
 1019,    0,    0,  999,    0,    0,    0,  386,    0,    0,
  180,    0,    0,    0,    0,    0,  387,    0,  174,    0,
    0,    0,    0,  750,    0,    0,  750,  174,    0,    0,
  388,  180,   55,  174,    0,    0,  343,  389,    0,    0,
    0,  750,    0,   56,    0,    0,    0,    0,    0,    0,
   57,  174,    0,  180, 1022,    0,    0,  999,    0,  180,
    0,  386,    0,   58,    0,    0,    0,  390,    0,    0,
  387,  407,    0,    0,  405,    0,  406,    0,    0,    0,
    0,    0,  180,    0,  388,    0,    0,    0,  174,  408,
  343,  389,    0,    0,  246,  391,  392,    0,    0,    0,
    0,  180,    0,    0,    0,    0,    0,  393,    0,    0,
  180,  394,    0,    0,    0,    0,  180,    0,    0,    0,
    0,  390,    0,    0,    0,  407,    0,    0,  405,    0,
  406,    0,    0,    0,  180,    0,    0,    0,    0,  181,
   59,    0,    0,  408,    0,    0,    0,    0,  246,  391,
  392,    0,    0,    0,    0,    0,    0,   60,    0,    0,
  181,  393,    0,    0,    0,  394, 1000,    0,    0,    0,
    0,  180,   61,    0,  395,    0,   62,    0,    0,   63,
    0,    0,  181,    0,  396,    0,    0,   64,  181,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  345,  346,
  347,  397,  173,  174,    0,    0,   65,    0,    0,    0,
    0,  181,  398,    0,    0,    0,    0,    0,    0,    0,
 1000,  348,  349,  399,  400,  401,  402,  403,  395,  404,
  181,    0,    0,    0,  350,  351,    0,    0,  396,  181,
    0,    0,    0,    0,  750,  181,    0,    0,    0,    0,
    0,    0,  345,  346,  347,  397,  173,  174,    0,    0,
    0,    0,    0,  181,    0,    0,  398,    0,    0,    0,
    0,    0,  729,    0,    0,  348,  349,  399,  400,  401,
  402,  403,    0,  404,    0,    0,    0,    0,  350,  351,
    0, 1027,    0,    0,  999,    0,    0,    0,  386,    0,
  181,  750,    0,    0,  750,    0,    0,  387,    0,    0,
    0,  750,    0,  729,  750,    0,  729,    0,  750,    0,
    0,  388,    0,  750,    0,    0,  750,  343,  389,    0,
    0,  729,    0,    0,    0,    0,    0,    0,    0,   76,
    0,    0,  750,    0,    0, 1030,   77,    0,  999,    0,
   78,   79,  386,    0,    0,    0,    0,    0,  390,   80,
    0,  387,  407,    0,    0,  405,  750,  406,    0,  750,
  750,   81,    0,    0,    0,  388,    0,    0,    0,  750,
  408,  343,  389,    0,    0,  246,  391,  392,    0,    0,
    0,    0,    0,    0,    0,    0,  750,    0,  393,    0,
    0,    0,  394,  868,    0,    0,    0,    0,  407,    0,
  424,  405,  390,  406,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  750,    0,    0,  408,    0,    0,    0,
    0,  246,    0,    0,    0,  750,   82,  750,    0,    0,
  391,  392,    0,    0,  868,    0,    0,  868,    0,  880,
    0,    0,  393,   83,    0,    0,  394, 1000,    0,    0,
    0,    0,  868,    0,  868,  395,    0,    0,   84,    0,
    0,    0,   85,    0,    0,  396,    0,    0,    0,    0,
    0,    0,    0,   86,    0,    0,    0,    0,    0,  345,
  346,  347,  397,  173,  174,    0,    0,    0,    0,    0,
    0,    0,   87,  398,    0,  862,    0,  862,  862,    0,
  862, 1000,  348,  349,  399,  400,  401,  402,  403,  395,
  404,    0,    0,  862,    0,  350,  351,    0,  862,  396,
    0,    0,    0,    0,  729,    0,    0,    0,    0,    0,
    0,    0,    0,  345,  346,  347,  397,  173,  174,    0,
    0,    0,    0,    0,    0,    0,    0,  398,    0,    0,
    0,    0,    0,    0,    0,    0,  348,  349,  399,  400,
  401,  402,  403,    0,  404,    0,    0,    0,    0,  350,
  351,    0, 1033,    0,    0,  999,    0,    0,    0,  386,
    0,  729,    0,    0,  729,    0,    0,    0,  387,    0,
    0,  729,    0,    0,  729,    0,    0,    0,  729,    0,
    0,    0,  388,  729,    0,    0,  729,    0,  343,  389,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  729,    0,    0,  386,    0,    0,    0,    0,
    0,    0,    0,    0,  387,    0,    0,    0,  630,  390,
    0,  630,    0,  630,    0,    0,  729,    0,  388,  729,
  729,    0,    0,    0,  343,  389,  630,  868,  868,  729,
    0,  630,    0,    0,    0,    0,    0,  391,  392,    0,
    0,    0,    0,  868,    0,    0,  729,    0,    0,  393,
    0,    0,    0,  394,    0,  390,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  868,    0,  868,    0,
    0,    0,    0,  729,    0,    0,    0,    0,    0,    0,
    0,  344,  868,  391,  392,  729,    0,  729,    0,    0,
    0,  407,  862,    0,  405,  393,  406,    0,    0,  394,
    0,  862,    0,    0,  868,    0,    0,    0, 1000,  408,
    0,    0,    0,    0,  246,  862,  395,    0,    0,    0,
    0,  862,  862,    0,    0,    0,  396,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  345,  346,  347,  397,  173,  174,    0,    0,    0,    0,
    0,    0,  862,    0,  398,    0,    0,    0,    0,    0,
    0,    0,  395,  348,  349,  399,  400,  401,  402,  403,
    0,  404,  396,    0,  868,    0,  350,  351,  862,    0,
  862,  862,    0,    0,    0,    0,  345,  346,  347,  397,
  173,  174,  862,    0,    0,    0,  862,    0, 1267,    0,
  398,    0,    0,    0,    0,    0,    0,    0,    0,  348,
  349,  399,  400,  401,  402,  403,    0,  404,    0,    0,
    0,    0,  350,  351,    0,    0,    0,    0,  630,    6,
    0,    0,    0,    0,  407,  630, 1468,  405,    0,  406,
 1362, 1363,    0, 1364,  630,    0, 1365,    0,    0,    0,
    0,    0,  408,    0,    0,    0,    0,  246,  630,  862,
 1366,    0,    0,    0,  630,  630, 1367,    0,    0,  862,
    0,    0,  630,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  862,  862,  862,  862,  862,  862,    0,
    0,    0,    0,    0,    0,  630,    0,  862,    0,    0,
    0,    0,    0,    0,    0,    0,  862,  862,  862,  862,
  862,  862,  862,    0,  862,    0,    0,    0,  386,  862,
  862,    0,    0,  630,  630,    0, 1368,  387,    0,    0,
    0,  407,  865,    0,  405,  630,  406,    0,    0,  630,
    0,  388,    0,    0,    0,   14,    0,  343,  389,  408,
    0,    0,    0,    0,  246,    0,    0,    0,    0,    0,
 1369,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   16,    0,    0,    0,    0,    0,    0,  407,  390, 1469,
  405, 1370,  406,    0,    0,    0,    0,    0,  445,    0,
    0,    0,    0,    0,    0,  408,    0,    0,    0,    0,
  246,    0,  630,    0,    0,    0,  391,  392,    0,    0,
    0,    0,  630,    0,    0, 1371,    0,    0,  393,    0,
    0,    0,  394,    0,    0,    0,  630,  630,  630,  630,
  630,  630,    0,    0,    0,    0,    0,    0,    0,    0,
  630,    0,    0,    0,    0,    0,    0,    0,    0,  630,
  630,  630,  630,  630,  630,  630,    0,  630,    0,    0,
    0,  386,  630,  630,    0,    0,    0,    0,    0,  630,
  387,    0,    0,    0,  407,    0,    0,  405,    0,  406,
    0,    0,    0,    0,  388,  395,    0,    0,    0,    0,
  343,  389,  408,    0,    0,  396,    0,  246,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  345,
  346,  347,  397,  173,  174,    0,    0,    0,    0,    0,
    0,  390,    0,  398,    0,    0,    0,    0,    0,    0,
    0,    0,  348,  349,  399,  400,  401,  402,  403,    0,
  404,    0,    0,    0,    0,  350,  351,  344,    0,  391,
  392,    0,    0,    0,    1,    0,    0,  407,  386,    0,
  405,  393,  406,    0,    0,  394,    0,  387,    0,    0,
    0,    0,    0,    0,    0,  408,    2,    0,    0,    0,
  246,  388,    0,    0,    3,    0,    0,  343,  389,    0,
    0,    4,    0,    5,    0,    6,    0,    0,    0,    0,
    7,    0,    0,    0,  386,    0,    0,    8,    0,    0,
    0,    0,    0,  387,    0,    0,    0,    0,  390,    0,
    0,    9,    0,    0,    0,    0,  862,  388,  395,  862,
    0,  862,   10,  343,  389,    0,    0,    0,  396,    0,
    0,    0,    0,    0,  862,    0,  391,  392,    0,  862,
    0,    0,  345,  346,  347,  397,  173,  174,  393,    0,
    0,    0,  394,    0,  390,    0,  398,    0,    0,    0,
    0,    0,    0,    0,    0,  348,  349,  399,  400,  401,
  402,  403,    0,  404,    0,    0,    0,    0,  350,  351,
    0,    0,  391,  392,    0,    0,    0,    0,    0,   11,
    0,  386,    0,    0,  393,    0,   12,    0,  394,   13,
  387,   14,   15,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  388,  395,    0,    0,    0,    0,
  343,  389,    0,    0,    0,  396,   16,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  345,
  346,  347,  397,  173,  174,    0,    0,    0,    0,    0,
    0,  390,    0,  398,    0,    0,    0,    0,    0,    0,
    0,  395,  348,  349,  399,  400,  401,  402,  403,    0,
  404,  396,    0,   17,  386,  350,  351,    0,    0,  391,
  392,    0, 1025,  387,    0,  345,  346,  347,  397,  173,
  174,  393,  727,    0,    0,  394,    0,  388,    0,  398,
    0,    0,    0,  343,  389,    0,    0,    0,  348,  349,
  399,  400,  401,  402,  403,    0,  404,    0, 1311, 1312,
    0,  350,  351,    0,    0,    0,    0,    0, 1317, 1318,
    0, 1320, 1321,  727,  390,    0,  727,    0,    0, 1325,
 1326, 1327, 1328,  862, 1329, 1330, 1331, 1332, 1333, 1334,
    0,  727,  862,    0,    0,    0,  728,    0,  395,    0,
    0,    0,  391,  392,    0,    0,  862,    0,  396,    0,
    0,    0,  862,  862,  393,    0,  758,    0,  394, 1195,
    0,    0,  345,  346,  347,  397,  173,  174,    0,    0,
    0,    0,    0,    0,    0,    0,  398,  728,    0,    0,
  728,    0,    0,  862,    0,  348,  349,  399,  400,  401,
  402,  403,    0,  404,    0,  728,    0,  758,  350,  351,
  758,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  862,  862,    0,    0,  758,    0,    0,    0,  722,
    0,  395,    0,  862,    0,    0,    0,  862,    0,    0,
    0,  396,  523,    0,    0,    0,  524,    0,    0,  723,
    0,    0,    0,    0,  705,  345,  346,  347,  397,  173,
  174,    0,    0,    0,    0,  525,    0,    0,  526,  398,
  722,    0,    0,  722,    0,    0,    0,    0,  348,  349,
  399,  400,  401,  402,  403,    0,  404,    0,  722,    0,
  723,  350,  351,  723,    0,    0,    0,    0,    0,    0,
  862,    0,    0,    0,    0,    0,    0,    0,  723,  527,
  862,    0,    0,  724,    0,  528,  529,  530,    0,  531,
  532,  533,    0,  534,  862,  862,  862,  862,  862,  862,
    0,    0,    0,  757,    0,    0,    0,    0,  862,    0,
    0,    0,    0,  535,  727,  536,    0,  862,  862,  862,
  862,  862,  862,  862,  724,  862,    0,  724,    0,    0,
  862,  862,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  724,    0,  757,    0,  537,  757,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  757,  538,    0,    0,  751,  600,    0,    0,
    0,  727,    0,    0,  727,    0,    0,    0,  728,    0,
    0,  727,    0,    0,  727,  539,    0,  759,  727,    0,
    0,    0,    0,  727,    0,    0,  727,    0,  758,    0,
  178,    0,    0,    0,    0,    0,    0,  751,  600,    0,
  751,  600,  727,    0,    0,    0,    0,    0,    0,    0,
  540,  541,    0,    0,    0,  751,  600,    0,  759,    0,
    0,  759,    0,    0,    0,  728,  727,    0,  728,  727,
  727,    0,    0,    0,    0,  728,  759,    0,  728,  727,
  760,    0,  728,    0,    0,  758,    0,  728,  758,    0,
  728,  722,    0,    0,    0,  758,  727,    0,  758,    0,
  748,    0,  758,    0,    0,    0,  728,  758,    0,    0,
  758,  723,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  760,    0,  727,  760,    0,  758,    0,    0,    0,
  728,    0,    0,  728,  728,  727,    0,  727,    0,  760,
    0,  748,    0,  728,  748,    0,    0,    0,  722,    0,
  758,  722,    0,  758,  758,    0,    0,    0,  722,  748,
  728,  722,    0,  758,  752,  722,    0,    0,  723,    0,
  722,  723,    0,  722,    0,  724,    0,    0,  723,    0,
  758,  723,    0,    0,    0,  723,    0,  728,    0,  722,
  723,    0,    0,  723,    0,  757,    0,    0,    0,  728,
    0,  728,    0,    0,    0,  752,    0,  758,  752,  723,
    0,    0,    0,  722,    0,    0,  722,  722,    0,  758,
    0,  758,    0,  752,    0,    0,  722,  761,    0,    0,
    0,    0,  724,  723,    0,  724,  723,  723,    0,    0,
    0,    0,  724,  722,    0,  724,  723,  749,    0,  724,
    0,    0,  757,    0,  724,  757,    0,  724,  751,    0,
    0,    0,  757,  723,    0,  757,    0,    0,  761,  757,
  722,  761,    0,  724,  757,    0,    0,  757,    0,  759,
    0,    0,  722,    0,  722,    0,  761,    0,  749,    0,
  723,  749,    0,  757,    0,    0,    0,  724,    0,    0,
  724,  724,  723,    0,  723,    0,  749,    0,    0,    0,
  724,  753,    0,    0,    0,  751,  600,  757,  751,  600,
  757,  757,    0,    0,    0,  751,  600,  724,  751,  600,
  757,    0,  751,  600,    0,    0,  759,  751,  600,  759,
  751,  600,  760,    0,    0,    0,  759,  757,    0,  759,
    0,    0,  753,  759,  724,  753,  751,  600,  759,    0,
    0,  759,  748,    0,    0,    0,  724,    0,  724,    0,
  753,    0,    0,    0,  757,    0,    0,  759,    0,    0,
  751,  600,    0,  751,  751,  600,  757,    0,  757,    0,
    0,    0,    0,  751,  600,    0,    0,    0,    0,  760,
    0,  759,  760,    0,  759,  759,    0,    0,    0,  760,
  751,  600,  760,    0,  759,    0,  760,    0,    0,  748,
    0,  760,  748,    0,  760,    0,  752,    0,    0,  748,
    0,  759,  748,    0,    0,    0,  748,  751,  600,    0,
  760,  748,    0,    0,  748,    0,    0,    0,    0,  751,
  600,  751,    0,    0,    0,    0,    0,    0,  759,    0,
  748,    0,    0,    0,  760,    0,    0,  760,  760,    0,
  759,    0,  759,    0,    0,    0,    0,  760,    0,    0,
    0,    0,    0,  752,  748,    0,  752,  748,  748,  761,
    0,    0,    0,  752,  760,    0,  752,  748,    0,    0,
  752,    0,    0,    0,    0,  752,    0,    0,  752,  749,
    0,  863,  640,  638,  748,  639,    0,  641,    0,    0,
    0,  760,    0,    0,  752,    0,    0,    0,    0,    0,
  804,  803,  805,  760,    0,  760,    0,    0,    0,    0,
    0,  748,    0,    0,    0,    0,  761,    0,  752,  761,
    0,  752,  752,  748,    0,  748,  761,    0,  292,  761,
    0,  752,    0,  761,    0,    0,  749,    0,  761,  749,
    0,  761,    0,  753,    0,    0,  749,    0,  752,  749,
    0,    0,    0,  749,    0,    0,    0,  761,  749,  292,
    0,  749,    0,    0,    0,    0,  292,    0,    0,    0,
  292,  292,    0,  292,    0,  752,  292,  749,    0,    0,
    0,  761,    0,    0,  761,  761,    0,  752,    0,  752,
  292,    0,    0,    0,  761,    0,  292,    0,    0,    0,
  753,  749,    0,  753,  749,  749,    0,    0,    0,    0,
  753,  761,    0,  753,  749,  640,  638,  753,  639,    0,
  641,    0,  753,    0,    0,  753,    0,    0,    0,    0,
    0,  749,    0,  804,  803,  805,    0,    0,  761,    0,
    0,  753,    0,    0,    0,    0,    0,    0,    0,    0,
  761,    0,  761,    0,    0,    0,  292,    0,  749,    0,
    0,    0,    0,    0,    0,  753,    0,    0,  753,  753,
  749,    0,  749,    0,    0,  292,    0,    0,  753,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  292,    0,    0,    0,    0,  753,    0,    0,    0,    0,
  292,    0,    0,    0,    0,    0,    0,    0,    0,  292,
    0,  292,  791,    0,    0,    0,    0,    0,  292,    0,
  636,  214,  753,    0,    0,  214,  637,    0,    0,  792,
    0,    0,    0,    0,  753,    0,  753,  777,    0,    0,
  214,  524,    0,    0,  214,  292,    0,  214,    0,    0,
    0,    0,    0,    0,    0,    0,  778,    0,    0,    0,
  525,    0,    0,  526,    0,  793,    0,    0,    0,    0,
    0,    0,    0,    0,  794,    0,    0,    0,    0,    0,
    0,    0,  795,    0,    0,    0,    0,    0,  214,    0,
    0,    0,    0,    0,  214,  214,  214,    0,  214,  214,
  214,  796,  214,  797,  527,    0,    0,    0,    0,    0,
  528,  529,  530,    0,  531,  532,  533,  798,  534,  799,
  800,  801,  214,    0,  214,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  535,    0,
  536,    0,    0,    0,    0,  791,    0,    0,    0,    0,
    0,    0,    0,  636,    0,  214,    0,    0,    0,  637,
   78,    0,  792,    0,    0,    0,    0,    0,    0,    0,
  802,  537,  214,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  523,    0,    0,    0,  524,    0,  538,    0,
    0,    0,    0,    0,  214,  214,    0,    0,  793,  214,
    0,    0,    0,    0,    0,  525,    0,  794,  526,    0,
  539,    0,    0,    0,  214,  795,    0,    0,  214,    0,
    0,  214,    0,    0,    0,    0,    0,    0,    0,  214,
  214,    0,    0,    0,  796,    0,  797,    0,    0,    0,
    0,    0,    0,    0,    0,  540,  541,    0,    0,  527,
  798,    0,  799,  800,  801,  528,  529,  530,    0,  531,
  532,  533,  214,  534,    0,    0,    0,    0,  214,  214,
  214,    0,  214,  214,  214,    0,  214,    0,    0,    0,
    0,    0,    0,  535,  523,  536,    0,    0,  524,    0,
    0,    0,    0,    0,    0,    0,  214,    0,  214,    0,
    0,    0,    0,  802,    0,  127,    0,  525,    0,  127,
  526,    0,    0,    0,    0,    0,  537,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  127,  214,
    0,  127,    0,  538,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  214,    0,    0,    0,
    0,  527,    0,    0,    0,  539,    0,  528,  529,  530,
    0,  531,  532,  533,    0,  534,    0,    0,  214,    0,
  178,    0,  127,    0,    0,    0,    0,    0,  127,  127,
  127,    0,  127,  127,  127,  535,  127,  536,    0,    0,
  540,  541,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  214,  214,    0,  127,    0,  127,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  537,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  538,    0,    0,    0,  127,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  134,
    0,    0,    0,    0,    0,    0,  127,  539,  135,  136,
  137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
  147,  148,  149,  150,  151,  152,  153,  154,  127,  155,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  540,  541,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  501,    0,    0,    0,
    0,    0,    0,  127,  127,  135,  136,  137,  138,  139,
  140,  141,  142,  143,  144,  145,  146,  147,  148,  149,
  150,  151,  152,  153,  154,  418,  155,    0,    0,    0,
    0,    0,    0,    0,    0,  418,  418,  418,  418,  418,
  418,  418,  418,  418,  418,  418,  418,  418,  418,  418,
  418,  418,  418,  418,    0,  418,
};
static short yycheck[] = {                                      16,
   48,   56,    4,  125,    4,   57,   49,   96,    0,   55,
  224,  224,  224,   50,  281,   56,   59,  114,  115,  114,
  115,  316,   60,  324,   61,   77,  320,  324,  449,  293,
  576,  674,  578,   81,  484,  455,  493,  487,  295,   82,
   62,   86,   65,  493,  431,   83,   89,  131,   45,  630,
  105,  619,  107,  232,   80,  682,  376,    0,   75,  933,
    0,   40,  241,   85,   87,    0,   40,   84,  862,  106,
  944,   40,   45,   40,    0,   45,   45,  614,   44,   40,
  338,   41,   63,  126,   63,   42,  960,   40,   59,  679,
  127,    0,  879,  119,   41,   41,   40,   58,   44,    0,
  970,    0,    0,  671,  954,  187,   44,    0,  197,  382,
   42,   44,   42,  159,    0,   41,   59, 1116,   44,   59,
   44,   44,   40,   44,   59,   44, 1240,  570,   41,  224,
 1052,   40,   41,   59,   44,   44,   44,  183,  264,  353,
  353,  353,  925,   91,    0,   63,  932,    0,  264,  932,
   59,   45,  274, 1152,    0,    0,    0,   40,   59,  281,
   59,   59,   44,  284,    0,  742,   59,   58, 1253,  463,
  260,  226,    0,   59,  288,  470,  471,  472,  473,   41,
  288,  239,   91, 1121,  288, 1161, 1441,  274,   41,  368,
  260,   44,  493,  230,  309,  277,  493,   41,  282,  274,
   44,  321,  239,   59,  925,    0,   59,    0,    0,  302,
  258,  932,   12,   59,   59,   59,    0,   40, 1489,  274,
  277,  357,    0,   59,  518,  262,  647,  287, 1098,  257,
  388,   59,  496,   45,  378,  378,  925,  257, 1045,  294,
 1047,   45,  273,  932,    0,    0,  301,    0,  303,   41,
  305,   44,   44,  308,  376,  329, 1130, 1256,  353,   63,
  806,  807,   44,  831,   59,  523,   59,   59, 1523,   59,
  456,  317,  262,  319,    0,   59,  419,   41,  728,  543,
   44,   59, 1003,  441,  330,  459,  334,  824,   41,  346,
 1561,   44,  326,  377,  430,  332,  412, 1147,  835,  836,
 1087,  320,    0,   59,   59,  449,   59,  335, 1563,  321,
  341,  285,  112,   41, 1003,  335,   44,  437,    0,  440,
  494,  376, 1593,  466,  367, 1301,  384,  364,  418,  277,
  260, 1261,  258,   59, 1272,  461,  338,  452,  375,  382,
  297,  264,  379,   41,  617,    0,   44,  384,  418,  258,
  443,  277,  278,  461,  280, 1141,    0,  461, 1141,  285,
 1445,   59,  288,  750, 1158,  274, 1296,  305,  277,  278,
  444,  280,  332, 1487,  304,  301,  285,   59,  924,  288,
  467,  307,  401,  597,  597,  597,  269,  461,  321,   44,
  980, 1265,  301,   91, 1268,  976, 1270,  387,  307, 1398,
    0,  310,  462,  463,   59,    0,  319, 1277,  490,  319,
  677,  264,  258,  510, 1336,   59, 1223,  451,   41,  264,
 1141, 1295,  468,  442,    0,    0,  690,  606,  264,  693,
  258,  614,   41,  319,  278,   44,  280,  397,  493,  321,
  411,  285,  343,  707,  288,   40,   41,    0,  310,   44,
  397,  349, 1141,  379,  397,  341,  349,  301, 1308,   59,
   41,  307,  459,  432,   59, 1252,  412,  513,  321,  368,
  379,  437,  736,  511, 1101,  401, 1053,  378,  459,  307,
  459, 1355,  408,   59,   59, 1359,  459,  461,   41,  459,
  459,  417,  401,  419,  461,  448,   91,  494,  441,  408,
  461,  441,  597,  412,  461,  406,   59,  562,  409,  829,
  419,  437,  455,  559,  560,  455,  442,  461,  775, 1313,
  455,  523,    0, 1397,  425, 1062,  784,  319,  437,  461,
  322,  455, 1406,  442,  453,  379,  329,  329,  459,  332,
  332,  459,  985,  598,  336,  471,  668,  455,  343,  341,
  451,  344,  344,  398,  410,  677,  653,  401,  467, 1136,
  258, 1107,  471,   41,  408,  459,   44,  461,  360,  571,
  461,  571,  395,  419,  617,  689,  274,  332, 1124,  277,
  278,   59,  280,  378,  368,  341,    0,  285,  685,  686,
  288,  419,  384,  668, 1315,  621,  388, 1178,  442,    0,
  453,  280,  384,  301,  397,  397,  356,  286,  461,  307,
 1484,  406,  310,  668,  409,  341,  714,  912,  673,  265,
  432,  411,  414,  403,  679,  662, 1315,  664,  432,  406,
  425,  384,  403, 1260,  813,  681,  682,  816,    0,  262,
   41,  824,  397,   44,  699,   59,   41,  459,  441,  441,
  688,  326,  835, 1221,  273,  459,  451,  303,   59,  341,
  453,  453,  455,  258,  435,  274,  930,  284,    0,  461,
  461,    0,  727,  728,  329,    0,  971,  332,  942,  274,
  457,  379,  277,  278,    0,  280,  441,    0,  726,  344,
  285,    0,   12,  288,    0,  959,    0,   59,   41,  343,
  455,  310,  786,  401,  788,  278,  301,  829, 1254,   59,
  408,  925,  307,  925,  412,  310,   41,   41,  932,   44,
  932,  419,  760,  761,  762,   41,  983,   59,   41,  329,
   59,   44,  332,  735,   59,   41,  773,   41,   44,  437,
  279,  491,  397,   59,  442,  747,   59,  320,  329,  461,
   59,  332, 1139,   59,  329,   59,  431,  332, 1145,   41,
    0,  258,  406,  438,  387,  409,  319,  343,  385,  467,
 1227,  814,  817,  471,  829,    0,  329,    0,   91,  332,
  258,  425,  784,  260,  379,  349,  441,    0,  341, 1003,
 1003,  330,  112,  815,   42,  818,  274,  397,  453,   47,
  455, 1444,  378,  412,   44,  258,  401,  451, 1065,   41,
  307,   41,    0,  408,   44,    0,  397,  412,   41,   59,
 1498,  265,  397,  440,  419,  364,    0,  304,  401,  307,
  406,  398,  310,  409,   59,  388,   59,    0,  936,  937,
  457,  441,  437,  382,  397,  259,   59,  442,    0,  425,
  264, 1271,   44,  453,  307,  455,  270,  258,  467,  303,
  957, 1155, 1518,   93, 1128, 1285,  441,  262,  302,  442,
  437,   59,  467, 1085,   59,  451,  471,  278,   41,  280,
  455,   44,  980,  268,  285,   59,  263,  288,  441,   41,
  461,  301,   44, 1157,  338, 1573,   59, 1443,  462,  463,
  301,   93,  455, 1559,  471,  339,  307,   59, 1003,   42,
   43, 1361,   45, 1459,   47,  702, 1462,  279,  973,  262,
 1598,  461,  419, 1344,  711,  980, 1227, 1141,  966, 1141,
 1227,  461,  302,  258,  412, 1591,  313,  410,  262,  301,
  437,  419,    0,  353,  982,  258,  278,  324,  280,  951,
  988,  951,  277,  278,  406,  280, 1051, 1052, 1053,  437,
  285,  274, 1257,  288, 1086,  278,  419,  280,  330,  339,
    0,  206,  285,  260,  471,  288,  301,  764,  379,  214,
  262,  366,  307,  459,  398,  322, 1253,  349,  301,  467,
  319,  461,  387,  471,  307,  418,  358,  310,    0,  336,
  401,   59,  364,  319,   44,  457, 1103,  408, 1105,  443,
 1274,   41,  341,  319,   44,  319,  332,  304,  419, 1526,
  382,  418,  445,  360,  245,  341,  332, 1379,  249,   59,
  262,   44,  280,  254,  343,  341,  437,  341,  286, 1303,
 1078,  442,   44,  459,  387,  461,   59,  379,  445, 1051,
 1052,  428,  461,   93,  379, 1101, 1153,   59,  379,  461,
    0,   91, 1483,  387,    0,  278,  379,  280,    0,  378,
  471,    0,  388,  443,  461, 1621,  401,  414,  344,    0,
  401,  397,  388,  408,  388, 1592,  459,  408,  401,  344,
  278,  397,  280,  397,  419,  408,  319,  406,    0,  412,
  409, 1315, 1315,  369, 1525,  387,  419, 1614,   44,  332,
  461,    0,  437,  900,  369,  353,  425,  442,  341,   59,
    0,  442, 1168,   59,  437,  441, 1172,   59,  323,  442,
   59, 1253, 1134, 1345, 1134,  441,  435,  441,   59,  455,
  323,  379,  451,  444,    0, 1267,  471,  280,  402,  455,
    0,  455,   41,  286,  467,  387,  943,   59,  471,  322,
  461,  427,  461,    0,    0,  388,  329,  319,  258,  332,
   59,  261,  427,  336,  397,  317,  318,  329, 1445,   59,
  332,  344,   40,  461,  405,  406,  407,   45,  321,  341,
    0,   44,  344,    0,  322,  461, 1548,  360,  404, 1466,
   58,   42,   43,   59,   45,   40,   47,   44,  336,   59,
   41, 1266, 1267,   44, 1260,  421,  344,  307,  441,  260,
 1315,  384,   59,   59,  295, 1266, 1578, 1579,  258, 1520,
 1497, 1498,  360,  384,  397,  306,  388,    0, 1275,   44,
   93, 1336,  313,    0,  274,  397,    0,  272,  278,   59,
  280,  414,   59,   44, 1606,  285,    0, 1379,  288, 1356,
  260,  302,   93,    0,  289, 1532, 1557,  338, 1620,   42,
   43,  301,   45,  314,   47,  406, 1543,  307,  441,  384,
  310,  260,    0, 1497, 1497, 1497,  414,    0,   93,  441,
  453,  260,  455,  338,  425,  386,   59,   41,  339, 1590,
   44,  453,   59,  384,  304,   59, 1573, 1396, 1575,  334,
 1362,   42,   43,    0,   45,   59,   47,  319, 1532, 1532,
 1532, 1612,   59, 1445, 1379,  304,    0,  466,    0,  468,
  375, 1598,  403,  384, 1336,  304,    0,  259,  363,  341,
 1342,   59,  357,  388, 1466,  493,   59,   91,  270,  379,
    0,  349,   41,   42,   43, 1392,   45,  578,   47,  419,
  358, 1575, 1575, 1575,  435, 1411,    0,  408,  439, 1415,
   45,  401,   59, 1365,    0, 1497, 1498,  418,  408,  394,
  338,  396,  412,   58,    0,   59,  322,   59, 1477,  419,
    0,   41,   40,  329,   44,   59,  332,   45,  619,  461,
  336,  622,  443,  274,  419,  430,  627,  437,  344,   59,
 1532,  319,  442, 1456,  635,   63,  637,  638,  639,  640,
  641, 1543,  643,  288,  360,   59, 1548,  648,  265,  444,
  319,   41,    0,   59,   44,  259,  301,  467,  296,  280,
   40,  471,  338,   59,    0,  286,  270,  425,  384,   59,
  671, 1573,  341, 1575, 1506, 1466, 1578, 1579,   41,   42,
   43,  397,   45,  462,   47, 1482,  303,  264,    0,   16,
   42,   43,  302,   45,    0,   47, 1598, 1494,  414,  375,
  321,  319,  319,  419, 1606,   41, 1497, 1498,   44,  492,
  493,   59,  388, 1548,    0,  353,  317,   41, 1620,  388,
   44, 1518,  461,   59,  341,  441, 1508,  280, 1508,  339,
 1527,  462,  463,  286,  258,   41,  338,  453,   44,  455,
  644, 1532, 1570, 1578, 1579,  337,  343,   59,   75,  453,
  274,  262, 1543,   59,  278,   41,  280,   41,   44,  312,
   44,  285, 1559,  667,  288, 1045,  403, 1047,    0,  280,
 1567, 1606,  441,   59,  678,  286,  341,  301,  458,  459,
  460,  378, 1573,  307, 1575, 1620,  310,   40,  279,  321,
  791,  792,  793,  319, 1591,  796,  797,  798,  408,  800,
  801,  802,  803,  804,  805,  462,  463, 1598,  418,  406,
  301,  280,  409,  437,  494,  495,  329,  286,  384,    0,
  458,  459,  460,  461,  462,  463,  384,   59,  425,  618,
  831,  620,  262,  443,  623,  624,  625,  838,  839,  330,
  841,  296,  843,  481,  482,  846,  847,  848,  849,  850,
  851,  392,  393,  403,  451,  379,  494,  495,  349,   40,
   41,   42,   43,   44,   45,   46,   47,  358,  296,   42,
   43,  322,   45,  364,   47,  675,  676,  401,   59,   60,
   61,   62,  362,  322,  408,  336,  322,  451,  412,  319,
  403,  382,  322,   41,    0,  419,   44,  336,  353,  329,
  336,   41,  332,  418,   44,  435,  336,  461,  344,  360,
   91,  341,   93,  437,  344,  443,   41,  280,  442,   44,
  358,  360,  288,  286,  360,  353,  439,    0,  280,    0,
  360,  444,  470,  384,  286,   41,   41,  450,   44,   44,
  412,   44,  278,  467,  280,  384,   61,  471,  461,  285,
  373,   40,  288,   59,  384,  287,  469,  387,  388,   41,
  312,   41,   44,  414,   44,  301,   41,  397,   41,   44,
   41,   42,   43,   44,   45,  414,   47,   41,  414,   41,
   44,  264,   44,   40,  414,  462,   59,  462,   59,   60,
   61,   62,  278,   41,  280,   41,   44,   41,   44,  462,
   44,    0,  288,  458,  459,  460,  461,  462,  463,   41,
   44,  441,   44, 1014, 1015,  301, 1017, 1018,  437,  461,
  321,   44,   93,  453, 1025,  455,  481,  482,  403,   40,
  458,  459,  460,   40,  462,  463,   40,   40,   40,  494,
  495,  461,   41,  379,   40,   44,   40,  279,   40,   40,
   40,    0,   40,  481,  482,   91,  321,   46,   44,   44,
   59,  429,   46,   61,   40,  401,  494,  495, 1069,  301,
  280,   44,  408,  383,   46,  349, 1077,   44, 1079, 1080,
  278,  262,  278,  264, 1085,  301,  264,  461,  437,  262,
  398,  272,   41,  379,  471,   44,  398,  459,  330,  280,
  277,  448,  448,  400,   40,  286,  442,  280,  289,  350,
   59,   42,   43,  286,   45,  401,   47,  349, 1119,   41,
   42,   43,  408,   45,    0,   47,  358,   40,   59,   91,
   40,  312,  364,   40,  264,  384,  412,  383,  319,   44,
  321,  322,  390,   40,  325,   40,  437,  465,  329,  318,
  382,  332,   40,  334,  321,  336,  442,  321,   41,  453,
  341,  342,  461,  344,  449,   41,   42,   43,   44,   45,
  264,   47,  461,   40, 1175,  277,  274,  459,   40,  360,
  361,  301,  363,   59,   60,   61,   62, 1188,  285,  345,
  345,  262,  278,  264, 1195,  419,  377,  417,  379,  380,
  381,  272,  301,  384,  419,   40,  387,  388,  357,  280,
  418,   40,   40,  319,  274,  286,  397,   93,  289,   45,
 1221,  461,   44,  329,  386,  368,  332,   44,  321,  264,
   41,   44,   40,  414,    0,  341,  321,   63,  344,  280,
   44,  312,    0,   44,  266,  329,  319,   40,  319,  430,
  321,  322,   40,  300,  325,  264,  329,  461,  329,  332,
  441,  332,  423,  334,   41,  336,   58,   41,  341,   41,
  341,  342,  453,  344,  455,   41,   42,   43,   44,   45,
  461,   47,  388,   41,   41,  455,  395,  441,  491,  360,
  361,  397,  363,   59,   60,   61,   62, 1298,  310,   41,
  310,   59,   41,   40,   40,   40,  377,   40,  379,  380,
  381,  353,   40,  384,   40,  388,  387,  388,   40,   40,
  319, 1322, 1323,  322,  397,   40,  397,   93,   40,  278,
  329,  280,    0,  332,   40,  441,   40,  336,   40,  288,
   40,   40,  341,  414, 1345,  344,   40,  453,  262,  280,
  328,   44,  301,   41,  274,  286,  389,  344,  280,  430,
  389,  360,  389,  332,  286,  423,  391, 1368,  441,  447,
  441,  392,  271,   41,   41,   41,   44,  288,    0,  379,
  453,   40,  453,   41,  455,  384,  262,  278,  264,  388,
  461,   59,  408,   41,  418,   41,  272,  437,  397,   41,
   42,   43,   41,   45,  386,   47,  461,   41,   41, 1410,
  286,  353,  386,  289,  397,  414,  372, 1418,  372,   41,
   42,   43,   44,   45,   41,   47,   41,   41,   42,   43,
  379,   45,   41,   47,   41,   41,  312,   59,   60,   61,
   62,   41,  441,  319,   41,  321,  322,   41,    0,  325,
   41,   41,  401,  329,  453,   41,  332,   41,  334,  408,
  336,   41,   41,   41,   41,  341,  342,   59,  344,   44,
  296,   93,    0,  280,  403,  341,   41,   42,   43,   40,
   45,    0,   47,   59,  360,  361,   40,  363,    0,   41,
   59,   59,   44,  442,  341,   59,  262,   59,  264,   59,
   41,  377,  353,  379,  380,  381,  272,   59,  384,  345,
   41,  387,  388,   41,  369,  321,   44,   40,  341,   59,
   59,  397,   41,  289,   43,   44,   45,  353,  796,  461,
  798,   59,  800,  801,  384,  803,  804,  805,  414,  384,
   59,   60,   61,   62,  384,   44,  312,   59,   41,   41,
   44,  411,  436,  319,  430,  321,  322,   42,   43,  325,
   45,  319,   47,  329,    0,  441,  332,   44,  334,  443,
  336,  305,  302,   41,   93,  341,  342,  453,  344,  455,
  344,   40,  305,  341,   59,  461,  473,  474,  475,  476,
  477,  478,  479,  480,  360,  361,  294,  363,   44,  464,
  308,   44,   41,    0,  384,   41,  338,   43,   44,   45,
  278,  377,  280,  379,  380,  381,  384,   40,  384,    0,
  288,  387,  388,   59,   60,   61,   62,  264,  278,  264,
  388,  397,  458,  459,  460,  459,  462,  463,  280,  397,
  262,  390,  264,  321,  286,  264,  471,    0,  414,  412,
  272,   40,  264,  310,  459,  481,  482,   93,  271,  437,
   41,  344,  344,   44,  430,  344,  280,  289,  494,  495,
  344,   41,  286,  459,   40,  441,  271,   40,   59,   41,
   41,   59,  305,  441,   59,   41,    0,  453,   41,  455,
  312,    0,    0, 1048,   12,  461,  241,  319,  234,  321,
  322,  233,  606,  325,  985,  566,   59,  329,  776,  260,
  332,  379,  334,  983,  336,  280,  384,  980,  972,  341,
  342,  286,  344, 1286,   79,  291,  278,    0,  280,  518,
  286,  964,  321,  401,  673,  915,  288,    0,  360,  361,
  408,  363,  279,  262,  973,  264,  303, 1272,  303,  709,
  278,  302,  280,  272, 1274,  377, 1513,  379,  380,  381,
  288, 1517,  384,  314, 1516,  387,  388,  279, 1552,  498,
  289,  699, 1117, 1605,  442,  397, 1471,  328,   41, 1532,
   43,   44,   45, 1549, 1298, 1518,   59,  563,  339,  301,
  353,  771,  414,  312, 1297,  280,   59,   60,   61,   62,
  319,  286,  321,  322,  975,  308,  325,  296,  430,  500,
  329,  289,  757,  332, 1143,  334,  556,  336,  330,  441,
   13,  266,  341,  342,  749,  344,  262,  379,  264,  433,
   93,  453,  437,  455,  677,  662,  272,  349,  648,  461,
  649,  360,  361, 1345,  363,  357,  358,  117,  879,  401,
 1445,  379,  364,  289, 1353, 1527,  408,  408,  377, 1567,
  379,  380,  381, 1623,  449,  384,  613,  418,  387,  388,
  382,  832, 1016,  401,  643,   -1,  312,   -1,  397,  352,
  408,   -1,  394,  319,  396,  321,  322,   -1,   -1,  325,
  442,   -1,  443,  329,    0,  414,  332,  278,  334,  280,
  336,   -1,   -1,   -1,   -1,  341,  342,  419,  344,   -1,
  461,  430,   -1,   -1,  442,   41,   42,   43,   -1,   45,
   -1,   47,  441,   -1,  360,  361,   -1,  363,   -1,   -1,
   -1,    0,  444,   -1,  453,   41,  455,   43,   44,   45,
   -1,  377,  461,  379,  380,  381,   -1,   -1,  384,   -1,
   -1,  387,  388,   59,   60,   61,   62,   -1,   41,   42,
   43,  397,   45,   -1,   47,   -1,  319,   -1,   -1,   -1,
   -1,   -1,   41,   -1,   -1,   44,  329,   -1,  414,  332,
   -1,   -1,   -1,   -1,   -1,  258,   -1,   93,  341,   -1,
   59,   -1,   -1,   -1,  430,   -1,   -1,   -1,  379,  262,
   -1,  264,   -1,   -1,   -1,  441,  279,   -1,   -1,  272,
   -1,  260,   -1,   40,   -1,   -1,   43,  453,   45,  455,
  401,   -1,   -1,   -1,   -1,  461,  289,  408,  301,   -1,
   -1,   58,   -1,   -1,  307,  388,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  397,   -1,   -1,   -1,   -1,  312,
   -1,   -1,   -1,  302,   -1,   -1,  319,  330,  321,  322,
   -1,  442,  325,    0,   -1,  314,  329,   -1,   -1,  332,
   -1,  334,   -1,  336,   -1,   -1,  349,   -1,  341,  342,
   -1,  344,   -1,   -1,  357,  358,    0,   -1,  441,   -1,
  339,  364,   -1,   -1,   -1,   -1,   -1,  360,  361,   -1,
  363,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,  382,
   40,   -1,   -1,   43,  377,   45,  379,  380,  381,   -1,
   -1,  384,   59,   -1,  387,  388,   -1,   41,   58,   -1,
   44,   -1,   -1,   63,  397,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   59,  419,   -1,   -1,   -1,
   -1,  414,   -1,   -1,  280,   -1,  262,  430,  264,  408,
  286,   -1,   -1,   -1,   -1,   -1,  272,  430,   -1,  418,
   -1,   41,   42,   43,   -1,   45,   -1,   47,  441,   -1,
   -1,   -1,   -1,  289,   -1,   -1,   -1,   -1,   -1,   -1,
  453,   -1,  455,   -1,  443,   -1,   -1,  280,  461,   -1,
   -1,   -1,   -1,  286,   -1,   -1,  312,   -1,   -1,  278,
   -1,  280,  461,  319,   -1,  321,  322,   -1,   -1,  325,
   -1,   -1,   -1,  329,   -1,   -1,  332,   -1,  334,   -1,
  336,   -1,   -1,   -1,   -1,  341,  342,   -1,  344,   -1,
  267,   41,   42,   43,   -1,   45,   -1,   47,   -1,  276,
   -1,   -1,   -1,   -1,  360,  361,   -1,  363,   -1,   -1,
   -1,   -1,   40,  290,   42,   43,  293,   45,   -1,  296,
  297,  377,   -1,  379,  380,  381,   -1,   -1,  384,   -1,
   58,  387,  388,   -1,   -1,   63,   -1,   -1,  315,   -1,
   -1,  397,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  327,   -1,   -1,   -1,   -1,   41,   42,   43,  414,   45,
  379,   47,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   45,   41,   42,   43,  430,   45,   -1,   47,  355,  356,
   -1,   -1,  401,   -1,   -1,  441,   -1,  267,   -1,  408,
  367,  278,   -1,  280,  371,   -1,  276,  453,  262,  455,
   -1,  288,  379,   -1,   41,  461,   -1,   44,   -1,   40,
  290,   42,   43,   -1,   45,   -1,  296,  297,   -1,   -1,
   -1,   -1,   59,  442,  280,   -1,   -1,   58,   -1,   -1,
  286,   -1,   63,   -1,   -1,  315,   -1,   -1,   -1,   -1,
   -1,   -1,   41,   42,   43,  422,   45,  327,   47,   -1,
   -1,   -1,   -1,   -1,   -1,  319,   -1,  434,  322,   -1,
  280,   -1,   -1,   -1,   -1,  329,  286,  444,  332,   -1,
   -1,   -1,  336,   -1,   -1,  355,  356,  341,   -1,   -1,
  344,  458,  459,  460,  461,  462,  463,  367,   -1,   -1,
    0,  371,  379,   -1,   -1,  472,  360,   -1,   -1,  379,
   -1,   -1,   -1,   -1,  481,  482,  483,  484,  485,  486,
  487,   -1,  489,   -1,  401,   -1,   -1,  494,  495,   -1,
  384,  408,   -1,  387,  388,   -1,   -1,   -1,   -1,   -1,
  280,   41,  260,  397,   44,   -1,  286,   -1,  418,  267,
   -1,   -1,  422,   -1,   -1,   -1,   -1,   -1,  276,   59,
  414,   -1,   -1,   -1,  434,  442,   -1,   41,   42,   43,
   -1,   45,  290,   47,  444,   -1,   -1,   -1,  296,  297,
   -1,   -1,   -1,   -1,   -1,   -1,  304,  441,  458,  459,
  460,  461,  462,  463,   -1,   -1,   -1,   -1,   -1,  453,
   40,  455,  472,   43,  280,   45,   -1,   -1,   -1,  327,
  286,  481,  482,  483,  484,  485,  486,  487,   58,  489,
  280,   -1,   -1,   63,  494,  495,  286,   -1,   -1,   -1,
   -1,  296,   -1,   -1,    0,  353,   -1,  355,  356,  260,
   -1,   41,   42,   43,   -1,   45,  267,   47,   -1,  367,
   -1,   -1,   -1,  371,   -1,  276,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,  290,
   -1,   -1,   -1,   -1,   -1,  296,  297,   -1,   -1,   -1,
   58,   -1,   -1,  304,   -1,   63,   -1,   -1,  353,   -1,
   -1,  280,  319,   59,   -1,  322,   -1,  286,   -1,   -1,
   -1,   -1,  329,   -1,   -1,  332,  327,   -1,   -1,  336,
   -1,   -1,   -1,   -1,  341,   -1,  434,  344,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  444,   -1,   -1,   45,
   -1,   -1,  353,  360,  355,  356,   -1,   -1,   -1,   -1,
  458,  459,  460,  461,  462,  463,  367,   63,   -1,   -1,
  371,   -1,   -1,   -1,  472,   -1,   -1,  384,   -1,   -1,
  387,  388,   -1,  481,  482,  483,  484,  485,  486,  487,
  397,  489,   -1,   -1,   -1,   -1,  494,  495,  278,  444,
  280,   -1,   -1,   -1,   -1,   -1,   -1,  414,  288,   -1,
   -1,   -1,   -1,  458,  459,  460,   -1,  462,  463,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,   -1,
   -1,   -1,  286,  434,  441,   -1,  481,  482,  483,  484,
  485,  486,  487,  444,   -1,   -1,  453,  267,  455,  494,
  495,   -1,   -1,   -1,   -1,   -1,  276,  458,  459,  460,
  461,  462,  463,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  290,  472,   -1,   -1,   -1,   -1,  296,  297,   -1,   45,
  481,  482,  483,  484,  485,  486,  487,   -1,  489,   -1,
   -1,   -1,   -1,  494,  495,  315,   -1,   63,  271,  379,
  280,   -1,  260,   -1,   -1,  263,  286,  327,   -1,  267,
   -1,   -1,  258,   -1,   -1,   -1,   -1,   -1,  276,   40,
   -1,  401,   43,   -1,   45,   -1,   -1,   -1,  408,  302,
    0,   -1,  290,  279,   -1,  355,  356,   58,  296,  297,
  313,  314,   63,  316,   -1,   -1,  319,  367,   -1,   -1,
   -1,  371,   -1,   -1,   -1,  301,   -1,   -1,   -1,  379,
  333,  307,  442,   -1,   -1,   -1,  339,   -1,   -1,  327,
   -1,   41,   -1,   40,   44,   -1,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,  330,   -1,   -1,   -1,   -1,   59,
   -1,   58,   -1,   -1,   -1,   -1,   63,  355,  356,   -1,
  296,   -1,  422,  349,   -1,   -1,   -1,   -1,   -1,  367,
   -1,   -1,  358,  371,  434,   -1,   -1,   -1,  364,   -1,
   -1,   -1,   -1,   -1,  444,   -1,  399,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  382,   -1,  458,  459,
  460,  461,  462,  463,   -1,  418,   -1,   -1,   -1,   -1,
   -1,   -1,  472,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  433,  481,  482,  483,  484,  485,  486,  487,  426,  489,
  443,   -1,   -1,  419,  494,  495,  434,   -1,   -1,   -1,
   -1,  454,   -1,   -1,   -1,   -1,  444,   -1,  461,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  458,  459,  460,  461,  462,  463,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  472,  488,   -1,   -1,   -1,   -1,
   -1,   -1,  418,  481,  482,  483,  484,  485,  486,  487,
  296,  489,   -1,   -1,   -1,   -1,  494,  495,   -1,  260,
   41,   -1,  263,   44,   -1,   -1,  267,   -1,  444,   -1,
   -1,   -1,   -1,   -1,   -1,  276,   -1,   -1,   59,   -1,
   -1,   -1,  458,  459,  460,   -1,  462,  463,   -1,  290,
   -1,   -1,   -1,   -1,   -1,  296,  297,   -1,   -1,   -1,
   -1,   -1,    0,   -1,   -1,  481,  482,   -1,   -1,   -1,
  486,  487,  262,  260,   -1,   -1,  263,   -1,  494,  495,
  267,   -1,   -1,   -1,   -1,   -1,  327,   -1,   -1,  276,
   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  290,   -1,   -1,   -1,   -1,   58,  296,
  297,   -1,   -1,   63,  355,  356,   -1,   -1,   -1,   -1,
   -1,   59,   -1,   -1,   -1,   -1,  367,   -1,   -1,  319,
  371,   -1,  322,   -1,   -1,   -1,   -1,   -1,   -1,  329,
  327,   -1,  332,   -1,   40,   -1,  336,   43,   -1,   45,
   -1,  341,   -1,   -1,  344,   -1,   -1,   -1,  444,   -1,
   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,  355,  356,
  360,   -1,  458,  459,  460,   -1,  462,  463,   -1,   -1,
  367,   -1,   -1,   -1,  371,  426,   -1,   -1,   -1,   -1,
   -1,    0,   -1,  434,  384,  481,  482,  387,  388,   -1,
  486,  487,   -1,  444,   -1,   -1,   -1,  397,  494,  495,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  458,  459,  460,
  461,  462,  463,   -1,  414,   -1,   -1,   -1,   -1,   -1,
   -1,  472,   -1,   -1,   -1,   -1,   -1,  258,   -1,  426,
  481,  482,  483,  484,  485,  486,  487,  434,  489,   -1,
   59,  441,   -1,  494,  495,   -1,   -1,  444,  279,   -1,
   -1,   -1,   -1,  453,   -1,  455,   -1,   -1,   -1,   -1,
   -1,  458,  459,  460,  461,  462,  463,   -1,   -1,   -1,
  301,   -1,   -1,   -1,   -1,  472,  307,   -1,   -1,   -1,
   -1,   -1,    0,   -1,  481,  482,  483,  484,  485,  486,
  487,   -1,  489,   -1,   -1,   -1,   -1,  494,  495,  330,
  260,   -1,   -1,  263,   -1,   -1,   -1,  267,   -1,   -1,
  258,   -1,   -1,   -1,   -1,   -1,  276,   -1,  349,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,  358,   -1,   -1,
  290,  279,  295,  364,   -1,   -1,  296,  297,   -1,   -1,
   -1,   59,   -1,  306,   -1,   -1,   -1,   -1,   -1,   -1,
  313,  382,   -1,  301,  260,   -1,   -1,  263,   -1,  307,
   -1,  267,   -1,  326,   -1,   -1,   -1,  327,   -1,   -1,
  276,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,  330,   -1,  290,   -1,   -1,   -1,  419,   58,
  296,  297,   -1,   -1,   63,  355,  356,   -1,   -1,   -1,
   -1,  349,   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,
  358,  371,   -1,   -1,   -1,   -1,  364,   -1,   -1,   -1,
   -1,  327,   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,
   45,   -1,   -1,   -1,  382,   -1,   -1,   -1,   -1,  258,
  403,   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,  355,
  356,   -1,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
  279,  367,   -1,   -1,   -1,  371,  426,   -1,   -1,   -1,
   -1,  419,  435,   -1,  434,   -1,  439,   -1,   -1,  442,
   -1,   -1,  301,   -1,  444,   -1,   -1,  450,  307,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  458,  459,
  460,  461,  462,  463,   -1,   -1,  469,   -1,   -1,   -1,
   -1,  330,  472,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  426,  481,  482,  483,  484,  485,  486,  487,  434,  489,
  349,   -1,   -1,   -1,  494,  495,   -1,   -1,  444,  358,
   -1,   -1,   -1,   -1,  262,  364,   -1,   -1,   -1,   -1,
   -1,   -1,  458,  459,  460,  461,  462,  463,   -1,   -1,
   -1,   -1,   -1,  382,   -1,   -1,  472,   -1,   -1,   -1,
   -1,   -1,    0,   -1,   -1,  481,  482,  483,  484,  485,
  486,  487,   -1,  489,   -1,   -1,   -1,   -1,  494,  495,
   -1,  260,   -1,   -1,  263,   -1,   -1,   -1,  267,   -1,
  419,  319,   -1,   -1,  322,   -1,   -1,  276,   -1,   -1,
   -1,  329,   -1,   41,  332,   -1,   44,   -1,  336,   -1,
   -1,  290,   -1,  341,   -1,   -1,  344,  296,  297,   -1,
   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  306,
   -1,   -1,  360,   -1,   -1,  260,  313,   -1,  263,   -1,
  317,  318,  267,   -1,   -1,   -1,   -1,   -1,  327,  326,
   -1,  276,   40,   -1,   -1,   43,  384,   45,   -1,  387,
  388,  338,   -1,   -1,   -1,  290,   -1,   -1,   -1,  397,
   58,  296,  297,   -1,   -1,   63,  355,  356,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1,  367,   -1,
   -1,   -1,  371,    0,   -1,   -1,   -1,   -1,   40,   -1,
   42,   43,  327,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  441,   -1,   -1,   58,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,  453,  403,  455,   -1,   -1,
  355,  356,   -1,   -1,   41,   -1,   -1,   44,   -1,   46,
   -1,   -1,  367,  420,   -1,   -1,  371,  426,   -1,   -1,
   -1,   -1,   59,   -1,   61,  434,   -1,   -1,  435,   -1,
   -1,   -1,  439,   -1,   -1,  444,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  450,   -1,   -1,   -1,   -1,   -1,  458,
  459,  460,  461,  462,  463,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  472,   -1,   40,   -1,   42,   43,   -1,
   45,  426,  481,  482,  483,  484,  485,  486,  487,  434,
  489,   -1,   -1,   58,   -1,  494,  495,   -1,   63,  444,
   -1,   -1,   -1,   -1,  262,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  458,  459,  460,  461,  462,  463,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  472,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  481,  482,  483,  484,
  485,  486,  487,   -1,  489,   -1,   -1,   -1,   -1,  494,
  495,   -1,  260,   -1,   -1,  263,   -1,   -1,   -1,  267,
   -1,  319,   -1,   -1,  322,   -1,   -1,   -1,  276,   -1,
   -1,  329,   -1,   -1,  332,   -1,   -1,   -1,  336,   -1,
   -1,   -1,  290,  341,   -1,   -1,  344,   -1,  296,  297,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  360,   -1,   -1,  267,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  276,   -1,   -1,   -1,   40,  327,
   -1,   43,   -1,   45,   -1,   -1,  384,   -1,  290,  387,
  388,   -1,   -1,   -1,  296,  297,   58,  264,  265,  397,
   -1,   63,   -1,   -1,   -1,   -1,   -1,  355,  356,   -1,
   -1,   -1,   -1,  280,   -1,   -1,  414,   -1,   -1,  367,
   -1,   -1,   -1,  371,   -1,  327,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  303,   -1,  305,   -1,
   -1,   -1,   -1,  441,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  353,  319,  355,  356,  453,   -1,  455,   -1,   -1,
   -1,   40,  267,   -1,   43,  367,   45,   -1,   -1,  371,
   -1,  276,   -1,   -1,  341,   -1,   -1,   -1,  426,   58,
   -1,   -1,   -1,   -1,   63,  290,  434,   -1,   -1,   -1,
   -1,  296,  297,   -1,   -1,   -1,  444,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  458,  459,  460,  461,  462,  463,   -1,   -1,   -1,   -1,
   -1,   -1,  327,   -1,  472,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  434,  481,  482,  483,  484,  485,  486,  487,
   -1,  489,  444,   -1,  411,   -1,  494,  495,  353,   -1,
  355,  356,   -1,   -1,   -1,   -1,  458,  459,  460,  461,
  462,  463,  367,   -1,   -1,   -1,  371,   -1,  271,   -1,
  472,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  481,
  482,  483,  484,  485,  486,  487,   -1,  489,   -1,   -1,
   -1,   -1,  494,  495,   -1,   -1,   -1,   -1,  260,  302,
   -1,   -1,   -1,   -1,   40,  267,  309,   43,   -1,   45,
  313,  314,   -1,  316,  276,   -1,  319,   -1,   -1,   -1,
   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,  290,  434,
  333,   -1,   -1,   -1,  296,  297,  339,   -1,   -1,  444,
   -1,   -1,  304,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  458,  459,  460,  461,  462,  463,   -1,
   -1,   -1,   -1,   -1,   -1,  327,   -1,  472,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  481,  482,  483,  484,
  485,  486,  487,   -1,  489,   -1,   -1,   -1,  267,  494,
  495,   -1,   -1,  355,  356,   -1,  399,  276,   -1,   -1,
   -1,   40,   41,   -1,   43,  367,   45,   -1,   -1,  371,
   -1,  290,   -1,   -1,   -1,  418,   -1,  296,  297,   58,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
  433,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  443,   -1,   -1,   -1,   -1,   -1,   -1,   40,  327,  452,
   43,  454,   45,   -1,   -1,   -1,   -1,   -1,  461,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,
   63,   -1,  434,   -1,   -1,   -1,  355,  356,   -1,   -1,
   -1,   -1,  444,   -1,   -1,  488,   -1,   -1,  367,   -1,
   -1,   -1,  371,   -1,   -1,   -1,  458,  459,  460,  461,
  462,  463,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  472,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  481,
  482,  483,  484,  485,  486,  487,   -1,  489,   -1,   -1,
   -1,  267,  494,  495,   -1,   -1,   -1,   -1,   -1,  418,
  276,   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,   45,
   -1,   -1,   -1,   -1,  290,  434,   -1,   -1,   -1,   -1,
  296,  297,   58,   -1,   -1,  444,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  458,
  459,  460,  461,  462,  463,   -1,   -1,   -1,   -1,   -1,
   -1,  327,   -1,  472,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  481,  482,  483,  484,  485,  486,  487,   -1,
  489,   -1,   -1,   -1,   -1,  494,  495,  353,   -1,  355,
  356,   -1,   -1,   -1,  261,   -1,   -1,   40,  267,   -1,
   43,  367,   45,   -1,   -1,  371,   -1,  276,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,  283,   -1,   -1,   -1,
   63,  290,   -1,   -1,  291,   -1,   -1,  296,  297,   -1,
   -1,  298,   -1,  300,   -1,  302,   -1,   -1,   -1,   -1,
  307,   -1,   -1,   -1,  267,   -1,   -1,  314,   -1,   -1,
   -1,   -1,   -1,  276,   -1,   -1,   -1,   -1,  327,   -1,
   -1,  328,   -1,   -1,   -1,   -1,   40,  290,  434,   43,
   -1,   45,  339,  296,  297,   -1,   -1,   -1,  444,   -1,
   -1,   -1,   -1,   -1,   58,   -1,  355,  356,   -1,   63,
   -1,   -1,  458,  459,  460,  461,  462,  463,  367,   -1,
   -1,   -1,  371,   -1,  327,   -1,  472,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  481,  482,  483,  484,  485,
  486,  487,   -1,  489,   -1,   -1,   -1,   -1,  494,  495,
   -1,   -1,  355,  356,   -1,   -1,   -1,   -1,   -1,  406,
   -1,  267,   -1,   -1,  367,   -1,  413,   -1,  371,  416,
  276,  418,  419,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  290,  434,   -1,   -1,   -1,   -1,
  296,  297,   -1,   -1,   -1,  444,  443,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  458,
  459,  460,  461,  462,  463,   -1,   -1,   -1,   -1,   -1,
   -1,  327,   -1,  472,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  434,  481,  482,  483,  484,  485,  486,  487,   -1,
  489,  444,   -1,  490,  267,  494,  495,   -1,   -1,  355,
  356,   -1,  455,  276,   -1,  458,  459,  460,  461,  462,
  463,  367,    0,   -1,   -1,  371,   -1,  290,   -1,  472,
   -1,   -1,   -1,  296,  297,   -1,   -1,   -1,  481,  482,
  483,  484,  485,  486,  487,   -1,  489,   -1, 1176, 1177,
   -1,  494,  495,   -1,   -1,   -1,   -1,   -1, 1186, 1187,
   -1, 1189, 1190,   41,  327,   -1,   44,   -1,   -1, 1197,
 1198, 1199, 1200,  267, 1202, 1203, 1204, 1205, 1206, 1207,
   -1,   59,  276,   -1,   -1,   -1,    0,   -1,  434,   -1,
   -1,   -1,  355,  356,   -1,   -1,  290,   -1,  444,   -1,
   -1,   -1,  296,  297,  367,   -1,    0,   -1,  371,  455,
   -1,   -1,  458,  459,  460,  461,  462,  463,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  472,   41,   -1,   -1,
   44,   -1,   -1,  327,   -1,  481,  482,  483,  484,  485,
  486,  487,   -1,  489,   -1,   59,   -1,   41,  494,  495,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  355,  356,   -1,   -1,   59,   -1,   -1,   -1,    0,
   -1,  434,   -1,  367,   -1,   -1,   -1,  371,   -1,   -1,
   -1,  444,  273,   -1,   -1,   -1,  277,   -1,   -1,    0,
   -1,   -1,   -1,   -1,  285,  458,  459,  460,  461,  462,
  463,   -1,   -1,   -1,   -1,  296,   -1,   -1,  299,  472,
   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,  481,  482,
  483,  484,  485,  486,  487,   -1,  489,   -1,   59,   -1,
   41,  494,  495,   44,   -1,   -1,   -1,   -1,   -1,   -1,
  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,  340,
  444,   -1,   -1,    0,   -1,  346,  347,  348,   -1,  350,
  351,  352,   -1,  354,  458,  459,  460,  461,  462,  463,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,  472,   -1,
   -1,   -1,   -1,  374,  262,  376,   -1,  481,  482,  483,
  484,  485,  486,  487,   41,  489,   -1,   44,   -1,   -1,
  494,  495,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   41,   -1,  407,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,  424,   -1,   -1,    0,    0,   -1,   -1,
   -1,  319,   -1,   -1,  322,   -1,   -1,   -1,  262,   -1,
   -1,  329,   -1,   -1,  332,  446,   -1,    0,  336,   -1,
   -1,   -1,   -1,  341,   -1,   -1,  344,   -1,  262,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   41,   41,   -1,
   44,   44,  360,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  481,  482,   -1,   -1,   -1,   59,   59,   -1,   41,   -1,
   -1,   44,   -1,   -1,   -1,  319,  384,   -1,  322,  387,
  388,   -1,   -1,   -1,   -1,  329,   59,   -1,  332,  397,
    0,   -1,  336,   -1,   -1,  319,   -1,  341,  322,   -1,
  344,  262,   -1,   -1,   -1,  329,  414,   -1,  332,   -1,
    0,   -1,  336,   -1,   -1,   -1,  360,  341,   -1,   -1,
  344,  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   -1,  441,   44,   -1,  360,   -1,   -1,   -1,
  384,   -1,   -1,  387,  388,  453,   -1,  455,   -1,   59,
   -1,   41,   -1,  397,   44,   -1,   -1,   -1,  319,   -1,
  384,  322,   -1,  387,  388,   -1,   -1,   -1,  329,   59,
  414,  332,   -1,  397,    0,  336,   -1,   -1,  319,   -1,
  341,  322,   -1,  344,   -1,  262,   -1,   -1,  329,   -1,
  414,  332,   -1,   -1,   -1,  336,   -1,  441,   -1,  360,
  341,   -1,   -1,  344,   -1,  262,   -1,   -1,   -1,  453,
   -1,  455,   -1,   -1,   -1,   41,   -1,  441,   44,  360,
   -1,   -1,   -1,  384,   -1,   -1,  387,  388,   -1,  453,
   -1,  455,   -1,   59,   -1,   -1,  397,    0,   -1,   -1,
   -1,   -1,  319,  384,   -1,  322,  387,  388,   -1,   -1,
   -1,   -1,  329,  414,   -1,  332,  397,    0,   -1,  336,
   -1,   -1,  319,   -1,  341,  322,   -1,  344,  262,   -1,
   -1,   -1,  329,  414,   -1,  332,   -1,   -1,   41,  336,
  441,   44,   -1,  360,  341,   -1,   -1,  344,   -1,  262,
   -1,   -1,  453,   -1,  455,   -1,   59,   -1,   41,   -1,
  441,   44,   -1,  360,   -1,   -1,   -1,  384,   -1,   -1,
  387,  388,  453,   -1,  455,   -1,   59,   -1,   -1,   -1,
  397,    0,   -1,   -1,   -1,  319,  319,  384,  322,  322,
  387,  388,   -1,   -1,   -1,  329,  329,  414,  332,  332,
  397,   -1,  336,  336,   -1,   -1,  319,  341,  341,  322,
  344,  344,  262,   -1,   -1,   -1,  329,  414,   -1,  332,
   -1,   -1,   41,  336,  441,   44,  360,  360,  341,   -1,
   -1,  344,  262,   -1,   -1,   -1,  453,   -1,  455,   -1,
   59,   -1,   -1,   -1,  441,   -1,   -1,  360,   -1,   -1,
  384,  384,   -1,  387,  388,  388,  453,   -1,  455,   -1,
   -1,   -1,   -1,  397,  397,   -1,   -1,   -1,   -1,  319,
   -1,  384,  322,   -1,  387,  388,   -1,   -1,   -1,  329,
  414,  414,  332,   -1,  397,   -1,  336,   -1,   -1,  319,
   -1,  341,  322,   -1,  344,   -1,  262,   -1,   -1,  329,
   -1,  414,  332,   -1,   -1,   -1,  336,  441,  441,   -1,
  360,  341,   -1,   -1,  344,   -1,   -1,   -1,   -1,  453,
  453,  455,   -1,   -1,   -1,   -1,   -1,   -1,  441,   -1,
  360,   -1,   -1,   -1,  384,   -1,   -1,  387,  388,   -1,
  453,   -1,  455,   -1,   -1,   -1,   -1,  397,   -1,   -1,
   -1,   -1,   -1,  319,  384,   -1,  322,  387,  388,  262,
   -1,   -1,   -1,  329,  414,   -1,  332,  397,   -1,   -1,
  336,   -1,   -1,   -1,   -1,  341,   -1,   -1,  344,  262,
   -1,   41,   42,   43,  414,   45,   -1,   47,   -1,   -1,
   -1,  441,   -1,   -1,  360,   -1,   -1,   -1,   -1,   -1,
   60,   61,   62,  453,   -1,  455,   -1,   -1,   -1,   -1,
   -1,  441,   -1,   -1,   -1,   -1,  319,   -1,  384,  322,
   -1,  387,  388,  453,   -1,  455,  329,   -1,  271,  332,
   -1,  397,   -1,  336,   -1,   -1,  319,   -1,  341,  322,
   -1,  344,   -1,  262,   -1,   -1,  329,   -1,  414,  332,
   -1,   -1,   -1,  336,   -1,   -1,   -1,  360,  341,  302,
   -1,  344,   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,
  313,  314,   -1,  316,   -1,  441,  319,  360,   -1,   -1,
   -1,  384,   -1,   -1,  387,  388,   -1,  453,   -1,  455,
  333,   -1,   -1,   -1,  397,   -1,  339,   -1,   -1,   -1,
  319,  384,   -1,  322,  387,  388,   -1,   -1,   -1,   -1,
  329,  414,   -1,  332,  397,   42,   43,  336,   45,   -1,
   47,   -1,  341,   -1,   -1,  344,   -1,   -1,   -1,   -1,
   -1,  414,   -1,   60,   61,   62,   -1,   -1,  441,   -1,
   -1,  360,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  453,   -1,  455,   -1,   -1,   -1,  399,   -1,  441,   -1,
   -1,   -1,   -1,   -1,   -1,  384,   -1,   -1,  387,  388,
  453,   -1,  455,   -1,   -1,  418,   -1,   -1,  397,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  433,   -1,   -1,   -1,   -1,  414,   -1,   -1,   -1,   -1,
  443,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  452,
   -1,  454,  272,   -1,   -1,   -1,   -1,   -1,  461,   -1,
  280,  273,  441,   -1,   -1,  277,  286,   -1,   -1,  289,
   -1,   -1,   -1,   -1,  453,   -1,  455,  273,   -1,   -1,
  292,  277,   -1,   -1,  296,  488,   -1,  299,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  292,   -1,   -1,   -1,
  296,   -1,   -1,  299,   -1,  325,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  334,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  342,   -1,   -1,   -1,   -1,   -1,  340,   -1,
   -1,   -1,   -1,   -1,  346,  347,  348,   -1,  350,  351,
  352,  361,  354,  363,  340,   -1,   -1,   -1,   -1,   -1,
  346,  347,  348,   -1,  350,  351,  352,  377,  354,  379,
  380,  381,  374,   -1,  376,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,
  376,   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,   -1,  407,   -1,   -1,   -1,  286,
  412,   -1,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  430,  407,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  273,   -1,   -1,   -1,  277,   -1,  424,   -1,
   -1,   -1,   -1,   -1,  446,  273,   -1,   -1,  325,  277,
   -1,   -1,   -1,   -1,   -1,  296,   -1,  334,  299,   -1,
  446,   -1,   -1,   -1,  292,  342,   -1,   -1,  296,   -1,
   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  481,
  482,   -1,   -1,   -1,  361,   -1,  363,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  481,  482,   -1,   -1,  340,
  377,   -1,  379,  380,  381,  346,  347,  348,   -1,  350,
  351,  352,  340,  354,   -1,   -1,   -1,   -1,  346,  347,
  348,   -1,  350,  351,  352,   -1,  354,   -1,   -1,   -1,
   -1,   -1,   -1,  374,  273,  376,   -1,   -1,  277,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,  376,   -1,
   -1,   -1,   -1,  430,   -1,  273,   -1,  296,   -1,  277,
  299,   -1,   -1,   -1,   -1,   -1,  407,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  296,  407,
   -1,  299,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,
   -1,  340,   -1,   -1,   -1,  446,   -1,  346,  347,  348,
   -1,  350,  351,  352,   -1,  354,   -1,   -1,  446,   -1,
  461,   -1,  340,   -1,   -1,   -1,   -1,   -1,  346,  347,
  348,   -1,  350,  351,  352,  374,  354,  376,   -1,   -1,
  481,  482,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  481,  482,   -1,  374,   -1,  376,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  407,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,  407,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  461,
   -1,   -1,   -1,   -1,   -1,   -1,  424,  446,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
  482,  483,  484,  485,  486,  487,  488,  489,  446,  491,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  481,  482,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  461,   -1,   -1,   -1,
   -1,   -1,   -1,  481,  482,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,  481,  482,  483,  484,
  485,  486,  487,  488,  489,  461,  491,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,  481,  482,  483,  484,  485,
  486,  487,  488,  489,   -1,  491,
};
#define YYFINAL 18
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 495
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,0,0,
"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ACTIVE","ADD","AFTER","ALL","ALTER","AND","ANY",
"AS","ASC","AT","AVG","AUTO","BASENAME","BEFORE","BEGIN","BETWEEN","BLOB","BY",
"CACHE","CAST","CHARACTER","CHECK","CHECK_POINT_LEN","COLLATE","COLLATION",
"COMMA","COMMIT","COMMITTED","COMPUTED","CONCATENATE","CONDITIONAL",
"CONSTRAINT","CONTAINING","COUNT","CREATE","CSTRING","CURRENT","CURSOR",
"DATABASE","DATE","DB_KEY","DEBUG","DECIMAL","DECLARE","DEFAULT","DELETE",
"DESC","DISTINCT","DO","DOMAIN","DROP","ELSE","END","ENTRY_POINT","EQL",
"ESCAPE","EXCEPTION","EXECUTE","EXISTS","EXIT","EXTERNAL","FILTER","FOR",
"FOREIGN","FROM","FULL","FUNCTION","GDSCODE","GEQ","GENERATOR","GEN_ID","GRANT",
"GROUP","GROUP_COMMIT_WAIT","GTR","HAVING","IF","IN","INACTIVE","INNER",
"INPUT_TYPE","INDEX","INSERT","INTEGER","INTO","IS","ISOLATION","JOIN","KEY",
"KW_CHAR","KW_DEC","KW_DOUBLE","KW_FILE","KW_FLOAT","KW_INT","KW_LONG",
"KW_NULL","KW_NUMERIC","KW_UPPER","KW_VALUE","LENGTH","LOGFILE","LPAREN","LEFT",
"LEQ","LEVEL","LIKE","LOG_BUF_SIZE","LSS","MANUAL","MAXIMUM","MAX_SEGMENT",
"MERGE","MESSAGE","MINIMUM","MODULE_NAME","NAMES","NATIONAL","NATURAL","NCHAR",
"NEQ","NO","NOT","NOT_GTR","NOT_LSS","NUM_LOG_BUFS","OF","ON","ONLY","OPTION",
"OR","ORDER","OUTER","OUTPUT_TYPE","OVERFLOW","PAGE","PAGES","PAGE_SIZE",
"PARAMETER","PASSWORD","PLAN","POSITION","POST_EVENT","PRECISION","PRIMARY",
"PRIVILEGES","PROCEDURE","PROTECTED","RAW_PARTITIONS","READ","REAL",
"REFERENCES","RESERVING","RETAIN","RETURNING_VALUES","RETURNS","REVOKE","RIGHT",
"RPAREN","ROLLBACK","SEGMENT","SELECT","SET","SHADOW","SHARED","SINGULAR",
"SIZE","SMALLINT","SNAPSHOT","SOME","SORT","SQLCODE","STABILITY","STARTING",
"STATISTICS","SUB_TYPE","SUSPEND","SUM","TABLE","THEN","TO","TRANSACTION",
"TRIGGER","UNCOMMITTED","UNION","UNIQUE","UPDATE","USER","VALUES","VARCHAR",
"VARIABLE","VARYING","VERSION","VIEW","WAIT","WHEN","WHERE","WHILE","WITH",
"WORK","WRITE","FLOAT","NUMBER","NUMERIC","SYMBOL","STRING","INTRODUCER",
"ACTION","ADMIN","CASCADE","FREE_IT","RESTRICT","ROLE","COLUMN","TYPE",
"EXTRACT","YEAR","MONTH","DAY","HOUR","MINUTE","SECOND","WEEKDAY","YEARDAY",
"TIME","TIMESTAMP","CURRENT_DATE","CURRENT_TIME","CURRENT_TIMESTAMP",
"CURRENT_USER","CURRENT_ROLE","KW_BREAK","SUBSTRING","RECREATE","KW_DESCRIPTOR",
"FIRST","SKIP","NUMBER64BIT","SCALEDINT",
};
char *yyrule[] = {
"$accept : top",
"top : statement",
"top : statement ';'",
"statement : alter",
"statement : blob",
"statement : commit",
"statement : create",
"statement : declare",
"statement : delete",
"statement : drop",
"statement : grant",
"statement : insert",
"statement : invoke_procedure",
"statement : recreate",
"statement : revoke",
"statement : rollback",
"statement : select",
"statement : set",
"statement : update",
"statement : DEBUG signed_short_integer",
"grant : GRANT privileges ON prot_table_name TO user_grantee_list grant_option",
"grant : GRANT proc_privileges ON PROCEDURE simple_proc_name TO user_grantee_list grant_option",
"grant : GRANT privileges ON prot_table_name TO grantee_list",
"grant : GRANT proc_privileges ON PROCEDURE simple_proc_name TO grantee_list",
"grant : GRANT role_name_list TO role_grantee_list role_admin_option",
"prot_table_name : simple_table_name",
"prot_table_name : TABLE simple_table_name",
"privileges : ALL",
"privileges : ALL PRIVILEGES",
"privileges : privilege_list",
"privilege_list : privilege",
"privilege_list : privilege_list ',' privilege",
"proc_privileges : EXECUTE",
"privilege : SELECT",
"privilege : INSERT",
"privilege : DELETE",
"privilege : UPDATE column_parens_opt",
"privilege : REFERENCES column_parens_opt",
"grant_option : WITH GRANT OPTION",
"grant_option :",
"role_admin_option : WITH ADMIN OPTION",
"role_admin_option :",
"simple_proc_name : symbol_procedure_name",
"revoke : REVOKE rev_grant_option privileges ON prot_table_name FROM user_grantee_list",
"revoke : REVOKE rev_grant_option proc_privileges ON PROCEDURE simple_proc_name FROM user_grantee_list",
"revoke : REVOKE privileges ON prot_table_name FROM user_grantee_list",
"revoke : REVOKE proc_privileges ON PROCEDURE simple_proc_name FROM user_grantee_list",
"revoke : REVOKE privileges ON prot_table_name FROM grantee_list",
"revoke : REVOKE proc_privileges ON PROCEDURE simple_proc_name FROM grantee_list",
"revoke : REVOKE role_name_list FROM role_grantee_list",
"rev_grant_option : GRANT OPTION FOR",
"grantee_list : grantee",
"grantee_list : grantee_list ',' grantee",
"grantee_list : grantee_list ',' user_grantee",
"grantee_list : user_grantee_list ',' grantee",
"grantee : PROCEDURE symbol_procedure_name",
"grantee : TRIGGER symbol_trigger_name",
"grantee : VIEW symbol_view_name",
"grantee : ROLE symbol_role_name",
"user_grantee_list : user_grantee",
"user_grantee_list : user_grantee_list ',' user_grantee",
"user_grantee : symbol_user_name",
"user_grantee : USER symbol_user_name",
"user_grantee : GROUP symbol_user_name",
"role_name_list : role_name",
"role_name_list : role_name_list ',' role_name",
"role_name : symbol_role_name",
"role_grantee_list : role_grantee",
"role_grantee_list : role_grantee_list ',' role_grantee",
"role_grantee : symbol_user_name",
"role_grantee : USER symbol_user_name",
"declare : DECLARE declare_clause",
"declare_clause : FILTER filter_decl_clause",
"declare_clause : EXTERNAL FUNCTION udf_decl_clause",
"udf_decl_clause : symbol_UDF_name arg_desc_list1 RETURNS return_value1 ENTRY_POINT sql_string MODULE_NAME sql_string",
"udf_data_type : simple_type",
"udf_data_type : BLOB",
"udf_data_type : CSTRING '(' pos_short_integer ')' charset_clause",
"arg_desc_list1 :",
"arg_desc_list1 : arg_desc_list",
"arg_desc_list1 : '(' arg_desc_list ')'",
"arg_desc_list : arg_desc",
"arg_desc_list : arg_desc_list ',' arg_desc",
"arg_desc : init_data_type udf_data_type",
"arg_desc : init_data_type udf_data_type BY KW_DESCRIPTOR",
"return_value1 : return_value",
"return_value1 : '(' return_value ')'",
"return_value : init_data_type udf_data_type",
"return_value : init_data_type udf_data_type FREE_IT",
"return_value : init_data_type udf_data_type BY KW_VALUE",
"return_value : init_data_type udf_data_type BY KW_DESCRIPTOR",
"return_value : PARAMETER pos_short_integer",
"filter_decl_clause : symbol_filter_name INPUT_TYPE blob_subtype OUTPUT_TYPE blob_subtype ENTRY_POINT sql_string MODULE_NAME sql_string",
"create : CREATE create_clause",
"create_clause : EXCEPTION symbol_exception_name sql_string",
"create_clause : unique_opt order_direction INDEX symbol_index_name ON simple_table_name index_definition",
"create_clause : PROCEDURE procedure_clause",
"create_clause : TABLE table_clause",
"create_clause : TRIGGER def_trigger_clause",
"create_clause : VIEW view_clause",
"create_clause : GENERATOR generator_clause",
"create_clause : DATABASE db_clause",
"create_clause : DOMAIN domain_clause",
"create_clause : SHADOW shadow_clause",
"create_clause : ROLE role_clause",
"recreate : RECREATE recreate_clause",
"recreate_clause : PROCEDURE rprocedure_clause",
"recreate_clause : TABLE rtable_clause",
"unique_opt : UNIQUE",
"unique_opt :",
"index_definition : column_list",
"index_definition : column_parens",
"index_definition : computed_by '(' begin_trigger value end_trigger ')'",
"shadow_clause : pos_short_integer manual_auto conditional sql_string first_file_length sec_shadow_files",
"manual_auto : MANUAL",
"manual_auto : AUTO",
"manual_auto :",
"conditional :",
"conditional : CONDITIONAL",
"first_file_length :",
"first_file_length : LENGTH equals long_integer page_noise",
"sec_shadow_files :",
"sec_shadow_files : db_file_list",
"db_file_list : db_file",
"db_file_list : db_file_list db_file",
"domain_clause : column_def_name as_opt data_type begin_trigger domain_default_opt end_trigger domain_constraint_clause collate_clause",
"as_opt : AS",
"as_opt :",
"domain_default_opt : DEFAULT begin_trigger default_value",
"domain_default_opt :",
"domain_constraint_clause :",
"domain_constraint_clause : domain_constraint_list",
"domain_constraint_list : domain_constraint_def",
"domain_constraint_list : domain_constraint_list domain_constraint_def",
"domain_constraint_def : domain_constraint",
"domain_constraint : null_constraint",
"domain_constraint : domain_check_constraint",
"null_constraint : NOT KW_NULL",
"domain_check_constraint : begin_trigger CHECK '(' search_condition ')' end_trigger",
"generator_clause : symbol_generator_name",
"role_clause : symbol_role_name",
"db_clause : db_name db_initial_desc1 db_rem_desc1",
"equals :",
"equals : '='",
"db_name : sql_string",
"db_initial_desc1 :",
"db_initial_desc1 : db_initial_desc",
"db_initial_desc : db_initial_option",
"db_initial_desc : db_initial_desc db_initial_option",
"db_initial_option : PAGE_SIZE equals pos_short_integer",
"db_initial_option : LENGTH equals long_integer page_noise",
"db_initial_option : USER sql_string",
"db_initial_option : PASSWORD sql_string",
"db_initial_option : SET NAMES sql_string",
"db_rem_desc1 :",
"db_rem_desc1 : db_rem_desc",
"db_rem_desc : db_rem_option",
"db_rem_desc : db_rem_desc db_rem_option",
"db_rem_option : db_file",
"db_rem_option : db_log",
"db_rem_option : db_log_option",
"db_rem_option : DEFAULT CHARACTER SET symbol_character_set_name",
"db_log_option : GROUP_COMMIT_WAIT equals long_integer",
"db_log_option : CHECK_POINT_LEN equals long_integer",
"db_log_option : NUM_LOG_BUFS equals pos_short_integer",
"db_log_option : LOG_BUF_SIZE equals unsigned_short_integer",
"db_log : db_default_log_spec",
"db_log : db_rem_log_spec",
"db_rem_log_spec : LOGFILE '(' logfiles ')' OVERFLOW logfile_desc",
"db_rem_log_spec : LOGFILE BASENAME logfile_desc",
"db_default_log_spec : LOGFILE",
"db_file : file1 sql_string file_desc1",
"logfiles : logfile_desc",
"logfiles : logfiles ',' logfile_desc",
"logfile_desc : logfile_name logfile_attrs",
"logfile_name : sql_string",
"logfile_attrs :",
"logfile_attrs : logfile_attrs logfile_attr",
"logfile_attr : SIZE equals long_integer",
"file1 : KW_FILE",
"file_desc1 :",
"file_desc1 : file_desc",
"file_desc : file_clause",
"file_desc : file_desc file_clause",
"file_clause : STARTING file_clause_noise long_integer",
"file_clause : LENGTH equals long_integer page_noise",
"file_clause_noise :",
"file_clause_noise : AT",
"file_clause_noise : AT PAGE",
"page_noise :",
"page_noise : PAGE",
"page_noise : PAGES",
"table_clause : simple_table_name external_file '(' table_elements ')'",
"rtable_clause : simple_table_name external_file '(' table_elements ')'",
"external_file : EXTERNAL KW_FILE sql_string",
"external_file : EXTERNAL sql_string",
"external_file :",
"table_elements : table_element",
"table_elements : table_elements ',' table_element",
"table_element : column_def",
"table_element : table_constraint_definition",
"column_def : column_def_name data_type_or_domain default_opt end_trigger column_constraint_clause collate_clause",
"column_def : column_def_name non_array_type def_computed",
"column_def : column_def_name def_computed",
"def_computed : computed_by '(' begin_trigger value end_trigger ')'",
"computed_by : COMPUTED BY",
"computed_by : COMPUTED",
"data_type_or_domain : data_type begin_trigger",
"data_type_or_domain : simple_column_name begin_string",
"collate_clause : COLLATE symbol_collation_name",
"collate_clause :",
"column_def_name : simple_column_name",
"simple_column_def_name : simple_column_name",
"data_type_descriptor : init_data_type data_type",
"init_data_type :",
"default_opt : DEFAULT default_value",
"default_opt :",
"default_value : constant",
"default_value : current_user",
"default_value : current_role",
"default_value : null_value",
"default_value : datetime_value_expression",
"column_constraint_clause :",
"column_constraint_clause : column_constraint_list",
"column_constraint_list : column_constraint_def",
"column_constraint_list : column_constraint_list column_constraint_def",
"column_constraint_def : constraint_name_opt column_constraint",
"column_constraint : NOT KW_NULL",
"column_constraint : REFERENCES simple_table_name column_parens_opt referential_trigger_action",
"column_constraint : check_constraint",
"column_constraint : UNIQUE",
"column_constraint : PRIMARY KEY",
"table_constraint_definition : constraint_name_opt table_constraint",
"constraint_name_opt : CONSTRAINT symbol_constraint_name",
"constraint_name_opt :",
"table_constraint : unique_constraint",
"table_constraint : primary_constraint",
"table_constraint : referential_constraint",
"table_constraint : check_constraint",
"unique_constraint : UNIQUE column_parens",
"primary_constraint : PRIMARY KEY column_parens",
"referential_constraint : FOREIGN KEY column_parens REFERENCES simple_table_name column_parens_opt referential_trigger_action",
"check_constraint : begin_trigger CHECK '(' search_condition ')' end_trigger",
"referential_trigger_action : update_rule",
"referential_trigger_action : delete_rule",
"referential_trigger_action : delete_rule update_rule",
"referential_trigger_action : update_rule delete_rule",
"referential_trigger_action :",
"update_rule : ON UPDATE referential_action",
"delete_rule : ON DELETE referential_action",
"referential_action : CASCADE",
"referential_action : SET DEFAULT",
"referential_action : SET KW_NULL",
"referential_action : NO ACTION",
"procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string var_declaration_list full_proc_block end_trigger",
"rprocedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string var_declaration_list full_proc_block end_trigger",
"alter_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string var_declaration_list full_proc_block end_trigger",
"input_parameters : '(' proc_parameters ')'",
"input_parameters :",
"output_parameters : RETURNS input_parameters",
"output_parameters :",
"proc_parameters : proc_parameter",
"proc_parameters : proc_parameters ',' proc_parameter",
"proc_parameter : simple_column_def_name non_array_type",
"var_declaration_list : var_declarations",
"var_declaration_list :",
"var_declarations : var_declaration",
"var_declarations : var_declarations var_declaration",
"var_declaration : DECLARE VARIABLE column_def_name non_array_type ';'",
"proc_block : proc_statement",
"proc_block : full_proc_block",
"full_proc_block : BEGIN proc_statements END",
"full_proc_block : BEGIN proc_statements excp_statements END",
"proc_statements : proc_block",
"proc_statements : proc_statements proc_block",
"proc_statement : assignment ';'",
"proc_statement : delete ';'",
"proc_statement : EXCEPTION symbol_exception_name ';'",
"proc_statement : exec_procedure",
"proc_statement : for_select",
"proc_statement : if_then_else",
"proc_statement : insert ';'",
"proc_statement : POST_EVENT value ';'",
"proc_statement : singleton_select",
"proc_statement : update ';'",
"proc_statement : while",
"proc_statement : SUSPEND ';'",
"proc_statement : EXIT ';'",
"proc_statement : KW_BREAK ';'",
"exec_procedure : EXECUTE PROCEDURE symbol_procedure_name proc_inputs proc_outputs ';'",
"for_select : FOR select INTO variable_list cursor_def DO proc_block",
"if_then_else : IF '(' search_condition ')' THEN proc_block ELSE proc_block",
"if_then_else : IF '(' search_condition ')' THEN proc_block",
"singleton_select : select INTO variable_list ';'",
"variable : ':' symbol_variable_name",
"proc_inputs : var_const_list",
"proc_inputs : '(' var_const_list ')'",
"proc_inputs :",
"proc_outputs : RETURNING_VALUES variable_list",
"proc_outputs : RETURNING_VALUES '(' variable_list ')'",
"proc_outputs :",
"var_const_list : variable",
"var_const_list : constant",
"var_const_list : column_name",
"var_const_list : null_value",
"var_const_list : var_const_list ',' variable",
"var_const_list : var_const_list ',' constant",
"var_const_list : var_const_list ',' column_name",
"var_const_list : var_const_list ',' null_value",
"variable_list : variable",
"variable_list : column_name",
"variable_list : variable_list ',' column_name",
"variable_list : variable_list ',' variable",
"while : WHILE '(' search_condition ')' DO proc_block",
"cursor_def : AS CURSOR symbol_cursor_name",
"cursor_def :",
"excp_statements : excp_statement",
"excp_statements : excp_statements excp_statement",
"excp_statement : WHEN errors DO proc_block",
"errors : err",
"errors : errors ',' err",
"err : SQLCODE signed_short_integer",
"err : GDSCODE symbol_gdscode_name",
"err : EXCEPTION symbol_exception_name",
"err : ANY",
"invoke_procedure : EXECUTE PROCEDURE symbol_procedure_name prc_inputs",
"prc_inputs : prm_const_list",
"prc_inputs : '(' prm_const_list ')'",
"prc_inputs :",
"prm_const_list : parameter",
"prm_const_list : constant",
"prm_const_list : null_value",
"prm_const_list : prm_const_list ',' parameter",
"prm_const_list : prm_const_list ',' constant",
"prm_const_list : prm_const_list ',' null_value",
"view_clause : symbol_view_name column_parens_opt AS begin_string union_view check_opt end_string",
"union_view : union_view_expr",
"union_view_expr : select_view_expr",
"union_view_expr : union_view_expr UNION select_view_expr",
"union_view_expr : union_view_expr UNION ALL select_view_expr",
"select_view_expr : SELECT limit_clause distinct_clause select_list from_view_clause where_clause group_clause having_clause plan_clause",
"from_view_clause : FROM from_view_list",
"from_view_list : view_table",
"from_view_list : from_view_list ',' view_table",
"view_table : joined_view_table",
"view_table : table_name",
"joined_view_table : view_table join_type JOIN view_table ON search_condition",
"joined_view_table : '(' joined_view_table ')'",
"begin_string :",
"end_string :",
"begin_trigger :",
"end_trigger :",
"check_opt : WITH CHECK OPTION",
"check_opt :",
"def_trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position begin_trigger trigger_action end_trigger",
"trigger_active : ACTIVE",
"trigger_active : INACTIVE",
"trigger_active :",
"trigger_type : BEFORE INSERT",
"trigger_type : AFTER INSERT",
"trigger_type : BEFORE UPDATE",
"trigger_type : AFTER UPDATE",
"trigger_type : BEFORE DELETE",
"trigger_type : AFTER DELETE",
"trigger_position : POSITION nonneg_short_integer",
"trigger_position :",
"trigger_action : AS begin_trigger var_declaration_list full_proc_block",
"alter : ALTER alter_clause",
"alter_clause : EXCEPTION symbol_exception_name sql_string",
"alter_clause : TABLE simple_table_name alter_ops",
"alter_clause : TRIGGER alter_trigger_clause",
"alter_clause : PROCEDURE alter_procedure_clause",
"alter_clause : DATABASE init_alter_db alter_db",
"alter_clause : DOMAIN alter_column_name alter_domain_ops",
"alter_clause : INDEX alter_index_clause",
"domain_default_opt2 : DEFAULT begin_trigger default_value",
"domain_check_constraint2 : CHECK begin_trigger '(' search_condition ')' end_trigger",
"alter_domain_ops : alter_domain_op",
"alter_domain_ops : alter_domain_ops alter_domain_op",
"alter_domain_op : SET begin_trigger domain_default_opt2 end_trigger",
"alter_domain_op : ADD CONSTRAINT domain_check_constraint2",
"alter_domain_op : ADD domain_check_constraint",
"alter_domain_op : DROP DEFAULT",
"alter_domain_op : DROP CONSTRAINT",
"alter_domain_op : TO simple_column_name",
"alter_domain_op : TYPE init_data_type non_array_type",
"alter_ops : alter_op",
"alter_ops : alter_ops ',' alter_op",
"alter_op : DROP simple_column_name drop_behaviour",
"alter_op : DROP CONSTRAINT symbol_constraint_name",
"alter_op : ADD column_def",
"alter_op : ADD table_constraint_definition",
"alter_op : col_opt simple_column_name POSITION pos_short_integer",
"alter_op : col_opt alter_column_name TO simple_column_name",
"alter_op : col_opt alter_col_name TYPE alter_data_type_or_domain end_trigger",
"alter_column_name : keyword_or_column",
"keyword_or_column : COLUMN",
"keyword_or_column : TYPE",
"keyword_or_column : EXTRACT",
"keyword_or_column : YEAR",
"keyword_or_column : MONTH",
"keyword_or_column : DAY",
"keyword_or_column : HOUR",
"keyword_or_column : MINUTE",
"keyword_or_column : SECOND",
"keyword_or_column : WEEKDAY",
"keyword_or_column : YEARDAY",
"keyword_or_column : TIME",
"keyword_or_column : TIMESTAMP",
"keyword_or_column : CURRENT_DATE",
"keyword_or_column : CURRENT_TIME",
"keyword_or_column : CURRENT_TIMESTAMP",
"keyword_or_column : CURRENT_USER",
"keyword_or_column : CURRENT_ROLE",
"keyword_or_column : SYMBOL",
"keyword_or_column : KW_BREAK",
"keyword_or_column : SUBSTRING",
"keyword_or_column : KW_DESCRIPTOR",
"col_opt : ALTER",
"col_opt : ALTER COLUMN",
"alter_data_type_or_domain : non_array_type begin_trigger",
"alter_data_type_or_domain : simple_column_name begin_string",
"alter_col_name : simple_column_name",
"drop_behaviour : RESTRICT",
"drop_behaviour : CASCADE",
"drop_behaviour :",
"alter_index_clause : symbol_index_name ACTIVE",
"alter_index_clause : symbol_index_name INACTIVE",
"init_alter_db :",
"alter_db : db_alter_clause",
"alter_db : alter_db db_alter_clause",
"db_alter_clause : ADD db_file_list",
"db_alter_clause : DROP LOGFILE",
"db_alter_clause : SET db_log_option_list",
"db_alter_clause : ADD db_log",
"db_log_option_list : db_log_option",
"db_log_option_list : db_log_option_list ',' db_log_option",
"alter_trigger_clause : symbol_trigger_name trigger_active new_trigger_type trigger_position begin_trigger new_trigger_action end_trigger",
"new_trigger_type : trigger_type",
"new_trigger_type :",
"new_trigger_action : trigger_action",
"new_trigger_action :",
"drop : DROP drop_clause",
"drop_clause : EXCEPTION symbol_exception_name",
"drop_clause : INDEX symbol_index_name",
"drop_clause : PROCEDURE symbol_procedure_name",
"drop_clause : TABLE symbol_table_name",
"drop_clause : TRIGGER symbol_trigger_name",
"drop_clause : VIEW symbol_view_name",
"drop_clause : FILTER symbol_filter_name",
"drop_clause : DOMAIN symbol_domain_name",
"drop_clause : EXTERNAL FUNCTION symbol_UDF_name",
"drop_clause : SHADOW pos_short_integer",
"drop_clause : ROLE symbol_role_name",
"drop_clause : GENERATOR symbol_generator_name",
"data_type : non_array_type",
"data_type : array_type",
"non_array_type : simple_type",
"non_array_type : blob_type",
"array_type : non_charset_simple_type '[' array_spec ']'",
"array_type : character_type '[' array_spec ']' charset_clause",
"array_spec : array_range",
"array_spec : array_spec ',' array_range",
"array_range : signed_long_integer",
"array_range : signed_long_integer ':' signed_long_integer",
"simple_type : non_charset_simple_type",
"simple_type : character_type charset_clause",
"non_charset_simple_type : national_character_type",
"non_charset_simple_type : numeric_type",
"non_charset_simple_type : float_type",
"non_charset_simple_type : integer_keyword",
"non_charset_simple_type : SMALLINT",
"non_charset_simple_type : DATE",
"non_charset_simple_type : TIME",
"non_charset_simple_type : TIMESTAMP",
"integer_keyword : INTEGER",
"integer_keyword : KW_INT",
"blob_type : BLOB blob_subtype blob_segsize charset_clause",
"blob_type : BLOB '(' unsigned_short_integer ')'",
"blob_type : BLOB '(' unsigned_short_integer ',' signed_short_integer ')'",
"blob_type : BLOB '(' ',' signed_short_integer ')'",
"blob_segsize : SEGMENT SIZE unsigned_short_integer",
"blob_segsize :",
"blob_subtype : SUB_TYPE signed_short_integer",
"blob_subtype : SUB_TYPE symbol_blob_subtype_name",
"blob_subtype :",
"charset_clause : CHARACTER SET symbol_character_set_name",
"charset_clause :",
"national_character_type : national_character_keyword '(' pos_short_integer ')'",
"national_character_type : national_character_keyword",
"national_character_type : national_character_keyword VARYING '(' pos_short_integer ')'",
"character_type : character_keyword '(' pos_short_integer ')'",
"character_type : character_keyword",
"character_type : varying_keyword '(' pos_short_integer ')'",
"varying_keyword : VARCHAR",
"varying_keyword : CHARACTER VARYING",
"varying_keyword : KW_CHAR VARYING",
"character_keyword : CHARACTER",
"character_keyword : KW_CHAR",
"national_character_keyword : NCHAR",
"national_character_keyword : NATIONAL CHARACTER",
"national_character_keyword : NATIONAL KW_CHAR",
"numeric_type : KW_NUMERIC prec_scale",
"numeric_type : decimal_keyword prec_scale",
"ordinal : pos_short_integer",
"prec_scale :",
"prec_scale : '(' signed_long_integer ')'",
"prec_scale : '(' signed_long_integer ',' signed_long_integer ')'",
"decimal_keyword : DECIMAL",
"decimal_keyword : KW_DEC",
"float_type : KW_FLOAT precision_opt",
"float_type : KW_LONG KW_FLOAT precision_opt",
"float_type : REAL",
"float_type : KW_DOUBLE PRECISION",
"precision_opt : '(' nonneg_short_integer ')'",
"precision_opt :",
"set : set_transaction",
"set : set_generator",
"set : set_statistics",
"set_generator : SET GENERATOR symbol_generator_name TO signed_long_integer",
"set_generator : SET GENERATOR symbol_generator_name TO NUMBER64BIT",
"set_generator : SET GENERATOR symbol_generator_name TO '-' NUMBER64BIT",
"commit : COMMIT optional_work optional_retain",
"rollback : ROLLBACK optional_work",
"optional_work : WORK",
"optional_work :",
"optional_retain : RETAIN opt_snapshot",
"optional_retain :",
"opt_snapshot : SNAPSHOT",
"opt_snapshot :",
"set_transaction : SET TRANSACTION tran_opt_list_m",
"tran_opt_list_m : tran_opt_list",
"tran_opt_list_m :",
"tran_opt_list : tran_opt",
"tran_opt_list : tran_opt_list tran_opt",
"tran_opt : access_mode",
"tran_opt : lock_wait",
"tran_opt : isolation_mode",
"tran_opt : tbl_reserve_options",
"access_mode : READ ONLY",
"access_mode : READ WRITE",
"lock_wait : WAIT",
"lock_wait : NO WAIT",
"isolation_mode : ISOLATION LEVEL iso_mode",
"isolation_mode : iso_mode",
"iso_mode : snap_shot",
"iso_mode : READ UNCOMMITTED version_mode",
"iso_mode : READ COMMITTED version_mode",
"snap_shot : SNAPSHOT",
"snap_shot : SNAPSHOT TABLE",
"snap_shot : SNAPSHOT TABLE STABILITY",
"version_mode : VERSION",
"version_mode : NO VERSION",
"version_mode :",
"tbl_reserve_options : RESERVING restr_list",
"lock_type : SHARED",
"lock_type : PROTECTED",
"lock_type :",
"lock_mode : READ",
"lock_mode : WRITE",
"restr_list : restr_option",
"restr_list : restr_list ',' restr_option",
"restr_option : table_list table_lock",
"table_lock : FOR lock_type lock_mode",
"table_lock :",
"table_list : simple_table_name",
"table_list : table_list ',' simple_table_name",
"set_statistics : SET STATISTICS INDEX symbol_index_name",
"select : union_expr order_clause for_update_clause",
"union_expr : select_expr",
"union_expr : union_expr UNION select_expr",
"union_expr : union_expr UNION ALL select_expr",
"order_clause : ORDER BY order_list",
"order_clause :",
"order_list : order_item",
"order_list : order_list ',' order_item",
"order_item : column_name collate_clause order_direction",
"order_item : ordinal collate_clause order_direction",
"order_direction : ASC",
"order_direction : DESC",
"order_direction :",
"for_update_clause : FOR UPDATE for_update_list",
"for_update_clause :",
"for_update_list : OF column_list",
"for_update_list :",
"select_expr : SELECT limit_clause distinct_clause select_list from_clause where_clause group_clause having_clause plan_clause",
"distinct_clause : DISTINCT",
"distinct_clause : all_noise",
"select_list : select_items",
"select_list : '*'",
"select_items : select_item",
"select_items : select_items ',' select_item",
"select_item : rhs",
"select_item : rhs symbol_item_alias_name",
"select_item : rhs AS symbol_item_alias_name",
"from_clause : FROM from_list",
"from_list : table_reference",
"from_list : from_list ',' table_reference",
"table_reference : joined_table",
"table_reference : table_proc",
"joined_table : table_reference join_type JOIN table_reference ON search_condition",
"joined_table : '(' joined_table ')'",
"table_proc : symbol_procedure_name proc_table_inputs symbol_table_alias_name",
"table_proc : symbol_procedure_name proc_table_inputs",
"proc_table_inputs : '(' null_or_value_list ')'",
"proc_table_inputs :",
"null_or_value_list : null_or_value",
"null_or_value_list : null_or_value_list ',' null_or_value",
"null_or_value : null_value",
"null_or_value : value",
"table_name : simple_table_name",
"table_name : symbol_table_name symbol_table_alias_name",
"simple_table_name : symbol_table_name",
"join_type : INNER",
"join_type : LEFT",
"join_type : LEFT OUTER",
"join_type : RIGHT",
"join_type : RIGHT OUTER",
"join_type : FULL",
"join_type : FULL OUTER",
"join_type :",
"first_clause : FIRST long_integer",
"first_clause : FIRST '(' value ')'",
"first_clause : FIRST parameter",
"skip_clause : SKIP long_integer",
"skip_clause : SKIP '(' value ')'",
"skip_clause : SKIP parameter",
"limit_clause : first_clause skip_clause",
"limit_clause : first_clause",
"limit_clause : skip_clause",
"limit_clause :",
"group_clause : GROUP BY grp_column_list",
"group_clause :",
"grp_column_list : grp_column_elem",
"grp_column_list : grp_column_list ',' grp_column_elem",
"grp_column_elem : column_name",
"grp_column_elem : udf",
"grp_column_elem : column_name COLLATE symbol_collation_name",
"having_clause : HAVING search_condition",
"having_clause :",
"where_clause : WHERE search_condition",
"where_clause :",
"plan_clause : PLAN plan_expression",
"plan_clause :",
"plan_expression : plan_type '(' plan_item_list ')'",
"plan_type : JOIN",
"plan_type : SORT MERGE",
"plan_type : MERGE",
"plan_type : SORT",
"plan_type :",
"plan_item_list : plan_item",
"plan_item_list : plan_item ',' plan_item_list",
"plan_item : table_or_alias_list access_type",
"plan_item : plan_expression",
"table_or_alias_list : symbol_table_name",
"table_or_alias_list : symbol_table_name table_or_alias_list",
"access_type : NATURAL",
"access_type : INDEX '(' index_list ')'",
"access_type : ORDER symbol_index_name",
"index_list : symbol_index_name",
"index_list : symbol_index_name ',' index_list",
"insert : INSERT INTO simple_table_name ins_column_parens_opt VALUES '(' insert_value_list ')'",
"insert : INSERT INTO simple_table_name ins_column_parens_opt select_expr",
"insert_value_list : rhs",
"insert_value_list : insert_value_list ',' rhs",
"delete : delete_searched",
"delete : delete_positioned",
"delete_searched : DELETE FROM table_name where_clause",
"delete_positioned : DELETE FROM table_name cursor_clause",
"cursor_clause : WHERE CURRENT OF symbol_cursor_name",
"update : update_searched",
"update : update_positioned",
"update_searched : UPDATE table_name SET assignments where_clause",
"update_positioned : UPDATE table_name SET assignments cursor_clause",
"assignments : assignment",
"assignments : assignments ',' assignment",
"assignment : update_column_name '=' rhs",
"rhs : value",
"rhs : null_value",
"blob : READ BLOB simple_column_name FROM simple_table_name filter_clause segment_clause",
"blob : INSERT BLOB simple_column_name INTO simple_table_name filter_clause segment_clause",
"filter_clause : FILTER FROM blob_subtype_value TO blob_subtype_value",
"filter_clause : FILTER TO blob_subtype_value",
"filter_clause :",
"blob_subtype_value : blob_subtype",
"blob_subtype_value : parameter",
"blob_subtype : signed_short_integer",
"segment_clause : MAX_SEGMENT segment_length",
"segment_clause :",
"segment_length : unsigned_short_integer",
"segment_length : parameter",
"column_parens_opt : column_parens",
"column_parens_opt :",
"column_parens : '(' column_list ')'",
"column_list : simple_column_name",
"column_list : column_list ',' simple_column_name",
"ins_column_parens_opt : ins_column_parens",
"ins_column_parens_opt :",
"ins_column_parens : '(' ins_column_list ')'",
"ins_column_list : update_column_name",
"ins_column_list : ins_column_list ',' update_column_name",
"column_name : simple_column_name",
"column_name : symbol_table_alias_name '.' symbol_column_name",
"column_name : symbol_table_alias_name '.' '*'",
"simple_column_name : symbol_column_name",
"update_column_name : simple_column_name",
"update_column_name : symbol_table_alias_name '.' symbol_column_name",
"search_condition : predicate",
"search_condition : search_condition OR search_condition",
"search_condition : search_condition AND search_condition",
"search_condition : NOT search_condition",
"predicate : comparison_predicate",
"predicate : between_predicate",
"predicate : like_predicate",
"predicate : in_predicate",
"predicate : null_predicate",
"predicate : quantified_predicate",
"predicate : exists_predicate",
"predicate : containing_predicate",
"predicate : starting_predicate",
"predicate : unique_predicate",
"predicate : '(' search_condition ')'",
"comparison_predicate : value '=' value",
"comparison_predicate : value '<' value",
"comparison_predicate : value '>' value",
"comparison_predicate : value GEQ value",
"comparison_predicate : value LEQ value",
"comparison_predicate : value NOT_GTR value",
"comparison_predicate : value NOT_LSS value",
"comparison_predicate : value NEQ value",
"quantified_predicate : value '=' ALL '(' column_select ')'",
"quantified_predicate : value '<' ALL '(' column_select ')'",
"quantified_predicate : value '>' ALL '(' column_select ')'",
"quantified_predicate : value GEQ ALL '(' column_select ')'",
"quantified_predicate : value LEQ ALL '(' column_select ')'",
"quantified_predicate : value NOT_GTR ALL '(' column_select ')'",
"quantified_predicate : value NOT_LSS ALL '(' column_select ')'",
"quantified_predicate : value NEQ ALL '(' column_select ')'",
"quantified_predicate : value '=' some '(' column_select ')'",
"quantified_predicate : value '<' some '(' column_select ')'",
"quantified_predicate : value '>' some '(' column_select ')'",
"quantified_predicate : value GEQ some '(' column_select ')'",
"quantified_predicate : value LEQ some '(' column_select ')'",
"quantified_predicate : value NOT_GTR some '(' column_select ')'",
"quantified_predicate : value NOT_LSS some '(' column_select ')'",
"quantified_predicate : value NEQ some '(' column_select ')'",
"some : SOME",
"some : ANY",
"between_predicate : value BETWEEN value AND value",
"between_predicate : value NOT BETWEEN value AND value",
"like_predicate : value LIKE value",
"like_predicate : value NOT LIKE value",
"like_predicate : value LIKE value ESCAPE value",
"like_predicate : value NOT LIKE value ESCAPE value",
"in_predicate : value IN scalar_set",
"in_predicate : value NOT IN scalar_set",
"containing_predicate : value CONTAINING value",
"containing_predicate : value NOT CONTAINING value",
"starting_predicate : value STARTING value",
"starting_predicate : value NOT STARTING value",
"starting_predicate : value STARTING WITH value",
"starting_predicate : value NOT STARTING WITH value",
"exists_predicate : EXISTS '(' select_expr ')'",
"unique_predicate : SINGULAR '(' select_expr ')'",
"null_predicate : value IS KW_NULL",
"null_predicate : value IS NOT KW_NULL",
"scalar_set : '(' constant_list ')'",
"scalar_set : '(' column_select ')'",
"column_select : SELECT limit_clause distinct_clause value from_clause where_clause group_clause having_clause plan_clause",
"column_singleton : SELECT limit_clause distinct_clause value from_clause where_clause group_clause having_clause plan_clause",
"value : column_name",
"value : array_element",
"value : function",
"value : u_constant",
"value : parameter",
"value : variable",
"value : udf",
"value : '-' value",
"value : '+' value",
"value : value '+' value",
"value : value CONCATENATE value",
"value : value COLLATE symbol_collation_name",
"value : value '-' value",
"value : value '*' value",
"value : value '/' value",
"value : '(' value ')'",
"value : '(' column_singleton ')'",
"value : current_user",
"value : current_role",
"value : DB_KEY",
"value : symbol_table_alias_name '.' DB_KEY",
"value : KW_VALUE",
"value : datetime_value_expression",
"datetime_value_expression : CURRENT_DATE",
"datetime_value_expression : CURRENT_TIME",
"datetime_value_expression : CURRENT_TIMESTAMP",
"array_element : column_name '[' value_list ']'",
"value_list : value",
"value_list : value_list ',' value",
"constant : u_constant",
"constant : '-' u_numeric_constant",
"u_numeric_constant : NUMERIC",
"u_numeric_constant : NUMBER",
"u_numeric_constant : FLOAT",
"u_numeric_constant : NUMBER64BIT",
"u_numeric_constant : SCALEDINT",
"u_constant : u_numeric_constant",
"u_constant : sql_string",
"u_constant : DATE STRING",
"u_constant : TIME STRING",
"u_constant : TIMESTAMP STRING",
"constant_list : constant",
"constant_list : parameter",
"constant_list : current_user",
"constant_list : current_role",
"constant_list : constant_list ',' constant",
"constant_list : constant_list ',' parameter",
"constant_list : constant_list ',' current_user",
"constant_list : constant_list ',' current_role",
"parameter : '?'",
"current_user : USER",
"current_user : CURRENT_USER",
"current_role : CURRENT_ROLE",
"sql_string : STRING",
"sql_string : INTRODUCER STRING",
"signed_short_integer : nonneg_short_integer",
"signed_short_integer : '-' neg_short_integer",
"nonneg_short_integer : NUMBER",
"neg_short_integer : NUMBER",
"pos_short_integer : nonneg_short_integer",
"unsigned_short_integer : NUMBER",
"signed_long_integer : long_integer",
"signed_long_integer : '-' long_integer",
"long_integer : NUMBER",
"function : COUNT '(' '*' ')'",
"function : COUNT '(' all_noise value ')'",
"function : COUNT '(' DISTINCT value ')'",
"function : SUM '(' all_noise value ')'",
"function : SUM '(' DISTINCT value ')'",
"function : AVG '(' all_noise value ')'",
"function : AVG '(' DISTINCT value ')'",
"function : MINIMUM '(' all_noise value ')'",
"function : MINIMUM '(' DISTINCT value ')'",
"function : MAXIMUM '(' all_noise value ')'",
"function : MAXIMUM '(' DISTINCT value ')'",
"function : CAST '(' rhs AS data_type_descriptor ')'",
"function : KW_UPPER '(' value ')'",
"function : GEN_ID '(' symbol_generator_name ',' value ')'",
"function : EXTRACT '(' timestamp_part FROM value ')'",
"function : SUBSTRING '(' value FROM pos_short_integer ')'",
"function : SUBSTRING '(' value FROM pos_short_integer FOR nonneg_short_integer ')'",
"udf : symbol_UDF_name '(' value_list ')'",
"udf : symbol_UDF_name '(' ')'",
"timestamp_part : YEAR",
"timestamp_part : MONTH",
"timestamp_part : DAY",
"timestamp_part : HOUR",
"timestamp_part : MINUTE",
"timestamp_part : SECOND",
"timestamp_part : WEEKDAY",
"timestamp_part : YEARDAY",
"all_noise : ALL",
"all_noise :",
"null_value : KW_NULL",
"symbol_UDF_name : SYMBOL",
"symbol_blob_subtype_name : SYMBOL",
"symbol_character_set_name : SYMBOL",
"symbol_collation_name : SYMBOL",
"symbol_column_name : SYMBOL",
"symbol_constraint_name : SYMBOL",
"symbol_cursor_name : SYMBOL",
"symbol_domain_name : SYMBOL",
"symbol_exception_name : SYMBOL",
"symbol_filter_name : SYMBOL",
"symbol_gdscode_name : SYMBOL",
"symbol_generator_name : SYMBOL",
"symbol_index_name : SYMBOL",
"symbol_item_alias_name : SYMBOL",
"symbol_procedure_name : SYMBOL",
"symbol_role_name : SYMBOL",
"symbol_table_alias_name : SYMBOL",
"symbol_table_name : SYMBOL",
"symbol_trigger_name : SYMBOL",
"symbol_user_name : SYMBOL",
"symbol_variable_name : SYMBOL",
"symbol_view_name : SYMBOL",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
static int yydebug;
static int yynerrs;
#ifndef SHLIB_DEFS
int DSQL_yyerrflag;
#endif
#ifndef SHLIB_DEFS
int DSQL_yychar;
#endif
short *yyssp;
static YYSTYPE *yyvsp;
static YYSTYPE yyval;
static YYSTYPE yylval;
static short yyss[YYSTACKSIZE];
static YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE

/*
 *	PROGRAM:	Dynamic SQL runtime support
 *	MODULE:		lex.c
 *	DESCRIPTION:	Lexical routine
 *
 */

#include "../dsql/chars.h"

#define MAX_TOKEN_LEN   256
#define CHECK_BOUND(to)\
    {\
    if ((to - string) >= MAX_TOKEN_LEN)        \
	yyabandon (-104, isc_token_too_long); \
    }
#define CHECK_COPY_INCR(to,ch){CHECK_BOUND(to); *to++=ch;}


static TEXT	*lex_position (void);
static BOOLEAN	long_int (NOD, SLONG *);
static FLD	make_field (NOD);
static FIL	make_file (void);
static NOD	make_list (NOD);
static NOD	make_node (NOD_TYPE, int, ...);
static NOD	make_flag_node (NOD_TYPE, SSHORT, int, ...);
static void	prepare_console_debug (int, int *);
static BOOLEAN	short_int (NOD, SLONG *, SSHORT);
static void	stack_nodes (NOD, LLS *);
static int 	swallow_single_line_comment (void);
static int	yylex (USHORT, USHORT, USHORT, BOOLEAN *);
static void	yyabandon (SSHORT, STATUS);
#ifndef WINDOWS_ONLY
static void	check_log_file_attrs (void);
#endif

static TEXT	*ptr, *end, *last_token, *line_start;
static TEXT	*last_token_bk, *line_start_bk;
static SSHORT	lines, att_charset;
static SSHORT	lines_bk;
static BOOLEAN	first_time;

typedef struct tok {
    USHORT	tok_ident;
    CONST SCHAR	*tok_string;
    CONST USHORT tok_version;
} TOK;

#define DSQL_KEYWORD(tok_nr, tok_str, tok_ver) tok_nr, tok_str, tok_ver,

static CONST TOK tokens [] = {
#include "../dsql/keywords.h"
    0, 0, 0
    };

#undef DSQL_KEYWORD


void LEX_dsql_init (void)
{
/**************************************
 *
 *	L E X _ d s q l _ i n i t
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX for processing.  This is called only once
 *	per session.
 *
 **************************************/
CONST TOK	*token;

for (token = tokens; token->tok_string; ++token)
    {
    SYM         symbol;
    STR         str;

    symbol = (SYM) ALLOCPV (type_sym, 0);
    symbol->sym_string = (TEXT *) token->tok_string;
    symbol->sym_length = strlen (token->tok_string);
    symbol->sym_type = SYM_keyword;
    symbol->sym_keyword = token->tok_ident;
    symbol->sym_version = token->tok_version;
    str = (STR) ALLOCPV (type_str, symbol->sym_length);
    str->str_length = symbol->sym_length;
    strncpy (str->str_data, symbol->sym_string, symbol->sym_length);
    symbol->sym_object = (void *) str;
    HSHD_insert (symbol);
    }

}

void LEX_string (
    TEXT	*string,
    USHORT	length,
    SSHORT	character_set)
{
/**************************************
 *
 *	L E X _ s t r i n g
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX to process a string.
 *
 **************************************/

line_start = ptr = string;
end = string + length;
lines = 1;
att_charset = character_set;
line_start_bk = line_start;
lines_bk = lines;
first_time = TRUE;
#ifdef DEV_BUILD
if (DSQL_debug > 10)
    printf("%.*s\n", (int)length, string);
#endif
}

#ifndef WINDOWS_ONLY
static void check_log_file_attrs (void)
{
/**********************************************
 *
 *	c h e c k _ l o g _ f i l e _ a t t r s
 *
 **********************************************
 *
 * Functional description
 *	Check if log file attributes are valid
 *
 *********************************************/

if (g_file->fil_partitions)
    {
    if (!g_file->fil_length)
	{
	yyabandon (-261, isc_log_length_spec);
	/* Total length of a partitioned log must be specified */
	}

    if (PARTITION_SIZE (OneK * g_file->fil_length, g_file->fil_partitions) <
	(OneK*MIN_LOG_LENGTH))
	{
	yyabandon (-239, isc_partition_too_small);
	    /* Log partition size too small */
	}
    }
else
    {
    if ((g_file->fil_length) && (g_file->fil_length < MIN_LOG_LENGTH))
	{
	yyabandon (-239, isc_log_too_small);   /* Log size too small */
	}
    }     
}
#endif

static TEXT *lex_position (void)
{
/**************************************
 *
 *	l e x _ p o s i t i o n
 *
 **************************************
 *
 * Functional description
 *	Return the current position of LEX 
 *	in the input string.
 *
 **************************************/

return ptr;
}

static BOOLEAN long_int (
    NOD		string,
    SLONG	*long_value)
{
/*************************************
 *
 *	l o n g _ i n t
 * 
 *************************************
 *
 * Functional description
 *	checks for all digits in the
 *	number and return an atol().
 *
 *************************************/
UCHAR	*p;

for (p = ((STR) string)->str_data; classes [*p] & CHR_DIGIT; p++)
    if (!(classes [*p] & CHR_DIGIT))
	return FALSE;

*long_value = atol ((char *)((STR) string)->str_data);

return TRUE;
}

static FLD make_field (
    NOD		field_name)
{
/**************************************
 *
 *	m a k e _ f i e l d
 *
 **************************************
 *
 * Functional description
 *	Make a field block of given name.
 *
 **************************************/
FLD	field;
STR	string;
TSQL    tdsql;

tdsql = GET_THREAD_DATA;
       
if (field_name == NULL)
   {
    field = (FLD) ALLOCDV (type_fld, sizeof (INTERNAL_FIELD_NAME));
    strcpy (field->fld_name, (TEXT*) INTERNAL_FIELD_NAME);
    return field;
   }
string = (STR) field_name->nod_arg [1];
field = (FLD) ALLOCDV (type_fld, strlen ((SCHAR*) string->str_data));
strcpy (field->fld_name, (TEXT*) string->str_data);

return field;
}

static FIL make_file (void)
{
/**************************************
 *
 *	m a k e _ f i l e 
 *
 **************************************
 *
 * Functional description
 *	Make a file block
 *
 **************************************/
FIL	temp_file;
TSQL    tdsql;

tdsql = GET_THREAD_DATA;
       
temp_file = (FIL) ALLOCD (type_fil);

return temp_file;
}

static NOD make_list (
    NOD		node)
{
/**************************************
 *
 *	m a k e _ l i s t
 *
 **************************************
 *
 * Functional description
 *	Collapse nested list nodes into single list.
 *
 **************************************/
NOD	*ptr;
LLS	stack, temp;
USHORT	l;
NOD	old;
TSQL    tdsql;

tdsql = GET_THREAD_DATA;

if (!node)
    return node;

stack = 0;
stack_nodes (node, &stack);
for (l = 0, temp = stack; temp; temp = temp->lls_next)
    l++;

old  = node;
node = (NOD) ALLOCDV (type_nod, l);
node->nod_count = l;
node->nod_type  = nod_list;
node->nod_flags = old->nod_flags;
ptr = node->nod_arg + node->nod_count;

while (stack)
    *--ptr = (NOD) LLS_POP (&stack);

return node;
}

static NOD make_node (
    NOD_TYPE	type,
    int		count,
    ...)
{
/**************************************
 *
 *	m a k e _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type.
 *	Any change should also be made to function below
 *
 **************************************/
NOD	node, *p;
va_list	ptr;
TSQL    tdsql;

tdsql = GET_THREAD_DATA;

node = (NOD) ALLOCDV (type_nod, count);
node->nod_type = type;
node->nod_line = (USHORT) lines_bk;
node->nod_column = (USHORT) (last_token_bk - line_start_bk + 1);
node->nod_count = count;
p = node->nod_arg;
VA_START (ptr, count);

while (--count >= 0)
    *p++ = va_arg (ptr, NOD);

return node;
}

static NOD make_flag_node (
    NOD_TYPE	type,
    SSHORT	flag,
    int		count,
    ...)
{
/**************************************
 *
 *	m a k e _ f l a g _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type. Set flag field
 *
 **************************************/
NOD	node, *p;
va_list	ptr;
TSQL    tdsql;

tdsql = GET_THREAD_DATA;

node = (NOD) ALLOCDV (type_nod, count);
node->nod_type = type;
node->nod_flags = flag;
node->nod_line = (USHORT) lines_bk;
node->nod_column = (USHORT) (last_token_bk - line_start_bk + 1);
node->nod_count = count;
p = node->nod_arg;
VA_START (ptr, count);

while (--count >= 0)
    *p++ = va_arg (ptr, NOD);

return node;
}

static void prepare_console_debug (int level, int *yydeb)
{
/*************************************
 *
 *	p r e p a r e _ c o n s o l e _ d e b u g
 * 
 *************************************
 *
 * Functional description
 *	Activate debug info. In WinNT, redirect the standard
 *	output so one can see the generated information.
 *	Feel free to add your platform specific code.
 *
 *************************************/
DSQL_debug = level;
if (level > 10)
	*yydeb = level;
/* CVC: I added this code form Mike Nordell to see the output from internal
operations that's generated in DEV build when DEBUG <n> is typed into isql.exe.
When n>0, the output console is activated; otherwise it's closed. */
#if defined(DEV_BUILD) && defined(WIN32) && defined(SUPERSERVER)
if (level > 0)
{
	/* Console debug code inside this scope */
	if (AllocConsole())
	{
    		redirected_output = freopen("CONOUT$", "wt", stdout);
    		printf("DebugConsole - Yes, it's working.\n");
	}
}
else if (level <= 0 && redirected_output)
{
	fclose (redirected_output);
	redirected_output = 0;
	FreeConsole();
}
#endif
}

static BOOLEAN short_int (
    NOD		string,
    SLONG	*long_value,
    SSHORT	range)
{
/*************************************
 *
 *	s h o r t _ i n t
 * 
 *************************************
 *
 * Functional description
 *	is the string a valid representation 
 *	of a positive short int?
 *
 *************************************/
UCHAR	*p;
SCHAR	buf [10];    
BOOLEAN return_value;

if (((STR) string)->str_length > 5)
    return FALSE;

for (p = ((STR) string)->str_data; classes [*p] & CHR_DIGIT; p++)
    if (!(classes [*p] & CHR_DIGIT))
	return FALSE;

/* there are 5 or fewer digits, it's value may still be greater
 * than 32767... */

buf [0] = ((STR) string)->str_data[0];
buf [1] = ((STR) string)->str_data[1];
buf [2] = ((STR) string)->str_data[2];
buf [3] = ((STR) string)->str_data[3];
buf [4] = ((STR) string)->str_data[4];
buf [5] = '\0';

*long_value = atoi (buf);

switch (range) 
    {
    case POSITIVE:
        return_value = *long_value > SHRT_POS_MAX;		
	break;
    case NEGATIVE:
	return_value = *long_value > SHRT_NEG_MAX;
	break;
    case UNSIGNED:
	return_value = *long_value > SHRT_UNSIGNED_MAX;		
	break;
    }
return !return_value;
}

static void stack_nodes (
    NOD		node,
    LLS		*stack)
{
/**************************************
 *
 *	s t a c k _ n o d e s
 *
 **************************************
 *
 * Functional description
 *	Assist in turning a tree of misc nodes into a clean list.
 *
 **************************************/
NOD	*ptr, *end;
NOD     curr_node, next_node, start_chain, end_chain, save_link;

if (node->nod_type != nod_list)
    {
    LLS_PUSH (node, stack);
    return;
    }

/* To take care of cases where long lists of nodes are in a chain
   of list nodes with exactly one entry, this algorithm will look
   for a pattern of repeated list nodes with two entries, the first
   being a list node and the second being a non-list node.   Such
   a list will be reverse linked, and then re-reversed, stacking the
   non-list nodes in the process.   The purpose of this is to avoid
   massive recursion of this function. */

start_chain = node;
end_chain = (NOD) NULL;
curr_node = node;
next_node = node->nod_arg[0];
while ( curr_node->nod_count == 2 &&
        curr_node->nod_arg[0]->nod_type == nod_list &&
        curr_node->nod_arg[1]->nod_type != nod_list &&
        next_node->nod_arg[0]->nod_type == nod_list &&
        next_node->nod_arg[1]->nod_type != nod_list)
    {

    /* pattern was found so reverse the links and go to next node */

    save_link = next_node->nod_arg[0];
    next_node->nod_arg[0] = curr_node;
    curr_node = next_node;
    next_node = save_link;
    end_chain = curr_node;
    }

/* see if any chain was found */

if ( end_chain)
    {

    /* first, handle the rest of the nodes */
    /* note that next_node still points to the first non-pattern node */

    stack_nodes( next_node, stack);

    /* stack the non-list nodes and reverse the chain on the way back */
    
    curr_node = end_chain;
    while ( TRUE)
        {
        LLS_PUSH( curr_node->nod_arg[1], stack);
        if ( curr_node == start_chain)
            break;
        save_link = curr_node->nod_arg[0];
        curr_node->nod_arg[0] = next_node;
        next_node = curr_node;
        curr_node = save_link;
        }
    return;
    }

for (ptr = node->nod_arg, end = ptr + node->nod_count; ptr < end; ptr++)
    stack_nodes (*ptr, stack);
}

static int swallow_single_line_comment (void)
{
/**************************************
 *
 *	s w a l l o w _ s i n g l e _ l i n e _ c o m m e n t
 *
 **************************************
 *
 * Functional description:
 *  Discard single line comments (SLC) starting with --
 *  and takes care of end of input if necessary.
 *  There may be multiple consecutive SLC, multiple SLC
 *  separated by valid commands or by LF.
 *
 **************************************/
	SSHORT	c;
	
	if (ptr >= end)
		return -1;
	while (ptr + 1 < end)
	{
		c = *ptr++;
		if (c == '-' && *ptr == '-')
		{
			ptr++;
			while (ptr < end)
				if ((c = *ptr++) == '\n')
				{
					lines++;
					line_start = ptr;
					break;
				}
				if (ptr >= end)
					return -1;
		}
		else 
		{
			--ptr;
			break;
		}
	}
	return 0;
}

static int yylex (
    USHORT	client_dialect,
    USHORT	db_dialect,
    USHORT	parser_version,
    BOOLEAN	*stmt_ambiguous)
{
/**************************************
 *
 *	y y l e x
 *
 **************************************
 *
 * Functional description: lexer.
 *
 **************************************/
UCHAR	*p, class, string [MAX_TOKEN_LEN], *buffer, *buffer_end, *new_buffer;
SYM	sym;
SSHORT	c;
USHORT	buffer_len;

STR	delimited_id_str;

/* Find end of white space and skip comments */

/* CVC: Experiment to see if -- can be implemented as one-line comment. 
This is almost the same block than below in the loop when \n is detected,
but here we should "unget" the first character if there're not 2 hyphens. */
if (first_time)
{
	first_time = FALSE;
	if (swallow_single_line_comment() < 0)
		return -1;
}

for (;;)
    {
    if (ptr >= end)
		return -1;
    
    c = *ptr++;

    while (c == '\n')
    {
		lines++;
		line_start = ptr /* + 1*/; /* CVC: +1 left out. */
		/* CVC: Experiment to see if -- can be implemented as one-line comment. */
		if (swallow_single_line_comment() < 0)
			return -1;
		c = *ptr++;
	}

    if ((c == '/') && (*ptr == '*'))
	{
	ptr++;
	while (ptr < end)
	    {
	    if ((c = *ptr++) == '*')
		{
		if (*ptr == '/')
		    break;
		}
	    if (c == '\n')
		{
		lines++;
		line_start = ptr /* + 1*/; /* CVC: +1 left out. */
		}
	    }
	if (ptr >= end)
	    return -1;
	ptr++;
	continue;
	}

#if (! ( defined JPN_SJIS || defined JPN_EUC) )
    class = classes [c];
#else
    c = c & 0xff;
    class = (JPN1_CHAR(c) ? CHR_LETTER : classes[c]);
#endif /*JPN_SJIS || JPN_EUC */

    if (!(class & CHR_WHITE))
	break;
    }

/* Depending on class of token, parse token */

last_token = ptr - 1;

if (class & CHR_INTRODUCER)
    {
    /* The Introducer (_) is skipped, all other idents are copied
     * to become the name of the character set
     */
    p = string;
    for (; ptr < end && classes [*ptr] & CHR_IDENT; ptr++)
	{
	if (ptr >= end)
	    return -1;
	CHECK_COPY_INCR(p, UPPER7(*ptr));
	}
    
    CHECK_BOUND(p);
    *p = 0;

    /* make a string value to hold the name, the name 
     * is resolved in pass1_constant */

    yylval = (NOD) (MAKE_string (string, p - string))->str_data;

    return INTRODUCER;
    }

/* parse a quoted string, being sure to look for double quotes */

if (class & CHR_QUOTE)
    {
    buffer = string;
    buffer_len = sizeof (string);
    buffer_end = buffer + buffer_len - 1;
    for (p = buffer; ; p++)
	{
	if (ptr >= end)
	    {
	    if (buffer != string)
       		gds__free (buffer);
	    return -1;
	    }
	/* *ptr is quote - if next != quote we're at the end */
	if ((*ptr == c) && ((++ptr == end) || (*ptr != c)))
	    break;
        if (p > buffer_end)
	    {
	    new_buffer = (UCHAR *) gds__alloc (2 * buffer_len);
	    /* FREE: at outer block */
	    if (!new_buffer)		/* NOMEM: */
		{
		if (buffer != string)
		    gds__free (buffer);
		return -1;
		}
            memcpy (new_buffer, buffer, buffer_len);
	    if (buffer != string)
        	gds__free (buffer);
	    buffer = new_buffer;
	    p = buffer + buffer_len;
	    buffer_len = 2 * buffer_len;
	    buffer_end = buffer + buffer_len - 1;
	    }
	*p = *ptr++;
	}
    if (c == '"')
	{
	*stmt_ambiguous = TRUE; /* string delimited by double quotes could be
				**   either a string constant or a SQL delimited
				**   identifier, therefore marks the SQL
				**   statement as ambiguous  */
	if (client_dialect == SQL_DIALECT_V6_TRANSITION)
	    {
	    if (buffer != string)
		gds__free (buffer);
	    yyabandon (-104, isc_invalid_string_constant);
	    }
	else if (client_dialect >= SQL_DIALECT_V6)
	    {
	    if ((p - buffer) >= MAX_TOKEN_LEN)
		{
		if (buffer != string)
		    gds__free (buffer);
		yyabandon (-104, isc_token_too_long);
		}
	    yylval = (NOD) MAKE_string (buffer, p - buffer);
	    delimited_id_str = (STR) yylval;
	    delimited_id_str->str_flags |= STR_delimited_id;
	    if (buffer != string)
		gds__free (buffer);
	    return SYMBOL;
	    }
	}
    yylval = (NOD) MAKE_string (buffer, p - buffer);
    if (buffer != string)
	gds__free (buffer);
    return STRING;
    }
                                                 
/* 
 * Check for a numeric constant, which starts either with a digit or with
 * a decimal point followed by a digit.
 * 
 * This code recognizes the following token types:
 * 
 * NUMBER: string of digits which fits into a 32-bit integer
 * 
 * NUMBER64BIT: string of digits whose value might fit into an SINT64,
 *   depending on whether or not there is a preceding '-', which is to
 *   say that "9223372036854775808" is accepted here.
 *
 * SCALEDINT: string of digits and a single '.', where the digits
 *   represent a value which might fit into an SINT64, depending on
 *   whether or not there is a preceding '-'.
 *
 * FLOAT: string of digits with an optional '.', and followed by an "e"
 *   or "E" and an optionally-signed exponent.
 *
 * NOTE: we swallow leading or trailing blanks, but we do NOT accept
 *   embedded blanks:
 *
 * Another note: c is the first character which need to be considered,
 *   ptr points to the next character.
 */

assert(ptr <= end);

if ((class & CHR_DIGIT) ||
    ((c == '.') && (ptr < end) && (classes [*ptr] & CHR_DIGIT)))
    {
    /* The following variables are used to recognize kinds of numbers. */

    BOOLEAN have_error     = FALSE;	/* syntax error or value too large */
    BOOLEAN have_digit     = FALSE;	/* we've seen a digit              */
    BOOLEAN have_decimal   = FALSE;	/* we've seen a '.'                */
    BOOLEAN have_exp       = FALSE;	/* digit ... [eE]                  */
    BOOLEAN have_exp_sign  = FALSE; /* digit ... [eE] {+-]             */
    BOOLEAN have_exp_digit = FALSE; /* digit ... [eE] ... digit        */
    UINT64	number         = 0;
    UINT64	limit_by_10    = MAX_SINT64 / 10;

    for (--ptr ; ptr < end ; ptr++)
      {
	c = *ptr;
	if (have_exp_digit && (! (classes [c]  & CHR_DIGIT)))
	  /* First non-digit after exponent and digit terminates
	     the token. */
	    break;
	else if (have_exp_sign && (! (classes [c]  & CHR_DIGIT)))
	    {
	    /* only digits can be accepted after "1E-" */
	      have_error = TRUE;
	      break;
	    }
	else if (have_exp)
	    {
	    /* We've seen e or E, but nothing beyond that. */
	    if ( ('-' == c) || ('+' == c) )
		have_exp_sign = TRUE;
	    else if ( classes [c]  & CHR_DIGIT )
		/* We have a digit: we haven't seen a sign yet,
		   but it's too late now. */
		have_exp_digit = have_exp_sign  = TRUE;
	    else
		{
		/* end of the token */
		have_error = TRUE;
		break;
		}
	    }
	else if ('.' == c)
	    {
	    if (!have_decimal)
		have_decimal = TRUE;
	    else
		{
		have_error = TRUE;
		break;
		}
	    }
	else if (classes [c] & CHR_DIGIT)
	  {
	    /* Before computing the next value, make sure there will be
	       no overflow.  */

	    have_digit = TRUE;

	    if (number >= limit_by_10)
		/* possibility of an overflow */
		if ((number > limit_by_10) || (c > '8'))
		    {
		    have_error = TRUE;
		    break;
		    }
	    number = number * 10 + (c - '0');
	  }
	else if ( (('E' == c) || ('e' == c)) && have_digit )
	    have_exp = TRUE;
	else
	    /* Unexpected character: this is the end of the number. */
	    break;
      }

    /* We're done scanning the characters: now return the right kind
       of number token, if any fits the bill. */

    if (!have_error)
	{
	assert(have_digit);

	if (have_exp_digit)
	    {
	    yylval = (NOD) MAKE_string ((UCHAR *) last_token,
					ptr - last_token);
	    last_token_bk = last_token;
	    line_start_bk = line_start;
	    lines_bk = lines;
	    return FLOAT;
	    }
	else if (!have_exp)
	    {

	    /* We should return some kind (scaled-) integer type
	       except perhaps in dialect 1. */

	    if (!have_decimal && (number <= MAX_SLONG))
		{
		yylval = (NOD) number;
		return NUMBER;
		}
	    else
		{
		/* We have either a decimal point with no exponent
		   or a string of digits whose value exceeds MAX_SLONG:
		   the returned type depends on the client dialect,
		   so warn of the difference if the client dialect is
		   SQL_DIALECT_V6_TRANSITION.
		*/

		if (SQL_DIALECT_V6_TRANSITION == client_dialect)
		    {
		    /* Issue a warning about the ambiguity of the numeric
		     * numeric literal.  There are multiple calls because
		     * the message text exceeds the 119-character limit
		     * of our message database.
		     */
		    ERRD_post_warning( isc_dsql_warning_number_ambiguous,
				       gds_arg_string,
				       ERR_string( last_token,
						   ptr - last_token ),
				       gds_arg_end );
		    ERRD_post_warning( isc_dsql_warning_number_ambiguous1,
				       gds_arg_end );
		    }

		yylval = (NOD) MAKE_string ((UCHAR *) last_token,
					    ptr - last_token);

		last_token_bk = last_token;
		line_start_bk = line_start;
		lines_bk = lines;
		if (client_dialect < SQL_DIALECT_V6_TRANSITION)
		    return FLOAT;
		else if (have_decimal)
		    return SCALEDINT;
		else
		    return NUMBER64BIT;
		}
	    } /* else if (!have_exp) */
	} /* if (!have_error) */

    /* we got some kind of error or overflow, so don't recognize this
     * as a number: just pass it through to the next part of the lexer.
     */
    }

/* Restore the status quo ante, before we started our unsuccessful
   attempt to recognize a number. */
ptr = last_token;
c   = *ptr++;
/* We never touched class, so it doesn't need to be restored. */

/* end of number-recognition code */


if (class & CHR_LETTER)
    {
#if (! ( defined JPN_SJIS || defined JPN_EUC) )
    p = string;
    CHECK_COPY_INCR(p, UPPER (c));
    for (; ptr < end && classes [*ptr] & CHR_IDENT; ptr++)
        {
	if (ptr >= end)
	    return -1;
	CHECK_COPY_INCR(p, UPPER (*ptr));
        }
#else
    for (; ptr <= end ; c = *ptr++ , c = c & 0xff)
        {
        if (KANJI1(c))
            {
	    CHECK_COPY_INCR(p, UPPER (c));
            if (ptr >= end) 
		break; 
            
	    c = *ptr++;
            c = c & 0xff;
            if (!KANJI2(c))
                {
                ptr--;
                break;
                }
            else
		CHECK_COPY_INCR(p,c);
            }
	else
            {
#ifdef JPN_SJIS
            if ((SJIS_SINGLE(c)) || (classes[c] & CHR_IDENT) )
#else
            if (classes[c] & CHR_IDENT)
#endif 
		{	
		CHECK_COPY_INCR(p, UPPER(c));
		if (ptr >= end)
	    	    break;
		}
            else
		{
		ptr--;
                break;
		}
            }
        }
#endif /* JPN_SJIS || JPN_EUC */

    CHECK_BOUND(p);
    *p = 0;
    sym = HSHD_lookup (NULL_PTR, (TEXT *) string, p - string, SYM_keyword, parser_version);
    if (sym)
	{
	yylval = (NOD) sym->sym_object;
	return sym->sym_keyword;
	}
    yylval = (NOD) MAKE_string (string, p - string);
    last_token_bk = last_token;
    line_start_bk = line_start;
    lines_bk = lines;
    return SYMBOL;
    }

/* Must be punctuation -- test for double character punctuation */

if (last_token + 1 < end)
    {
    sym = HSHD_lookup (NULL_PTR, last_token, 2, SYM_keyword, parser_version);
    if (sym)
	{
	++ptr;
	return sym->sym_keyword;
	}
    }

/* Single character punctuation are simply passed on */

return c;
}

static void yyerror (
    TEXT	*error_string)
{
/**************************************
 *
 *	y y e r r o r
 *
 **************************************
 *
 * Functional description
 *	Print a syntax error.
 *
 **************************************/

if (DSQL_yychar < 1)
    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104,
	gds_arg_gds, gds__command_end_err,    /* Unexpected end of command */
	0);
else
    {
    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104,
 	gds_arg_gds, gds__dsql_token_unk_err, 
	gds_arg_number, (SLONG) lines, 
	gds_arg_number, (SLONG) (last_token - line_start + 1), /*CVC: +1*/
	    /* Token unknown - line %d, char %d */
 	gds_arg_gds, gds__random, 
	gds_arg_cstring, (int) (ptr - last_token), last_token,
 	0);
    }
}

static void yyabandon (
    SSHORT      sql_code,
    STATUS      error_symbol)
{
/**************************************
 *
 *	y y a b a n d o n
 *
 **************************************
 *
 * Functional description
 *	Abandon the parsing outputting the supplied string
 *
 **************************************/

ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) sql_code, 
	gds_arg_gds, error_symbol, 0);
}
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
dsql_yyparse(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, BOOLEAN *stmt_ambiguous)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    DSQL_yyerrflag = 0;
    DSQL_yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (DSQL_yychar < 0)
    {
        if ((DSQL_yychar = yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous)) < 0) DSQL_yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (DSQL_yychar <= YYMAXTOKEN) yys = yyname[DSQL_yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, DSQL_yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += DSQL_yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == DSQL_yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        DSQL_yychar = (-1);
        if (DSQL_yyerrflag > 0)  --DSQL_yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += DSQL_yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == DSQL_yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (DSQL_yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (DSQL_yyerrflag < 3)
    {
        DSQL_yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (DSQL_yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (DSQL_yychar <= YYMAXTOKEN) yys = yyname[DSQL_yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, DSQL_yychar, yys);
        }
#endif
        DSQL_yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
{ DSQL_parse = yyvsp[0]; }
break;
case 2:
{ DSQL_parse = yyvsp[-1]; }
break;
case 19:
{ prepare_console_debug ((int) yyvsp[0], &yydebug);
			  yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 20:
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-5], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 21:
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 22:
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-4], yyvsp[-2], make_list(yyvsp[0]), NULL); }
break;
case 23:
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-5], yyvsp[-2], make_list(yyvsp[0]), NULL); }
break;
case 24:
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					make_list(yyvsp[-3]), make_list(yyvsp[-1]), NULL, yyvsp[0]); }
break;
case 26:
{ yyval = yyvsp[0]; }
break;
case 27:
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 28:
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 29:
{ yyval = make_list (yyvsp[0]); }
break;
case 31:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 32:
{ yyval = make_list (make_node (nod_execute, (int) 0, NULL)); }
break;
case 33:
{ yyval = make_node (nod_select, (int) 0, NULL); }
break;
case 34:
{ yyval = make_node (nod_insert, (int) 0, NULL); }
break;
case 35:
{ yyval = make_node (nod_delete, (int) 0, NULL); }
break;
case 36:
{ yyval = make_node (nod_update, (int) 1, yyvsp[0]); }
break;
case 37:
{ yyval = make_node (nod_references, (int) 1, yyvsp[0]); }
break;
case 38:
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 39:
{ yyval = 0; }
break;
case 40:
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 41:
{ yyval = 0; }
break;
case 42:
{ yyval = make_node (nod_procedure_name, (int) 1, yyvsp[0]); }
break;
case 43:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-4], yyvsp[-2],
				make_list(yyvsp[0]), yyvsp[-5]); }
break;
case 44:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-5], yyvsp[-2],
				make_list(yyvsp[0]), yyvsp[-6]); }
break;
case 45:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-4], yyvsp[-2],
				make_list(yyvsp[0]), NULL); }
break;
case 46:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-5], yyvsp[-2],
				make_list(yyvsp[0]), NULL); }
break;
case 47:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-4], yyvsp[-2],
				make_list(yyvsp[0]), NULL); }
break;
case 48:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-5], yyvsp[-2],
				make_list(yyvsp[0]), NULL); }
break;
case 49:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, make_list(yyvsp[-2]), make_list(yyvsp[0]),
				NULL, NULL); }
break;
case 50:
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 52:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 53:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 54:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 55:
{ yyval = make_node (nod_proc_obj, (int) 1, yyvsp[0]); }
break;
case 56:
{ yyval = make_node (nod_trig_obj, (int) 1, yyvsp[0]); }
break;
case 57:
{ yyval = make_node (nod_view_obj, (int) 1, yyvsp[0]); }
break;
case 58:
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 60:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 61:
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 62:
{ yyval = make_node (nod_user_name, (int) 2, yyvsp[0], NULL); }
break;
case 63:
{ yyval = make_node (nod_user_group, (int) 1, yyvsp[0]); }
break;
case 65:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 66:
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 68:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 69:
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 70:
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 71:
{ yyval = yyvsp[0];}
break;
case 72:
{ yyval = yyvsp[0]; }
break;
case 73:
{ yyval = yyvsp[0]; }
break;
case 74:
{ yyval = make_node (nod_def_udf, (int) e_udf_count, 
				yyvsp[-7], yyvsp[-2], yyvsp[0], make_list (yyvsp[-6]), yyvsp[-4]); }
break;
case 76:
{ g_field->fld_dtype = dtype_blob; }
break;
case 77:
{ 
			g_field->fld_dtype = dtype_cstring; 
			g_field->fld_character_length = (SLONG) yyvsp[-2]; }
break;
case 78:
{ yyval = (NOD) NULL; }
break;
case 80:
{ yyval = yyvsp[-1]; }
break;
case 82:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 83:
{ yyval = make_node (nod_udf_param, (int) e_udf_param_count,
				yyvsp[-1], NULL); }
break;
case 84:
{ yyval = make_node (nod_udf_param, (int) e_udf_param_count,
				yyvsp[-3], MAKE_constant ((STR) FUN_descriptor, CONSTANT_SLONG)); }
break;
case 86:
{ yyval = yyvsp[-1]; }
break;
case 87:
{ yyval = make_node (nod_udf_return_value, (int) 2, yyvsp[-1], 
				MAKE_constant ((STR) FUN_reference, CONSTANT_SLONG));}
break;
case 88:
{ yyval = make_node (nod_udf_return_value, (int) 2, yyvsp[-2], 
				MAKE_constant ((STR) (-1 * FUN_reference), CONSTANT_SLONG));}
break;
case 89:
{ yyval = make_node (nod_udf_return_value, (int) 2, yyvsp[-3], 
				MAKE_constant ((STR) FUN_value, CONSTANT_SLONG));}
break;
case 90:
{ yyval = make_node (nod_udf_return_value, (int) 2, yyvsp[-3],
				MAKE_constant ((STR) FUN_descriptor, CONSTANT_SLONG));}
break;
case 91:
{ yyval = make_node (nod_udf_return_value, (int) 2, 
		  		(NOD) NULL, MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG));}
break;
case 92:
{ yyval = make_node (nod_def_filter, (int) e_filter_count, 
						yyvsp[-8], yyvsp[-6], yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 93:
{ yyval = yyvsp[0]; }
break;
case 94:
{ yyval = make_node (nod_def_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 95:
{ yyval = make_node (nod_def_index, (int) e_idx_count, 
					yyvsp[-6], yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 96:
{ yyval = yyvsp[0]; }
break;
case 97:
{ yyval = yyvsp[0]; }
break;
case 98:
{ yyval = yyvsp[0]; }
break;
case 99:
{ yyval = yyvsp[0]; }
break;
case 100:
{ yyval = yyvsp[0]; }
break;
case 101:
{ yyval = yyvsp[0]; }
break;
case 102:
{ yyval = yyvsp[0]; }
break;
case 103:
{ yyval = yyvsp[0]; }
break;
case 104:
{ yyval = yyvsp[0]; }
break;
case 105:
{ yyval = yyvsp[0]; }
break;
case 106:
{ yyval = yyvsp[0]; }
break;
case 107:
{ yyval = yyvsp[0]; }
break;
case 108:
{ yyval = make_node (nod_unique, (int) 0, NULL); }
break;
case 109:
{ yyval = NULL; }
break;
case 110:
{ yyval = make_list (yyvsp[0]); }
break;
case 112:
{ yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 113:
{ yyval = make_node (nod_def_shadow, (int) e_shadow_count,
			     yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], make_list (yyvsp[0])); }
break;
case 114:
{ yyval = MAKE_constant ((STR) 1, CONSTANT_SLONG); }
break;
case 115:
{ yyval = MAKE_constant ((STR) 0, CONSTANT_SLONG); }
break;
case 116:
{ yyval = MAKE_constant ((STR) 0, CONSTANT_SLONG); }
break;
case 117:
{ yyval = MAKE_constant ((STR) 0, CONSTANT_SLONG); }
break;
case 118:
{ yyval = MAKE_constant ((STR) 1, CONSTANT_SLONG); }
break;
case 119:
{ yyval = (NOD) 0;}
break;
case 120:
{ yyval = yyvsp[-1]; }
break;
case 121:
{ yyval = (NOD) NULL; }
break;
case 124:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 125:
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
                                          yyvsp[-7], yyvsp[-3], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 126:
{ yyval = NULL; }
break;
case 127:
{ yyval = NULL; }
break;
case 128:
{ yyval = yyvsp[0]; }
break;
case 129:
{ yyval = (NOD) NULL; }
break;
case 130:
{ yyval = (NOD) NULL; }
break;
case 133:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 134:
{ yyval = make_node (nod_rel_constraint, (int) 2, NULL, yyvsp[0]);}
break;
case 137:
{ yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 138:
{ yyval = make_node (nod_def_constraint, 
				  (int) e_cnstr_count, MAKE_string (NULL_STRING, 0), NULL, 
				  NULL, NULL, yyvsp[-2], NULL, yyvsp[0], NULL, NULL); }
break;
case 139:
{ yyval = make_node (nod_def_generator, 
						(int) e_gen_count, yyvsp[0]); }
break;
case 140:
{ yyval = make_node (nod_def_role, 
						(int) 1, yyvsp[0]); }
break;
case 141:
{ yyval = make_node (nod_def_database, (int) e_cdb_count,
				 yyvsp[-2], make_list(yyvsp[-1]), make_list (yyvsp[0]));}
break;
case 144:
{ log_defined = FALSE;
			  cache_defined = FALSE;
			  yyval = (NOD) yyvsp[0]; }
break;
case 145:
{yyval = (NOD) NULL;}
break;
case 148:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 149:
{ yyval = make_node (nod_page_size, 1, yyvsp[0]);}
break;
case 150:
{ yyval = make_node (nod_file_length, 1, yyvsp[-1]);}
break;
case 151:
{ yyval = make_node (nod_user_name, 1, yyvsp[0]);}
break;
case 152:
{ yyval = make_node (nod_password, 1, yyvsp[0]);}
break;
case 153:
{ yyval = make_node (nod_lc_ctype, 1, yyvsp[0]);}
break;
case 154:
{yyval = (NOD) NULL;}
break;
case 157:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 161:
{ yyval = make_node (nod_dfl_charset, 1, yyvsp[0]);}
break;
case 162:
{ yyval = make_node (nod_group_commit_wait, 1, yyvsp[0]);}
break;
case 163:
{ yyval = make_node (nod_check_point_len, 1, yyvsp[0]);}
break;
case 164:
{ yyval = make_node (nod_num_log_buffers, 1, yyvsp[0]);}
break;
case 165:
{ yyval = make_node (nod_log_buffer_size, 1, yyvsp[0]);}
break;
case 166:
{ if (log_defined)
			    yyabandon (-260, isc_log_redef);  /* Log redefined */
			  log_defined = TRUE;
			  yyval = yyvsp[0]; }
break;
case 167:
{ if (log_defined)
			    yyabandon (-260, isc_log_redef);
			  log_defined = TRUE;
			  yyval = yyvsp[0]; }
break;
case 168:
{ g_file->fil_flags |= LOG_serial | LOG_overflow; 
			  if (g_file->fil_partitions)
			      yyabandon (-261, isc_partition_not_supp);
			/* Partitions not supported in series of log file specification */
			 yyval = make_node (nod_list, 2, yyvsp[-3], yyvsp[0]); }
break;
case 169:
{ g_file->fil_flags |= LOG_serial;
			  if (g_file->fil_partitions)
			      yyabandon (-261, isc_partition_not_supp);
			  yyval = yyvsp[0]; }
break;
case 170:
{ g_file = make_file(); 
			  g_file->fil_flags = LOG_serial | LOG_default;
			  yyval = make_node (nod_log_file_desc, (int) 1,
						(NOD) g_file);}
break;
case 171:
{ g_file->fil_name = (STR) yyvsp[-1]; 
			  yyval = (NOD) make_node (nod_file_desc, (int) 1,
						(NOD) g_file); }
break;
case 173:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 174:
{ 
#ifndef WINDOWS_ONLY
		         check_log_file_attrs(); 
#endif
			 yyval = (NOD) make_node (nod_log_file_desc, (int) 1,
                                                (NOD) g_file); }
break;
case 175:
{ g_file = make_file();
			  g_file->fil_name = (STR) yyvsp[0]; }
break;
case 178:
{ g_file->fil_length = (SLONG) yyvsp[0]; }
break;
case 179:
{ g_file  = make_file ();}
break;
case 184:
{ g_file->fil_start = (SLONG) yyvsp[0];}
break;
case 185:
{ g_file->fil_length = (SLONG) yyvsp[-1];}
break;
case 192:
{ yyval = make_node (nod_def_relation, 
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 193:
{ yyval = make_node (nod_redef_relation, 
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 194:
{ yyval = yyvsp[0]; }
break;
case 195:
{ yyval = yyvsp[0]; }
break;
case 196:
{ yyval = (NOD) NULL; }
break;
case 198:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 201:
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
					yyvsp[-5], yyvsp[-3], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0], yyvsp[-4], NULL); }
break;
case 202:
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				    yyvsp[-2], NULL, NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 203:
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				    yyvsp[-1], NULL, NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 204:
{ 
			g_field->fld_flags |= FLD_computed;
			yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 207:
{ yyval = NULL; }
break;
case 208:
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
                                            yyvsp[-1], NULL, NULL, NULL, NULL); }
break;
case 209:
{ yyval = yyvsp[0]; }
break;
case 210:
{ yyval = (NOD) NULL; }
break;
case 211:
{ g_field_name = yyvsp[0];
			  g_field = make_field (yyvsp[0]);
			  yyval = (NOD) g_field; }
break;
case 212:
{ g_field = make_field (yyvsp[0]);
				  yyval = (NOD) g_field; }
break;
case 213:
{ yyval = yyvsp[-1]; }
break;
case 214:
{ g_field = make_field (NULL);
			  yyval = (NOD) g_field; }
break;
case 215:
{ yyval = yyvsp[0]; }
break;
case 216:
{ yyval = (NOD) NULL; }
break;
case 217:
{ yyval = yyvsp[0]; }
break;
case 220:
{ yyval = yyvsp[0]; }
break;
case 221:
{ yyval = yyvsp[0]; }
break;
case 222:
{ yyval = (NOD) NULL; }
break;
case 225:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 226:
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 227:
{ yyval = make_node (nod_null, (int) 1, NULL); }
break;
case 228:
{ yyval = make_node (nod_foreign, e_for_count,
                        make_node (nod_list, (int) 1, g_field_name), yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 230:
{ yyval = make_node (nod_unique, (int) 0, NULL); }
break;
case 231:
{ yyval = make_node (nod_primary, (int) 0, NULL); }
break;
case 232:
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 233:
{ yyval = yyvsp[0]; }
break;
case 234:
{ yyval = NULL ;}
break;
case 239:
{ yyval = make_node (nod_unique, 1, yyvsp[0]); }
break;
case 240:
{ yyval = make_node (nod_primary, e_pri_count, yyvsp[0]); }
break;
case 241:
{ yyval = make_node (nod_foreign, e_for_count, yyvsp[-4], yyvsp[-2], 
			         yyvsp[-1], yyvsp[0]); }
break;
case 242:
{ yyval = make_node (nod_def_constraint, 
				(int) e_cnstr_count, MAKE_string (NULL_STRING, 0), NULL, 
				NULL, NULL, yyvsp[-2], NULL, yyvsp[0], NULL, NULL); }
break;
case 243:
{ yyval = make_node (nod_ref_upd_del, e_ref_upd_del_count, yyvsp[0], NULL);}
break;
case 244:
{ yyval = make_node (nod_ref_upd_del, e_ref_upd_del_count, NULL, yyvsp[0]);}
break;
case 245:
{ yyval = make_node (nod_ref_upd_del, e_ref_upd_del_count, yyvsp[0], yyvsp[-1]); }
break;
case 246:
{ yyval = make_node (nod_ref_upd_del, e_ref_upd_del_count, yyvsp[-1], yyvsp[0]);}
break;
case 247:
{ yyval = NULL;}
break;
case 248:
{ yyval = yyvsp[0];}
break;
case 249:
{ yyval = yyvsp[0];}
break;
case 250:
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_CASCADE, e_ref_trig_action_count, NULL);}
break;
case 251:
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_SET_DEFAULT, e_ref_trig_action_count, NULL);}
break;
case 252:
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_SET_NULL, e_ref_trig_action_count, NULL);}
break;
case 253:
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_NONE, e_ref_trig_action_count, NULL);}
break;
case 254:
{ yyval = make_node (nod_def_procedure,
						  (int) e_prc_count, 
					          yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 255:
{ yyval = make_node (nod_redef_procedure,
						  (int) e_prc_count, 
					          yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 256:
{ yyval = make_node (nod_mod_procedure,
						  (int) e_prc_count, 
					          yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 257:
{ yyval = make_list (yyvsp[-1]); }
break;
case 258:
{ yyval = NULL; }
break;
case 259:
{ yyval = yyvsp[0]; }
break;
case 260:
{ yyval = NULL; }
break;
case 262:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 263:
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-1], NULL, NULL, NULL, NULL, NULL, NULL); }
break;
case 264:
{ yyval = make_list (yyvsp[0]); }
break;
case 265:
{ yyval = NULL; }
break;
case 267:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 268:
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-2], NULL, NULL, NULL, NULL, NULL, NULL); }
break;
case 271:
{ yyval = make_node (nod_block, e_blk_count,
					make_list (yyvsp[-1]), NULL);}
break;
case 272:
{ yyval = make_node (nod_block, e_blk_count,
					make_list (yyvsp[-2]), make_list (yyvsp[-1]));}
break;
case 274:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 277:
{ yyval = make_node (nod_exception_stmt, 1, yyvsp[-1]); }
break;
case 282:
{ yyval = make_node (nod_post, e_pst_count, yyvsp[-1]); }
break;
case 286:
{ yyval = make_node (nod_return, e_rtn_count, NULL); }
break;
case 287:
{ yyval = make_node (nod_exit, 0, NULL); }
break;
case 288:
{ yyval = make_node (nod_breakleave, e_break_count, NULL); }
break;
case 289:
{ yyval = make_node (nod_exec_procedure, e_exe_count, yyvsp[-3],
					  yyvsp[-2], yyvsp[-1]); }
break;
case 290:
{ yyval = make_node (nod_for_select, e_flp_count, yyvsp[-5],
					  make_list (yyvsp[-3]), yyvsp[-2], yyvsp[0], NULL); }
break;
case 291:
{ yyval = make_node (nod_if, e_if_count, yyvsp[-5], yyvsp[-2], yyvsp[0]); }
break;
case 292:
{ yyval = make_node (nod_if, e_if_count, yyvsp[-3], yyvsp[0], NULL); }
break;
case 293:
{ yyval = make_node (nod_for_select, e_flp_count, yyvsp[-3],
					  make_list (yyvsp[-1]), NULL, NULL); }
break;
case 294:
{ yyval = make_node (nod_var_name, (int) e_vrn_count, 
							yyvsp[0]); }
break;
case 295:
{ yyval = make_list (yyvsp[0]); }
break;
case 296:
{ yyval = make_list (yyvsp[-1]); }
break;
case 297:
{ yyval = NULL; }
break;
case 298:
{ yyval = make_list (yyvsp[0]); }
break;
case 299:
{ yyval = make_list (yyvsp[-1]); }
break;
case 300:
{ yyval = NULL; }
break;
case 305:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 306:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 307:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 308:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 311:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 312:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 313:
{ yyval = make_node (nod_while, e_while_count,
					  yyvsp[-3], yyvsp[0], NULL); }
break;
case 314:
{ yyval = make_node (nod_cursor, e_cur_count, yyvsp[0], NULL, NULL); }
break;
case 315:
{ yyval = NULL; }
break;
case 317:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 318:
{ yyval = make_node (nod_on_error, e_err_count,
					make_list (yyvsp[-2]), yyvsp[0]); }
break;
case 320:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 321:
{ yyval = make_node (nod_sqlcode, 1, yyvsp[0]); }
break;
case 322:
{ yyval = make_node (nod_gdscode, 1, yyvsp[0]); }
break;
case 323:
{ yyval = make_node (nod_exception, 1, yyvsp[0]); }
break;
case 324:
{ yyval = make_node (nod_default, 1, NULL); }
break;
case 325:
{ yyval = make_node (nod_exec_procedure, e_exe_count, yyvsp[-1],
				  yyvsp[0], make_node (nod_all, (int) 0, NULL)); }
break;
case 326:
{ yyval = make_list (yyvsp[0]); }
break;
case 327:
{ yyval = make_list (yyvsp[-1]); }
break;
case 328:
{ yyval = NULL; }
break;
case 332:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 333:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 334:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 335:
{ yyval = make_node (nod_def_view, (int) e_view_count, 
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 336:
{ yyval = make_node (nod_select, (int) 2, yyvsp[0], NULL); }
break;
case 337:
{ yyval = make_node (nod_list, (int) 1, yyvsp[0]); }
break;
case 338:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 339:
{ yyval = make_flag_node (nod_list, NOD_UNION_ALL, 2, yyvsp[-3], yyvsp[0]); }
break;
case 340:
{ yyval = make_node (nod_select_expr, e_sel_count, 
					yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 341:
{ yyval = make_list (yyvsp[0]); }
break;
case 343:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 346:
{ yyval = make_node (nod_join, (int) e_join_count,
						yyvsp[-5], yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 347:
{ yyval = yyvsp[-1]; }
break;
case 348:
{ beginning = lex_position(); }
break;
case 349:
{ yyval = (NOD) MAKE_string ((UCHAR *) beginning, 
			       (lex_position() == end) ?
			       lex_position()-beginning : last_token-beginning);}
break;
case 350:
{ beginning = last_token; }
break;
case 351:
{ yyval = (NOD) MAKE_string ((UCHAR *) beginning, 
					lex_position()-beginning); }
break;
case 352:
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count, 
					MAKE_string (NULL_STRING, 0), NULL, NULL, NULL, 
					NULL, NULL, NULL, NULL, NULL); }
break;
case 353:
{ yyval = 0; }
break;
case 354:
{ yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-8], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0], NULL); }
break;
case 355:
{ yyval = MAKE_constant ((STR) 0, CONSTANT_SLONG); }
break;
case 356:
{ yyval = MAKE_constant ((STR) 1, CONSTANT_SLONG); }
break;
case 357:
{ yyval = NULL; }
break;
case 358:
{ yyval = MAKE_constant ((STR) 1, CONSTANT_SLONG); }
break;
case 359:
{ yyval = MAKE_constant ((STR) 2, CONSTANT_SLONG); }
break;
case 360:
{ yyval = MAKE_constant ((STR) 3, CONSTANT_SLONG); }
break;
case 361:
{ yyval = MAKE_constant ((STR) 4, CONSTANT_SLONG); }
break;
case 362:
{ yyval = MAKE_constant ((STR) 5, CONSTANT_SLONG); }
break;
case 363:
{ yyval = MAKE_constant ((STR) 6, CONSTANT_SLONG); }
break;
case 364:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 365:
{ yyval = NULL; }
break;
case 366:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 367:
{ yyval = yyvsp[0]; }
break;
case 368:
{ yyval = make_node (nod_mod_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 369:
{ yyval = make_node (nod_mod_relation, (int) e_alt_count, 
						yyvsp[-1], make_list (yyvsp[0])); }
break;
case 370:
{ yyval = yyvsp[0]; }
break;
case 371:
{ yyval = yyvsp[0]; }
break;
case 372:
{ yyval = make_node (nod_mod_database, (int) e_adb_count,
				make_list (yyvsp[0])); }
break;
case 373:
{ yyval = make_node (nod_mod_domain, (int) e_alt_count,
                                          yyvsp[-1], make_list (yyvsp[0])); }
break;
case 374:
{ yyval = make_node (nod_mod_index, 
				     (int) e_mod_idx_count, yyvsp[0]); }
break;
case 375:
{ yyval = yyvsp[0]; }
break;
case 376:
{ yyval = make_node (nod_def_constraint, 
				  (int) e_cnstr_count, MAKE_string (NULL_STRING, 0), NULL, 
				  NULL, NULL, yyvsp[-2], NULL, yyvsp[0], NULL, NULL); }
break;
case 378:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 379:
{ yyval = make_node (nod_def_default, (int) e_dft_count,
					    yyvsp[-1], yyvsp[0]); }
break;
case 380:
{ yyval = yyvsp[0]; }
break;
case 381:
{ yyval = yyvsp[0]; }
break;
case 382:
{yyval = make_node (nod_del_default, (int) 0, NULL); }
break;
case 383:
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, NULL); }
break;
case 384:
{ yyval = yyvsp[0]; }
break;
case 385:
{ yyval = make_node (nod_mod_domain_type, 2, yyvsp[-1]); }
break;
case 387:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 388:
{ yyval = make_node (nod_del_field, 2, yyvsp[-1], yyvsp[0]); }
break;
case 389:
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, yyvsp[0]);}
break;
case 390:
{ yyval = yyvsp[0]; }
break;
case 391:
{ yyval = yyvsp[0]; }
break;
case 392:
{ yyval = make_node (nod_mod_field_pos, 2, yyvsp[-2],
				MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG)); }
break;
case 393:
{ yyval = make_node (nod_mod_field_name, 2, yyvsp[-2], yyvsp[0]); }
break;
case 394:
{ yyval = make_node (nod_mod_field_type, 3, yyvsp[-3], yyvsp[0], yyvsp[-1]); }
break;
case 395:
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 418:
{ yyval = NULL; }
break;
case 419:
{ yyval = NULL; }
break;
case 420:
{ yyval = NULL; }
break;
case 421:
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
                                        	    yyvsp[-1], NULL, NULL, NULL, NULL); }
break;
case 422:
{ g_field_name = yyvsp[0];
			  g_field = make_field (yyvsp[0]);
			  yyval = (NOD) g_field; }
break;
case 423:
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 424:
{ yyval = make_node (nod_cascade, 0, NULL); }
break;
case 425:
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 426:
{ yyval = make_node (nod_idx_active, 1, yyvsp[-1]); }
break;
case 427:
{ yyval = make_node (nod_idx_inactive, 1, yyvsp[-1]); }
break;
case 428:
{ log_defined = FALSE;
			  cache_defined = FALSE;
			  yyval = (NOD) NULL; }
break;
case 430:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 431:
{ yyval = yyvsp[0]; }
break;
case 432:
{ yyval = make_node (nod_drop_log, (int) 0, NULL); }
break;
case 433:
{ yyval = yyvsp[0]; }
break;
case 434:
{ yyval = yyvsp[0]; }
break;
case 436:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 437:
{ yyval = make_node (nod_mod_trigger, (int) e_trg_count,
				yyvsp[-6], NULL, yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0], NULL); }
break;
case 439:
{ yyval = NULL; }
break;
case 441:
{ yyval = NULL; }
break;
case 442:
{ yyval = yyvsp[0]; }
break;
case 443:
{ yyval = make_node (nod_del_exception, 1, yyvsp[0]); }
break;
case 444:
{ yyval = make_node (nod_del_index, (int) 1, yyvsp[0]); }
break;
case 445:
{ yyval = make_node (nod_del_procedure, (int) 1, yyvsp[0]); }
break;
case 446:
{ yyval = make_node (nod_del_relation, (int) 1, yyvsp[0]); }
break;
case 447:
{ yyval = make_node (nod_del_trigger, (int) 1, yyvsp[0]); }
break;
case 448:
{ yyval = make_node (nod_del_view, (int) 1, yyvsp[0]); }
break;
case 449:
{ yyval = make_node (nod_del_filter, (int) 1, yyvsp[0]); }
break;
case 450:
{ yyval = make_node (nod_del_domain, (int) 1, yyvsp[0]); }
break;
case 451:
{ yyval = make_node (nod_del_udf, (int) 1, yyvsp[0]); }
break;
case 452:
{ yyval = make_node (nod_del_shadow, (int) 1, yyvsp[0]); }
break;
case 453:
{ yyval = make_node (nod_del_role, (int) 1, yyvsp[0]); }
break;
case 454:
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 459:
{ g_field->fld_ranges = make_list (yyvsp[-1]);
		      g_field->fld_dimensions = g_field->fld_ranges->nod_count / 2;
		      g_field->fld_element_dtype = g_field->fld_dtype;
		      yyval = yyvsp[-3]; }
break;
case 460:
{ g_field->fld_ranges = make_list (yyvsp[-2]);
		      g_field->fld_dimensions = g_field->fld_ranges->nod_count / 2;
		      g_field->fld_element_dtype = g_field->fld_dtype;
		      yyval = yyvsp[-4]; }
break;
case 462:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 463:
{ if ((SLONG) yyvsp[0] < 1)
		     		yyval = make_node (nod_list, (int) 2, 
					MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG), 
					MAKE_constant ((STR) 1, CONSTANT_SLONG)); 
		          else
		     		yyval = make_node (nod_list, (int) 2, 
			   		MAKE_constant ((STR) 1, CONSTANT_SLONG), 
					MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG) ); }
break;
case 464:
{ yyval = make_node (nod_list, (int) 2, 
			 	MAKE_constant ((STR) yyvsp[-2], CONSTANT_SLONG),
				MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG)); }
break;
case 470:
{ 
			g_field->fld_dtype = dtype_long; 
			g_field->fld_length = sizeof (SLONG); 
			}
break;
case 471:
{ 
			g_field->fld_dtype = dtype_short; 
			g_field->fld_length = sizeof (SSHORT); 
			}
break;
case 472:
{ 
			*stmt_ambiguous = TRUE;
			if (client_dialect <= SQL_DIALECT_V5)
			    {
			    /* Post warning saying that DATE is equivalent to TIMESTAMP */
		            ERRD_post_warning (isc_sqlwarn, gds_arg_number, (SLONG) 301, 
                                               isc_arg_warning, isc_dtype_renamed, 0);
			    g_field->fld_dtype = dtype_timestamp; 
			    g_field->fld_length = sizeof (GDS_TIMESTAMP);
			    }
			else if (client_dialect == SQL_DIALECT_V6_TRANSITION)
			    yyabandon (-104, isc_transitional_date);
			else
			    {
			    g_field->fld_dtype = dtype_sql_date; 
			    g_field->fld_length = sizeof (ULONG);
			    }
			}
break;
case 473:
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_dialect_datatype_unsupport,
				    gds_arg_number, client_dialect,
				    gds_arg_string, "TIME",
				    0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_db_dialect_dtype_unsupport,
				    gds_arg_number, db_dialect,
				    gds_arg_string, "TIME",
				    0);
			g_field->fld_dtype = dtype_sql_time; 
			g_field->fld_length = sizeof (SLONG);
			}
break;
case 474:
{ 
			g_field->fld_dtype = dtype_timestamp; 
			g_field->fld_length = sizeof (GDS_TIMESTAMP);
			}
break;
case 477:
{ 
			g_field->fld_dtype = dtype_blob; 
			}
break;
case 478:
{ 
			g_field->fld_dtype = dtype_blob; 
			g_field->fld_seg_length = (SLONG) yyvsp[-1];
			g_field->fld_sub_type = 0;
			}
break;
case 479:
{ 
			g_field->fld_dtype = dtype_blob; 
			g_field->fld_seg_length = (SLONG) yyvsp[-3];
			g_field->fld_sub_type = (SLONG) yyvsp[-1];
			}
break;
case 480:
{ 
			g_field->fld_dtype = dtype_blob; 
			g_field->fld_seg_length = 80;
			g_field->fld_sub_type = (SLONG) yyvsp[-1];
			}
break;
case 481:
{
			g_field->fld_seg_length = (SLONG) yyvsp[0];
		  	}
break;
case 482:
{
			g_field->fld_seg_length = (SLONG) 80;
		  	}
break;
case 483:
{
			g_field->fld_sub_type = (SLONG) yyvsp[0];
			}
break;
case 484:
{
			g_field->fld_sub_type_name = yyvsp[0];
			}
break;
case 485:
{
			g_field->fld_sub_type = (SLONG) 0;
			}
break;
case 486:
{
			g_field->fld_character_set = yyvsp[0];
			}
break;
case 488:
{ 
			g_field->fld_dtype = dtype_text; 
			g_field->fld_character_length = (SLONG) yyvsp[-1]; 
			g_field->fld_flags |= FLD_national;
			}
break;
case 489:
{ 
			g_field->fld_dtype = dtype_text; 
			g_field->fld_character_length = 1; 
			g_field->fld_flags |= FLD_national;
			}
break;
case 490:
{ 
			g_field->fld_dtype = dtype_varying; 
			g_field->fld_character_length = (SLONG) yyvsp[-1]; 
			g_field->fld_flags |= FLD_national;
			}
break;
case 491:
{ 
			g_field->fld_dtype = dtype_text; 
			g_field->fld_character_length = (SLONG) yyvsp[-1]; 
			}
break;
case 492:
{ 
			g_field->fld_dtype = dtype_text; 
			g_field->fld_character_length = 1; 
			}
break;
case 493:
{ 
			g_field->fld_dtype = dtype_varying; 
			g_field->fld_character_length = (SLONG) yyvsp[-1]; 
			}
break;
case 502:
{ 
			  g_field->fld_sub_type = dsc_num_type_numeric;
			}
break;
case 503:
{  
			   g_field->fld_sub_type = dsc_num_type_decimal;
			   if (g_field->fld_dtype == dtype_short)
				{
				g_field->fld_dtype = dtype_long;
				g_field->fld_length = sizeof (SLONG);
				}
			}
break;
case 504:
{ yyval = make_node (nod_position, 1, yyvsp[0]); }
break;
case 505:
{
			g_field->fld_dtype = dtype_long; 
		    	g_field->fld_length = sizeof (SLONG); 
			g_field->fld_precision = 9;
		    	}
break;
case 506:
{         
			if ( ((SLONG) yyvsp[-1] < 1) || ((SLONG) yyvsp[-1] > 18) )
			    yyabandon (-842, isc_precision_err);
				/* Precision most be between 1 and 18. */ 
			if ((SLONG) yyvsp[-1] > 9)
			    {
			    if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect     >  SQL_DIALECT_V5) ) ||
				 ( (client_dialect >  SQL_DIALECT_V5) &&
				   (db_dialect     <= SQL_DIALECT_V5) ) )
			        ERRD_post (gds__sqlerr,
					   gds_arg_number, (SLONG) -817,
					   gds_arg_gds,
					   isc_ddl_not_allowed_by_db_sql_dial,
					   gds_arg_number, (SLONG) db_dialect,
					   0);
			    if (client_dialect <= SQL_DIALECT_V5)
			        {
				g_field->fld_dtype = dtype_double;
				g_field->fld_length = sizeof (double);
			        }
			    else
			        {
				if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				    {
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous,
					gds_arg_end );
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous1,
					gds_arg_end );
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous2,
					gds_arg_end );

				    }
				g_field->fld_dtype = dtype_int64;
				g_field->fld_length = sizeof (SINT64);
			        }
			    }
			else 
			    if ((SLONG) yyvsp[-1] < 5)
			    	{
			    	g_field->fld_dtype = dtype_short; 
			    	g_field->fld_length = sizeof (SSHORT); 
			    	}
			    else
			    	{
			    	g_field->fld_dtype = dtype_long; 
			    	g_field->fld_length = sizeof (SLONG); 
			    	}
			g_field->fld_precision = (SLONG) yyvsp[-1];
			}
break;
case 507:
{ 
			if ( ((SLONG) yyvsp[-3] < 1) || ((SLONG) yyvsp[-3] > 18) )
			    yyabandon (-842, isc_precision_err);
				/* Precision should be between 1 and 18 */ 
			if (((SLONG) yyvsp[-1] > (SLONG) yyvsp[-3]) || ((SLONG) yyvsp[-1] < 0))
			    yyabandon (-842, isc_scale_nogt);
				/* Scale must be between 0 and precision */
			if ((SLONG) yyvsp[-3] > 9)
			    {
			    if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect     >  SQL_DIALECT_V5) ) ||
				 ( (client_dialect >  SQL_DIALECT_V5) &&
				   (db_dialect     <= SQL_DIALECT_V5) ) )
			        ERRD_post (gds__sqlerr,
					   gds_arg_number, (SLONG) -817,
					   gds_arg_gds,
					   isc_ddl_not_allowed_by_db_sql_dial,
					   gds_arg_number, (SLONG) db_dialect,
					   0);
			    if (client_dialect <= SQL_DIALECT_V5)
			        {
				g_field->fld_dtype = dtype_double;
				g_field->fld_length = sizeof (double); 
			        }
			    else
			        {
				if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				  {
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous,
					gds_arg_end );
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous1,
					gds_arg_end );
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous2,
					gds_arg_end );
				  }
				  /* client_dialect >= SQL_DIALECT_V6 */
				g_field->fld_dtype = dtype_int64;
				g_field->fld_length = sizeof (SINT64);
			        }
			    }
			else
			    {
			    if ((SLONG) yyvsp[-3] < 5)
			    	{
			    	g_field->fld_dtype = dtype_short; 
			    	g_field->fld_length = sizeof (SSHORT); 
			    	}
			    else
			    	{
			    	g_field->fld_dtype = dtype_long; 
			    	g_field->fld_length = sizeof (SLONG); 
			    	}
			    }
			g_field->fld_precision = (SLONG) yyvsp[-3];
			g_field->fld_scale = - (SLONG) yyvsp[-1];
			}
break;
case 510:
{ 
			if ((SLONG) yyvsp[0] > 7)
			    {
			    g_field->fld_dtype = dtype_double;
			    g_field->fld_length = sizeof (double); 
			    }
			else
			    {
			    g_field->fld_dtype = dtype_real; 
			    g_field->fld_length = sizeof (float);
			    }
			}
break;
case 511:
{ 
			g_field->fld_dtype = dtype_double; 
			g_field->fld_length = sizeof (double); 
			}
break;
case 512:
{ 
			g_field->fld_dtype = dtype_real; 
			g_field->fld_length = sizeof (float); 
			}
break;
case 513:
{ 
			g_field->fld_dtype = dtype_double; 
			g_field->fld_length = sizeof (double); 
			}
break;
case 514:
{ yyval = yyvsp[-1]; }
break;
case 515:
{ yyval = 0; }
break;
case 519:
{ 
			  yyval = make_node (nod_set_generator2,e_gen_id_count,yyvsp[-2],
						MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG));
			}
break;
case 520:
{
			  yyval = make_node (nod_set_generator2,e_gen_id_count,yyvsp[-2],
				       MAKE_constant((STR)yyvsp[0], CONSTANT_SINT64));
			}
break;
case 521:
{
			  yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
					  make_node(nod_negate, 1,
						    MAKE_constant((STR)yyvsp[0], CONSTANT_SINT64)));
			}
break;
case 522:
{ yyval = make_node (nod_commit, 1, yyvsp[0]); }
break;
case 523:
{ yyval = make_node (nod_rollback, 0, NULL); }
break;
case 526:
{ yyval = make_node (nod_commit_retain, 0, NULL); }
break;
case 527:
{ yyval = (NOD) NULL; }
break;
case 529:
{ yyval = (NOD) NULL; }
break;
case 530:
{yyval = make_node (nod_trans, 1, make_list (yyvsp[0])); }
break;
case 532:
{ yyval = (NOD) NULL; }
break;
case 534:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 539:
{ yyval = make_flag_node (nod_access, NOD_READ_ONLY, (int) 0, NULL); }
break;
case 540:
{ yyval = make_flag_node (nod_access, NOD_READ_WRITE, (int) 0, NULL); }
break;
case 541:
{ yyval = make_flag_node (nod_wait, NOD_WAIT, (int) 0, NULL); }
break;
case 542:
{ yyval = make_flag_node (nod_wait, NOD_NO_WAIT, (int) 0, NULL); }
break;
case 543:
{ yyval = yyvsp[0];}
break;
case 545:
{ yyval = yyvsp[0];}
break;
case 546:
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 547:
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 548:
{ yyval = make_flag_node (nod_isolation, NOD_CONCURRENCY, 0, NULL); }
break;
case 549:
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 550:
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 551:
{ yyval = make_flag_node (nod_version, NOD_VERSION, 0, NULL); }
break;
case 552:
{ yyval = make_flag_node (nod_version, NOD_NO_VERSION, 0, NULL); }
break;
case 553:
{ yyval = 0; }
break;
case 554:
{ yyval = make_node (nod_reserve, 1, make_list (yyvsp[0])); }
break;
case 555:
{ yyval = (NOD) NOD_SHARED; }
break;
case 556:
{ yyval = (NOD) NOD_PROTECTED ; }
break;
case 557:
{ yyval = (NOD) 0; }
break;
case 558:
{ yyval = (NOD) NOD_READ; }
break;
case 559:
{ yyval = (NOD) NOD_WRITE; }
break;
case 561:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 562:
{ yyval = make_node (nod_table_lock, (int) 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 563:
{ yyval = make_flag_node (nod_lock_mode, ((SSHORT) yyvsp[-1] | (SSHORT) yyvsp[0]), 0, NULL); }
break;
case 564:
{ yyval = 0; }
break;
case 566:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 567:
{yyval = make_node (nod_set_statistics, 
				(int)e_stat_count, yyvsp[0]); }
break;
case 568:
{ yyval = make_node (nod_select, 3, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 569:
{ yyval = make_node (nod_list, 1, yyvsp[0]); }
break;
case 570:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 571:
{ yyval = make_flag_node (nod_list, NOD_UNION_ALL, 2, yyvsp[-3], yyvsp[0]); }
break;
case 572:
{ yyval = make_list (yyvsp[0]); }
break;
case 573:
{ yyval = 0; }
break;
case 575:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 576:
{ yyval = make_node (nod_order, e_order_count, yyvsp[-2], yyvsp[0], yyvsp[-1]); }
break;
case 577:
{ yyval = make_node (nod_order, e_order_count, yyvsp[-2], yyvsp[0], yyvsp[-1]); }
break;
case 578:
{ yyval = 0; }
break;
case 579:
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 580:
{ yyval = 0; }
break;
case 581:
{ yyval = yyvsp[0]; }
break;
case 582:
{ yyval = 0; }
break;
case 583:
{ yyval = yyvsp[0]; }
break;
case 584:
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 585:
{ yyval = make_node (nod_select_expr, e_sel_count, 
					yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 586:
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 587:
{ yyval = 0; }
break;
case 588:
{ yyval = make_list (yyvsp[0]); }
break;
case 589:
{ yyval = 0; }
break;
case 591:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 593:
{ yyval = make_node (nod_alias, 2, yyvsp[-1], yyvsp[0]); }
break;
case 594:
{ yyval = make_node (nod_alias, 2, yyvsp[-2], yyvsp[0]); }
break;
case 595:
{ yyval = make_list (yyvsp[0]); }
break;
case 597:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 600:
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-5], yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 601:
{ yyval = yyvsp[-1]; }
break;
case 602:
{ yyval = make_node (nod_rel_proc_name, 
					(int) e_rpn_count, yyvsp[-2], yyvsp[0], yyvsp[-1]); }
break;
case 603:
{ yyval = make_node (nod_rel_proc_name, 
					(int) e_rpn_count, yyvsp[-1], NULL, yyvsp[0]); }
break;
case 604:
{ yyval = make_list (yyvsp[-1]); }
break;
case 605:
{ yyval = NULL; }
break;
case 607:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 611:
{ yyval = make_node (nod_relation_name, 
						(int) e_rln_count, yyvsp[-1], yyvsp[0]); }
break;
case 612:
{ yyval = make_node (nod_relation_name, 
						(int) e_rln_count, yyvsp[0], NULL); }
break;
case 613:
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 614:
{ yyval = make_node (nod_join_left, (int) 0, NULL); }
break;
case 615:
{ yyval = make_node (nod_join_left, (int) 0, NULL); }
break;
case 616:
{ yyval = make_node (nod_join_right, (int) 0, NULL); }
break;
case 617:
{ yyval = make_node (nod_join_right, (int) 0, NULL); }
break;
case 618:
{ yyval = make_node (nod_join_full, (int) 0, NULL); }
break;
case 619:
{ yyval = make_node (nod_join_full, (int) 0, NULL); }
break;
case 620:
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 621:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 622:
{ yyval = yyvsp[-1]; }
break;
case 623:
{ yyval = yyvsp[0]; }
break;
case 624:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 625:
{ yyval = yyvsp[-1]; }
break;
case 626:
{ yyval = yyvsp[0]; }
break;
case 627:
{ yyval = make_node (nod_limit, e_limit_count, yyvsp[0], yyvsp[-1]); }
break;
case 628:
{ yyval = make_node (nod_limit, e_limit_count, NULL, yyvsp[0]); }
break;
case 629:
{ yyval = make_node (nod_limit, e_limit_count, yyvsp[0], NULL); }
break;
case 630:
{ yyval = 0; }
break;
case 631:
{ yyval = make_list (yyvsp[0]); }
break;
case 632:
{ yyval = 0; }
break;
case 634:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 637:
{ yyval = make_node (nod_collate, e_coll_count, (NOD) yyvsp[0], yyvsp[-2]); }
break;
case 638:
{ yyval = yyvsp[0]; }
break;
case 639:
{ yyval = 0; }
break;
case 640:
{ yyval = yyvsp[0]; }
break;
case 641:
{ yyval = 0; }
break;
case 642:
{ yyval = yyvsp[0]; }
break;
case 643:
{ yyval = 0; }
break;
case 644:
{ yyval = make_node (nod_plan_expr, 2, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 645:
{ yyval = 0; }
break;
case 646:
{ yyval = make_node (nod_merge, (int) 0, NULL); }
break;
case 647:
{ yyval = make_node (nod_merge, (int) 0, NULL); }
break;
case 648:
{ yyval = 0; }
break;
case 649:
{ yyval = 0; }
break;
case 651:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 652:
{ yyval = make_node (nod_plan_item, 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 655:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 656:
{ yyval = make_node (nod_natural, (int) 0, NULL); }
break;
case 657:
{ yyval = make_node (nod_index, 1, make_list (yyvsp[-1])); }
break;
case 658:
{ yyval = make_node (nod_index_order, 1, yyvsp[0]); }
break;
case 660:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 661:
{ yyval = make_node (nod_insert, e_ins_count, 
			  yyvsp[-5], make_list (yyvsp[-4]), make_list (yyvsp[-1]), NULL); }
break;
case 662:
{ yyval = make_node (nod_insert, e_ins_count, yyvsp[-2], yyvsp[-1], NULL, yyvsp[0]); }
break;
case 664:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 667:
{ yyval = make_node (nod_delete, e_del_count, yyvsp[-1], yyvsp[0], NULL); }
break;
case 668:
{ yyval = make_node (nod_delete, e_del_count, yyvsp[-1], NULL, yyvsp[0]); }
break;
case 669:
{ yyval = make_node (nod_cursor, e_cur_count, yyvsp[0], NULL, NULL); }
break;
case 672:
{ yyval = make_node (nod_update, e_upd_count, 
				yyvsp[-3], make_list (yyvsp[-1]), yyvsp[0], NULL); }
break;
case 673:
{ yyval = make_node (nod_update, e_upd_count,
			  	yyvsp[-3], make_list (yyvsp[-1]), NULL, yyvsp[0]); }
break;
case 675:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 676:
{ yyval = make_node (nod_assign, 2, yyvsp[0], yyvsp[-2]); }
break;
case 679:
{ yyval = make_node (nod_get_segment, e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 680:
{ yyval = make_node (nod_put_segment, e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 681:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 682:
{ yyval = make_node (nod_list, 2, NULL, yyvsp[0]); }
break;
case 686:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 687:
{ yyval = yyvsp[0]; }
break;
case 689:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 692:
{ yyval = NULL; }
break;
case 693:
{ yyval = make_list (yyvsp[-1]); }
break;
case 695:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 697:
{ yyval = NULL; }
break;
case 698:
{ yyval = make_list (yyvsp[-1]); }
break;
case 700:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 702:
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], yyvsp[0]); }
break;
case 703:
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], NULL); }
break;
case 704:
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 706:
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], yyvsp[0]); }
break;
case 708:
{ yyval = make_node (nod_or, 2, yyvsp[-2], yyvsp[0]); }
break;
case 709:
{ yyval = make_node (nod_and, 2, yyvsp[-2], yyvsp[0]); }
break;
case 710:
{ yyval = make_node (nod_not, 1, yyvsp[0]); }
break;
case 721:
{ yyval = yyvsp[-1]; }
break;
case 722:
{ yyval = make_node (nod_eql, 2, yyvsp[-2], yyvsp[0]); }
break;
case 723:
{ yyval = make_node (nod_lss, 2, yyvsp[-2], yyvsp[0]); }
break;
case 724:
{ yyval = make_node (nod_gtr, 2, yyvsp[-2], yyvsp[0]); }
break;
case 725:
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 726:
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 727:
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 728:
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 729:
{ yyval = make_node (nod_neq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 730:
{ yyval = make_node (nod_eql_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 731:
{ yyval = make_node (nod_lss_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 732:
{ yyval = make_node (nod_gtr_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 733:
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 734:
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 735:
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 736:
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 737:
{ yyval = make_node (nod_neq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 738:
{ yyval = make_node (nod_eql_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 739:
{ yyval = make_node (nod_lss_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 740:
{ yyval = make_node (nod_gtr_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 741:
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 742:
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 743:
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 744:
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 745:
{ yyval = make_node (nod_neq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 748:
{ yyval = make_node (nod_between, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 749:
{ yyval = make_node (nod_not, 1, make_node (nod_between, 
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 750:
{ yyval = make_node (nod_like, 2, yyvsp[-2], yyvsp[0]); }
break;
case 751:
{ yyval = make_node (nod_not, 1, make_node (nod_like, 2, yyvsp[-3], yyvsp[0])); }
break;
case 752:
{ yyval = make_node (nod_like, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 753:
{ yyval = make_node (nod_not, 1, make_node (nod_like, 
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 754:
{ yyval = make_node (nod_eql_any, 2, yyvsp[-2], yyvsp[0]); }
break;
case 755:
{ yyval = make_node (nod_not, 1, make_node (nod_eql_any, 2, yyvsp[-3], yyvsp[0])); }
break;
case 756:
{ yyval = make_node (nod_containing, 2, yyvsp[-2], yyvsp[0]); }
break;
case 757:
{ yyval = make_node (nod_not, 1, make_node (nod_containing, 2, yyvsp[-3], yyvsp[0])); }
break;
case 758:
{ yyval = make_node (nod_starting, 2, yyvsp[-2], yyvsp[0]); }
break;
case 759:
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-3], yyvsp[0])); }
break;
case 760:
{ yyval = make_node (nod_starting, 2, yyvsp[-3], yyvsp[0]); }
break;
case 761:
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-4], yyvsp[0])); }
break;
case 762:
{ yyval = make_node (nod_exists, 1, yyvsp[-1]); }
break;
case 763:
{ yyval = make_node (nod_singular, 1, yyvsp[-1]); }
break;
case 764:
{ yyval = make_node (nod_missing, 1, yyvsp[-2]); }
break;
case 765:
{ yyval = make_node (nod_not, 1, make_node (nod_missing, 1, yyvsp[-3])); }
break;
case 766:
{ yyval = make_list (yyvsp[-1]); }
break;
case 767:
{ yyval = yyvsp[-1]; }
break;
case 768:
{ yyval = make_node (nod_select_expr, e_sel_count, 
				yyvsp[-7], yyvsp[-6], make_list(yyvsp[-5]), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 769:
{ yyval = make_node (nod_select_expr, e_sel_count, 
		 		yyvsp[-7], yyvsp[-6], make_list(yyvsp[-5]), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0],
				MAKE_constant ((STR) 1, CONSTANT_SLONG)); }
break;
case 777:
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 778:
{ yyval = yyvsp[0]; }
break;
case 779:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_add2, 2, yyvsp[-2], yyvsp[0]);
			  else
			      yyval = make_node (nod_add, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 780:
{ yyval = make_node (nod_concatenate, 2, yyvsp[-2], yyvsp[0]); }
break;
case 781:
{ yyval = make_node (nod_collate, e_coll_count, (NOD) yyvsp[0], yyvsp[-2]); }
break;
case 782:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_subtract2, 2, yyvsp[-2], yyvsp[0]);
			  else 
			      yyval = make_node (nod_subtract, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 783:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			       yyval = make_node (nod_multiply2, 2, yyvsp[-2], yyvsp[0]);
			  else
			       yyval = make_node (nod_multiply, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 784:
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_divide2, 2, yyvsp[-2], yyvsp[0]);
			  else
			      yyval = make_node (nod_divide, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 785:
{ yyval = yyvsp[-1]; }
break;
case 786:
{ yyval = yyvsp[-1]; }
break;
case 789:
{ yyval = make_node (nod_dbkey, 1, NULL); }
break;
case 790:
{ yyval = make_node (nod_dbkey, 1, yyvsp[-2]); }
break;
case 791:
{ 
			  yyval = make_node (nod_dom_value, 0, NULL);
                        }
break;
case 792:
{ yyval = yyvsp[0]; }
break;
case 793:
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_dialect_datatype_unsupport,
				    gds_arg_number, client_dialect,
				    gds_arg_string, "DATE",
				    0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_db_dialect_dtype_unsupport,
				    gds_arg_number, db_dialect,
				    gds_arg_string, "DATE",
				    0);
			yyval = make_node (nod_current_date, 0, NULL);
			}
break;
case 794:
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_dialect_datatype_unsupport,
				    gds_arg_number, client_dialect,
				    gds_arg_string, "TIME",
				    0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_db_dialect_dtype_unsupport,
				    gds_arg_number, db_dialect,
				    gds_arg_string, "TIME",
				    0);
			yyval = make_node (nod_current_time, 0, NULL);
			}
break;
case 795:
{ yyval = make_node (nod_current_timestamp, 0, NULL); }
break;
case 796:
{ yyval = make_node (nod_array, 2, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 798:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 800:
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 801:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_STRING); }
break;
case 802:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 803:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_DOUBLE); }
break;
case 804:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SINT64); }
break;
case 805:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SINT64); }
break;
case 807:
{ yyval = MAKE_str_constant ((STR) yyvsp[0], att_charset); }
break;
case 808:
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_dialect_datatype_unsupport,
				    gds_arg_number, client_dialect,
				    gds_arg_string, "DATE",
				    0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_db_dialect_dtype_unsupport,
				    gds_arg_number, db_dialect,
				    gds_arg_string, "DATE",
				    0);
			yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_DATE);
			}
break;
case 809:
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_dialect_datatype_unsupport,
				    gds_arg_number, client_dialect,
				    gds_arg_string, "TIME",
				    0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_db_dialect_dtype_unsupport,
				    gds_arg_number, db_dialect,
				    gds_arg_string, "TIME",
				    0);
			yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_TIME); 
			}
break;
case 810:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_TIMESTAMP); }
break;
case 815:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 816:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 817:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 818:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 819:
{ yyval = make_node (nod_parameter, 0, NULL); }
break;
case 820:
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 821:
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 822:
{ yyval = make_node (nod_current_role, 0, NULL); }
break;
case 823:
{ yyval = yyvsp[0]; }
break;
case 824:
{ ((STR) yyvsp[0])->str_charset = (TEXT *) yyvsp[-1];
			  yyval = yyvsp[0]; }
break;
case 826:
{ yyval = (NOD) - (SLONG) yyvsp[0]; }
break;
case 827:
{ if ((SLONG) yyvsp[0] > SHRT_POS_MAX)
			    yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 828:
{ if ((SLONG) yyvsp[0] > SHRT_NEG_MAX)
			    yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 829:
{ if ((SLONG) yyvsp[0] == 0)
			    yyabandon (-842, isc_expec_positive);
				/* Positive number expected */
			  yyval = yyvsp[0];}
break;
case 830:
{ if ((SLONG) yyvsp[0] > SHRT_UNSIGNED_MAX)
			    yyabandon (-842, isc_expec_ushort);
				/* Unsigned short integer expected */
			  yyval = yyvsp[0];}
break;
case 832:
{ yyval = (NOD) - (SLONG) yyvsp[0]; }
break;
case 833:
{ yyval = yyvsp[0];}
break;
case 834:
{ yyval = make_node (nod_agg_count, 0, NULL); }
break;
case 835:
{ yyval = make_node (nod_agg_count, 1, yyvsp[-1]); }
break;
case 836:
{ yyval = make_flag_node (nod_agg_count,
                                       NOD_AGG_DISTINCT, 1, yyvsp[-1]); }
break;
case 837:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_agg_total2, 1, yyvsp[-1]);
			  else
			      yyval = make_node (nod_agg_total, 1, yyvsp[-1]);
			}
break;
case 838:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_flag_node (nod_agg_total2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
			      yyval = make_flag_node (nod_agg_total,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 839:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_agg_average2, 1, yyvsp[-1]);
			  else
			      yyval = make_node (nod_agg_average, 1, yyvsp[-1]);
			}
break;
case 840:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_flag_node (nod_agg_average2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
			      yyval = make_flag_node (nod_agg_average,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 841:
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 842:
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 843:
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 844:
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 845:
{ yyval = make_node (nod_cast, e_cast_count, yyvsp[-1], yyvsp[-3]); }
break;
case 846:
{ yyval = make_node (nod_upcase, 1, yyvsp[-1]); }
break;
case 847:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_gen_id2, 2, yyvsp[-3], yyvsp[-1]);
			  else
			      yyval = make_node (nod_gen_id, 2, yyvsp[-3], yyvsp[-1]);
			}
break;
case 848:
{ yyval = make_node (nod_extract, e_extract_count, yyvsp[-3], yyvsp[-1]); }
break;
case 849:
{ yyval = make_node (nod_substr, e_substr_count, yyvsp[-3],
				MAKE_constant ((STR) ((SLONG)(yyvsp[-1]) - 1), CONSTANT_SLONG),
				MAKE_constant ((STR) SHRT_POS_MAX, CONSTANT_SLONG)); }
break;
case 850:
{ yyval = make_node (nod_substr, e_substr_count, yyvsp[-5],
				MAKE_constant ((STR) ((SLONG)(yyvsp[-3]) - 1), CONSTANT_SLONG),
				MAKE_constant ((STR) (yyvsp[-1]), CONSTANT_SLONG)); }
break;
case 851:
{ yyval = make_node (nod_udf, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 852:
{ yyval = make_node (nod_udf, 1, yyvsp[-2]); }
break;
case 853:
{ yyval = MAKE_constant (blr_extract_year, CONSTANT_SLONG); }
break;
case 854:
{ yyval = MAKE_constant (blr_extract_month, CONSTANT_SLONG); }
break;
case 855:
{ yyval = MAKE_constant (blr_extract_day, CONSTANT_SLONG); }
break;
case 856:
{ yyval = MAKE_constant (blr_extract_hour, CONSTANT_SLONG); }
break;
case 857:
{ yyval = MAKE_constant (blr_extract_minute, CONSTANT_SLONG); }
break;
case 858:
{ yyval = MAKE_constant (blr_extract_second, CONSTANT_SLONG); }
break;
case 859:
{ yyval = MAKE_constant (blr_extract_weekday, CONSTANT_SLONG); }
break;
case 860:
{ yyval = MAKE_constant (blr_extract_yearday, CONSTANT_SLONG); }
break;
case 863:
{ yyval = make_node (nod_null, 0, NULL); }
break;
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (DSQL_yychar < 0)
        {
            if ((DSQL_yychar = yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous)) < 0) DSQL_yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (DSQL_yychar <= YYMAXTOKEN) yys = yyname[DSQL_yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, DSQL_yychar, yys);
            }
#endif
        }
        if (DSQL_yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
